# 1 "cfx.c"
# 1 "cfx.h" 1






















 
 
 
 
 
 
 
 
 
 
typedef struct Item
{
    int                 kind;
    int                 fileAttributed;
    int                 subjectFile;
    int                 subjectLine;
    int                 objectFile;
    int                 objectLine;
    char                *scopeName;
    char                *itemName;
    struct Item         *next;
} Item, *CFX_Item;


 
extern int      cfx_oneFileOption;
extern int      cfx_allFactsOption;
extern int      cfx_noMrOption;
extern int      cfx_noHrOption;
extern int      cfx_noMinOption;
extern int      cfx_noIfcOption;
extern int      cfx_directOption;

 
extern int      cfx_mode;
extern int      cfx_allFacts;
extern char     cfx_macroStartMarker [];
extern char     cfx_macroEndMarker [];
extern char     cfx_macroStartToken [];
extern char     cfx_macroEndToken [];

 
extern int      cfx_suppressMacroMarker;

 
extern char     *cfx_baseName;
extern char     *cfx_cppName;
extern int      cfx_macroStartTokenLen;

 
extern char    *Cfx_CanonPath( );

 
extern void     Cfx_Initialize ();
extern void     Cfx_Finalize ();
extern void     Cfx_CreateFileName ();

 
extern void     Cfx_CppInitialize ( 


);
extern void     Cfx_CppFinalize ( );
extern int      Cfx_AddFile ( );
extern void     Cfx_FileUsage ( );
extern void     Cfx_MacroDefinition ( 


);
extern void     Cfx_MacroUsage ( 
);
extern int      Cfx_IsIdentChar ();

 
extern void     Cfx_Cc1Initialize ( 



);
extern void     Cfx_Cc1Finalize ( );
extern int      Cfx_GetFileNumber ( );
extern void     Cfx_PushMacroStack ( );
extern void     Cfx_PopMacroStack ( );
extern void     Cfx_EnumItemDefinition ( 


);
extern void     Cfx_EnumTagDefinition ( 


);
extern void     Cfx_FcnDeclaration ( 



);
extern CFX_Item Cfx_GlobalFcnDefinition ( 



);
extern void     Cfx_GlobalVarDefinition ( 



);
extern void     Cfx_Import ( 




);

extern void     Cfx_Import_2 ( 





);      

extern void     Cfx_StructOrUnionDefinition ( 



);
extern void     Cfx_TypeDefinition ( 


);
extern void     Cfx_VarDeclaration ( 


);
extern void     Cfx_ImportSomething ( );

extern void	Cfx_EnumTagDefinitionEnd ( 


);	 
 
extern void	Cfx_StructOrUnionDefinitionEnd ( 



);  








extern void	Cfx_GlobalFcnDefinitionEnd ( 

);        



# 1 "cfx.c" 2

# 1 "../include/cfx-internal.h" 1
enum kindOfRelation
{ EXPORT_PUBLIC_FCN_DEF,     
  EXPORT_PUBLIC_VAR_DEF,     

	 

  EXPORT_STATIC_FCN_DEF,     
  EXPORT_STATIC_VAR_DEF,     
  EXPORT_PUBLIC_FCN_DECL,    
  EXPORT_PUBLIC_VAR_DECL,    
  EXPORT_STATIC_FCN_DECL,    
  EXPORT_MACRO,		     
  EXPORT_TYPE,		     
  EXPORT_ENUM_TAG,	     
  EXPORT_ENUM_ITEM,	     
  EXPORT_STRUCT,	     
  EXPORT_UNION,		     

  IMPORT_EXPORT_DIVIDER,

  INCLUDE_FILE,		     
  IMPORT_IMPLEMENT_PUBLIC_FCN,	     
  IMPORT_IMPLEMENT_PUBLIC_VAR,	     
  IMPORT_IMPLEMENT_STATIC_FCN,	     
  IMPORT_IMPLEMENT_STATIC_VAR,	     
  IMPORT_PUBLIC_FCN_DEF,     
  IMPORT_PUBLIC_FCN_REF,     
  IMPORT_PUBLIC_VAR_DEF,     
  IMPORT_PUBLIC_FCN_DECL,    
  IMPORT_PUBLIC_VAR_DECL,    
  IMPORT_STATIC_FCN_DEF,     
  IMPORT_STATIC_FCN_REF,     
  IMPORT_STATIC_VAR_DEF,     
  IMPORT_LINK_FCN,	     
  IMPORT_LINK_FCN_REF,	     
  IMPORT_LINK_VAR,	     
  IMPORT_EXTERN_FCN,	     
  IMPORT_EXTERN_FCN_REF,     
  IMPORT_EXTERN_VAR,	     
  IMPORT_CODE_AND_VARS,	     
  IMPORT_MACRO,		     
  IMPORT_TYPE,		     
  IMPORT_ENUM_TAG,	     
  IMPORT_ENUM_ITEM,	     
  IMPORT_STRUCT,	     
  IMPORT_UNION,		     

   

  EXPORT_PUBLIC_FCN_DEF_END,     
  EXPORT_STATIC_FCN_DEF_END,     
  EXPORT_ENUM_TAG_END,             
  EXPORT_STRUCT_END,                 
  EXPORT_UNION_END,                   

  IMPORT_FCN_REF_TEMP,
  IMPORT_VAR_REF_TEMP,
  IMPORT_LINK_FCN_TEMP,
  IMPORT_LINK_VAR_TEMP,

  NO_KIND
};

# 2 "cfx.c" 2


# 1 "/usr/include/stdio.h" 1 3
 
 

 
 
 

 






#pragma ident	"@(#)stdio.h	1.39	95/12/04 SMI"	

# 1 "/usr/include/sys/feature_tests.h" 1 3
 
 

 
 
 




#pragma ident	"@(#)feature_tests.h	1.7	94/12/06 SMI"





 
















# 17 "/usr/include/stdio.h" 2 3

# 1 "/usr/include/sys/va_list.h" 1 3
 







#pragma ident	"@(#)va_list.h	1.6	96/01/26 SMI"

 













# 41 "/usr/include/sys/va_list.h" 3



typedef void *__va_list;











# 18 "/usr/include/stdio.h" 2 3








typedef unsigned int	size_t;


typedef long	fpos_t;







 










 



















# 76 "/usr/include/stdio.h" 3




















































typedef struct	 
{




	int		_cnt;	 
	unsigned char	*_ptr;	 

	unsigned char	*_base;	 
	unsigned char	_flag;	 
	unsigned char	_file;	 
} FILE;


extern FILE		__iob[20 ];



extern FILE		*_lastbuf;
extern unsigned char	*_bufendtab[];

extern unsigned char	 _sibuf[], _sobuf[];




extern int	remove(const char *);
extern int	rename(const char *, const char *);
extern FILE	*tmpfile(void);
extern char	*tmpnam(char *);



extern int	fclose(FILE *);
extern int	fflush(FILE *);
extern FILE	*fopen(const char *, const char *);
extern FILE	*freopen(const char *, const char *, FILE *);
extern void	setbuf(FILE *, char *);
extern int	setvbuf(FILE *, char *, int, size_t);
 
extern int	fprintf(FILE *, const char *, ...);
 
extern int	fscanf(FILE *, const char *, ...);
 
extern int	printf(const char *, ...);
 
extern int	scanf(const char *, ...);
 
extern int	sprintf(char *, const char *, ...);
 
extern int	sscanf(const char *, const char *, ...);
extern int	vfprintf(FILE *, const char *, __va_list);
extern int	vprintf(const char *, __va_list);
extern int	vsprintf(char *, const char *, __va_list);
extern int	fgetc(FILE *);
extern char	*fgets(char *, int, FILE *);
extern int	fputc(int, FILE *);
extern int	fputs(const char *, FILE *);
extern int	getc(FILE *);
extern int	getchar(void);
extern char	*gets(char *);
extern int	putc(int, FILE *);
extern int	putchar(int);
extern int	puts(const char *);
extern int	ungetc(int, FILE *);
extern size_t	fread(void *, size_t, size_t, FILE *);
extern size_t	fwrite(const void *, size_t, size_t, FILE *);
extern int	fgetpos(FILE *, fpos_t *);
extern int	fseek(FILE *, long, int);
extern int	fsetpos(FILE *, const fpos_t *);
extern long	ftell(FILE *);
extern void	rewind(FILE *);
extern void	clearerr(FILE *);
extern int	feof(FILE *);
extern int	ferror(FILE *);
extern void	perror(const char *);

extern int	__filbuf(FILE *);
extern int	__flsbuf(int, FILE *);

 











 


# 234 "/usr/include/stdio.h" 3


 


# 254 "/usr/include/stdio.h" 3


# 338 "/usr/include/stdio.h" 3


 
































# 392 "/usr/include/stdio.h" 3









# 4 "cfx.c" 2

# 1 "/usr/include/string.h" 1 3
 
 

 
 
 




#pragma ident	"@(#)string.h	1.17	95/08/28 SMI"	


















extern void *memcpy(void *, const void *, size_t);
extern void *memmove(void *, const void *, size_t);
extern char *strcpy(char *, const char *);
extern char *strncpy(char *, const char *, size_t);

extern char *strcat(char *, const char *);
extern char *strncat(char *, const char *, size_t);

extern int memcmp(const void *, const void *, size_t);
extern int strcmp(const char *, const char *);
extern int strcoll(const char *, const char *);
extern int strncmp(const char *, const char *, size_t);
extern size_t strxfrm(char *, const char *, size_t);

extern void *memchr(const void *, int, size_t);
extern char *strchr(const char *, int);
extern size_t strcspn(const char *, const char *);
extern char *strpbrk(const char *, const char *);
extern char *strrchr(const char *, int);
extern size_t strspn(const char *, const char *);
extern char *strstr(const char *, const char *);
extern char *strtok(char *, const char *);




extern void *memset(void *, int, size_t);
extern char *strerror(int);
extern size_t strlen(const char *);








# 76 "/usr/include/string.h" 3


# 119 "/usr/include/string.h" 3







# 5 "cfx.c" 2

# 1 "/usr/include/malloc.h" 1 3
 
 

 
 
 




#pragma ident	"@(#)malloc.h	1.8	92/07/14 SMI"	





 





				 

				 
 


struct mallinfo  {
	int arena;	 
	int ordblks;	 
	int smblks;	 
	int hblks;	 
	int hblkhd;	 
	int usmblks;	 
	int fsmblks;	 
	int uordblks;	 
	int fordblks;	 
	int keepcost;	 
};








void *malloc(size_t);
void free(void *);
void *realloc(void *, size_t);
int mallopt(int, int);
struct mallinfo mallinfo(void);
void *calloc(size_t, size_t);

# 65 "/usr/include/malloc.h" 3







# 6 "cfx.c" 2

# 1 "/usr/include/sys/types.h" 1 3
 
 

 
 
 




#pragma ident	"@(#)types.h	1.38	95/11/14 SMI"


# 1 "/usr/include/sys/isa_defs.h" 1 3
 






#pragma ident	"@(#)isa_defs.h	1.7	94/10/26 SMI"

 

















































































































 






# 211 "/usr/include/sys/isa_defs.h" 3


 






 



















 







 











# 14 "/usr/include/sys/types.h" 2 3


 


# 1 "/usr/include/sys/machtypes.h" 1 3
 
 

 
 
 




#pragma ident	"@(#)machtypes.h	1.9	94/11/05 SMI"







 








typedef struct  _physadr_t { int r[1]; } *physadr_t;

typedef	struct	_label_t { int	val[2]; } label_t;



typedef	unsigned char	lock_t;		 






# 19 "/usr/include/sys/types.h" 2 3






 

typedef	unsigned char	uchar_t;
typedef	unsigned short	ushort_t;
typedef	unsigned int	uint_t;
typedef	unsigned long	ulong_t;

typedef	char *		caddr_t;	 
typedef	long		daddr_t;	 
typedef	long		off_t;		 
typedef	short		cnt_t;		 

typedef	ulong_t		paddr_t;	 
typedef	uchar_t		use_t;		 
typedef	short		sysid_t;
typedef	short		index_t;




typedef enum { B_FALSE, B_TRUE } boolean_t;


 








 
typedef union {
	double	_d;
	long	_l[2];
} longlong_t;
typedef union {
	double		_d;
	unsigned long	_l[2];
} u_longlong_t;





typedef	longlong_t	offset_t;
typedef	longlong_t	diskaddr_t;

 





# 88 "/usr/include/sys/types.h" 3



typedef union {
	offset_t	_f;	 
	struct {
		long _u;	 
		off_t _l;	 
	} _p;
} lloff_t;


# 108 "/usr/include/sys/types.h" 3



typedef union {
	diskaddr_t	_f;	 
	struct {
		long _u;	 
		daddr_t _l;	 
	} _p;
} lldaddr_t;


typedef ulong_t k_fltset_t;	 

 







typedef long		id_t;		 
					 
					 
					 
					 


 

typedef ulong_t	major_t;	 
typedef ulong_t	minor_t;	 


 

typedef short	pri_t;

 










typedef	ushort_t o_mode_t;		 
typedef short	o_dev_t;		 
typedef	ushort_t o_uid_t;		 
typedef	o_uid_t	o_gid_t;		 
typedef	short	o_nlink_t;		 
typedef short	o_pid_t;		 
typedef ushort_t o_ino_t;		 


 

typedef	int	key_t;			 
typedef	ulong_t	mode_t;			 



typedef	long	uid_t;			 


typedef	uid_t	gid_t;			 
typedef	ulong_t nlink_t;		 
typedef ulong_t	dev_t;			 
typedef ulong_t	ino_t;			 
typedef long	pid_t;			 








typedef int	ssize_t;	 
				 




typedef	long		time_t;	 




typedef	long		clock_t;  




typedef	int	clockid_t;	 




typedef	int	timer_t;	 





typedef	unsigned char	unchar;
typedef	unsigned short	ushort;
typedef	unsigned int	uint;
typedef	unsigned long	ulong;

# 234 "/usr/include/sys/types.h" 3





 












 




typedef	long	hostid_t;

 







typedef unsigned char	u_char;
typedef unsigned short	u_short;
typedef unsigned int	u_int;
typedef unsigned long	u_long;
typedef struct _quad { long val[2]; } quad;	 


 



# 1 "/usr/include/sys/select.h" 1 3
 
 

 
 
 




#pragma ident	"@(#)select.h	1.10	92/07/14 SMI"	


# 1 "/usr/include/sys/time.h" 1 3
 
 

 
 
 

 





 







#pragma ident	"@(#)time.h	2.47	95/08/24 SMI"	



 












struct timeval {
	long	tv_sec;		 
	long	tv_usec;	 
};

struct timezone {
	int	tz_minuteswest;	 
	int	tz_dsttime;	 
};








 




# 1 "/usr/include/sys/types.h" 1 3
 
 

 
 
 

# 302 "/usr/include/sys/types.h" 3

# 61 "/usr/include/sys/time.h" 2 3






















 














 









struct	itimerval {
	struct	timeval it_interval;	 
	struct	timeval it_value;	 
};


 

















 

















 






typedef struct  timespec {		 
	time_t		tv_sec;		 
	long		tv_nsec;	 
} timespec_t;

typedef struct timespec timestruc_t;	 

# 172 "/usr/include/sys/time.h" 3


 









 




typedef struct itimerspec {		 
	struct timespec	it_interval;	 
	struct timespec	it_value;	 
} itimerspec_t;


 


typedef	longlong_t	hrtime_t;

# 236 "/usr/include/sys/time.h" 3





int adjtime(struct timeval *, struct timeval *);
int getitimer(int, struct itimerval *);
int setitimer(int, const struct itimerval *, struct itimerval *);

 

















int gettimeofday(struct timeval *, void *);
int settimeofday(struct timeval *, void *);


hrtime_t	gethrtime(void);
hrtime_t	gethrvtime(void);
# 278 "/usr/include/sys/time.h" 3


# 1 "/usr/include/time.h" 1 3
 
 
 



 
 
 




#pragma ident	"@(#)time.h	1.23	95/08/28 SMI"	


































struct	tm {	 
	int	tm_sec;
	int	tm_min;
	int	tm_hour;
	int	tm_mday;
	int	tm_mon;
	int	tm_year;
	int	tm_wday;
	int	tm_yday;
	int	tm_isdst;
};



extern clock_t clock(void);
extern double difftime(time_t, time_t);
extern time_t mktime(struct tm *);
extern time_t time(time_t *);
extern char *asctime(const struct tm *);
extern char *ctime(const time_t *);
extern struct tm *gmtime(const time_t *);
extern struct tm *localtime(const time_t *);
extern size_t strftime(char *, size_t, const char *, const struct tm *);













# 103 "/usr/include/time.h" 3


# 123 "/usr/include/time.h" 3


# 138 "/usr/include/time.h" 3


# 171 "/usr/include/time.h" 3


 


# 249 "/usr/include/time.h" 3







# 280 "/usr/include/sys/time.h" 2 3











# 14 "/usr/include/sys/select.h" 2 3







 













typedef	long	fd_mask;





typedef	struct fd_set {
	fd_mask	fds_bits[((( 1024  )+((  (sizeof (fd_mask) * 8 )  )-1))/(  (sizeof (fd_mask) * 8 )  )) ];
} fd_set;


















extern int select(int, fd_set *, fd_set *, fd_set *, struct timeval *);










# 278 "/usr/include/sys/types.h" 2 3




 












 







# 7 "cfx.c" 2





























# 44 "cfx.c"

enum {NONE, CPP, CC1, IFC, HR, MR};

 
int     cfx_oneFileOption = 0;
int     cfx_allFactsOption = 0;
int     cfx_noMrOption = 0;
int     cfx_noHrOption = 0;
int     cfx_noMinOption = 0;
int     cfx_noIfcOption = 0;
int     cfx_directOption = 0;

 
int     cfx_mode = 0;
int     cfx_allFacts = 0;
char    cfx_macroStartMarker [] = " __MS__";
char    cfx_macroEndMarker [] = " __ME__ ";
char    cfx_macroStartToken [] = "__MS__";
char    cfx_macroEndToken [] = "__ME__";

 
int     cfx_suppressMacroMarker = 0;

 
char    *cfx_baseName =  __MS__5 0  __ME__ ;
char    *cfx_cppName =  __MS__5 0  __ME__ ;
int     cfx_macroStartTokenLen = 6;

 
int     cfx_externalFileNumber;

static FILE     *interface =  __MS__5 0  __ME__ ;
static FILE     *srcFile =  __MS__5 0  __ME__ ;

typedef struct File
{
    char        *fileName;
    char        *shortFileName;
    int         mainFile;
    struct File *next;
} File;

typedef struct Files
{
    char        *fileName;
    char        *shortFileName;
    int         comparisonValue;
    int         mainFile;
    int         interfaceFileWritten;
} Files;

typedef struct MacroStack
{
    int                 fileNumber;
    struct MacroStack   *next;
} MacroStack;

 
static void     AddToInterface ();
static int      CheckReadable ();
static int      CheckWriteable ();
static int      CompareItems ();
static Item     **ConvertDataLLToTableAndSort ();
static void     ConvertFileLLToTable ();
static void     CorrelateLinkRefsAndDefs ();
static void     CorrelateRefsDefsAndDecls ();
static int      CountElementsInDataLL ();
static Item     *CreateNewItem ();
static void     FileReadError ();
static char     *GetFileNameForRead ();
static char     *GetFileNameForWrite ();
static void     InitializeFile ();
static void     MallocString ();
static void     MallocStringLen ();
static void     ReadAndVerifyHeader ();
static void     ReadFileListIntoTable ();
static void     ReadMRDataIntoDataLL ();
static void     SkipAn ();
static void     SkipComments ();
static void     Cfx_AssertFailed ();
static int      SortByName ();
static char     *TimeString ();
static void     WriteFileListFromFileLL ();
static void     WriteFileListFromFileTable ();
static int      WriteHRDataFromDataTable ();
static void     WriteHRExport ();
static void     WriteHRImport ();
static void     WriteMRDataFromDataLL ();
static void     WriteMRDataFromDataLL_gerry ();    
static int      WriteMRDataFromDataTable ();

 
static int      noMrOption, noHrOption, noMinOption;     
static int      allFactsOption, oneFileOption;           
static int      dirAttribOption;                         
static int      noIfcOption;                             
static Item     *mainHead =  __MS__5 0  __ME__ ;
static Item     *masterHead =  __MS__5 0  __ME__ ;

static MacroStack       *stackHead =  __MS__5 0  __ME__ ;

static File     *fileHead =  __MS__5 0  __ME__ ;

static char     *emptyString = "";
static char     *cppInfoFileName;
static char     *cc1InfoFileName;

static int      numFiles;
static Files    *fileTable;

static int      currentFileNumber = -1;

static char     *mrInfoFile, *hrInfoFile, *minInfoFile;

# 459 "cfx.c"



# 563 "cfx.c"



# 1106 "cfx.c"


 
 
 
 
 
 
 
int     Cfx_AddFile (fileName, shortName, len, angle_brackets)
    char *fileName, *shortName;
    int len, angle_brackets;
{
    File        *ptr = fileHead, *lastPtr =  __MS__5 0  __ME__ , *newFile;
    int         fileNo = 0;

    fileName = (char *) Cfx_CanonPath(fileName);                         

     
    while (ptr !=  __MS__5 0  __ME__ )
    {
        fileNo++;
        if (strcmp (ptr->fileName, fileName) == 0)
        {
            if (len == -1)
            {
                ptr->mainFile = 0;
            }
             
            return (fileNo);
        }
        lastPtr = ptr;
        ptr = ptr->next;
    }

     
    newFile = (File *) malloc (sizeof (File));
    if (newFile ==  __MS__5 0  __ME__ )
    {
        fprintf ( __MS__5 (&__iob[2])  __ME__ , "[3] No memory for File \"%s\".\n", fileName);
        exit (103);
    }

    if ((len == -1) || (len == -2))
    {
        newFile->fileName = fileName;
        newFile->shortFileName = shortName;
        if (len == -1)
        {
            newFile->mainFile = 0;
        }
        else
        {
            newFile->mainFile = 1;
        }
    }
    else
    {
        MallocString (&(newFile->fileName), fileName);
        if (shortName ==  __MS__5 0  __ME__ )
        {
            newFile->shortFileName = newFile->fileName;
        }
        else
        {
            newFile->shortFileName = (char *) malloc (len + 3);
            if (angle_brackets)
            {
                newFile->shortFileName [0] = '<';
                strncpy (&newFile->shortFileName [1], shortName, len);
                newFile->shortFileName [len + 1] = 0;
                strcat (newFile->shortFileName, ">");
            }
            else
            {
                strncpy (newFile->shortFileName, shortName, len);
                newFile->shortFileName [len] = 0;
            }
        }
    }
        
    newFile->next =  __MS__5 0  __ME__ ;
    if (lastPtr ==  __MS__5 0  __ME__ )
    {
        fileHead = newFile;
    }
    else
    {
        lastPtr->next = newFile;
    }
    return (fileNo + 1);
}  


 
 
 
 
 
 
 

void    Cfx_CreateFileName (fileName, finalFileName, purpose)
    char        *fileName, *finalFileName;
    int         purpose;
{
    char        *ptr, *ptr1;

    if (strncmp (fileName, ".cfx." , 
                 strlen (".cfx." )) == 0)
    {
        strcpy (finalFileName, fileName);
        return;
    }

    if (strrchr (fileName, '/') ==  __MS__5 0  __ME__ )
    {
        if (purpose == IFC)
        {
            finalFileName [0] = 0;
        }
        else
        {
            strcpy (finalFileName, ".cfx." );
        }

        if (purpose == CPP) strcat (finalFileName, "cpp." );
        else if (purpose == CC1) strcat (finalFileName, "cc1." );
             else if (purpose == IFC) strcat (finalFileName, ".ifc." );

        strcat (finalFileName, fileName);
    }
    else
    {
        strcpy (finalFileName, fileName);
        ptr = strrchr (finalFileName, '/') + 1;
        *ptr = 0;

        if (purpose != IFC)
        {
            strcpy (ptr, ".cfx." );
        }

        if (purpose == CPP) strcat (finalFileName, "cpp." );
        else if (purpose == CC1) strcat (finalFileName, "cc1." );
             else if (purpose == IFC) strcat (finalFileName, ".ifc." );

        ptr = strrchr (fileName, '/') + 1;
        strcat (finalFileName, ptr);
    }

    ptr = finalFileName;
}  


 
 
 
 
 
 
 
 
void Cfx_Import (importType, fileAttributed, fileUsingItem, 
                  fileDefiningItem, lineDefiningItem, itemName)
    int         importType;
    int         fileAttributed;
    int         fileUsingItem;
    int         fileDefiningItem;
    int         lineDefiningItem;
    char        *itemName;
{
    Item        *newItem;

    newItem = CreateNewItem (fileAttributed, fileUsingItem, -1, importType, "*** Undefined Item ***" );
    newItem->objectFile = fileDefiningItem;
    newItem->objectLine = lineDefiningItem;
    MallocString (&(newItem->itemName), itemName);
}  


 
 
 
 
 
 
 
 
 
void Cfx_Import_2 (importType, fileAttributed, fileUsingItem, 
                  fileDefiningItem, lineDefiningItem, itemName, scopeName )
    int         importType;
    int         fileAttributed;
    int         fileUsingItem;
    int         fileDefiningItem;
    int         lineDefiningItem;
    char        *itemName;
    char        *scopeName;
{
    Item        *newItem;

    newItem = CreateNewItem (fileAttributed, fileUsingItem, -1, importType,scopeName, "*** Undefined Item ***" );
    newItem->objectFile = fileDefiningItem;
    newItem->objectLine = lineDefiningItem;
 
    MallocString (&(newItem->itemName), itemName);


}  




 
 
 
# 1570 "cfx.c"



 
 
 
static int      CheckReadable (fileName)
    char *fileName;
{
    FILE        *f;

    f = fopen (fileName, "r");
    if (f ==  __MS__5 0  __ME__ )
    {
        return (0);
    }

    return (1);
}  


 
 
 
static int      CheckWriteable (fileName)
    char *fileName;
{
    FILE        *f;

    f = fopen (fileName, "w");
    if (f !=  __MS__5 0  __ME__ )
    {
        if (unlink (fileName) != 0)
        {
            fprintf ( __MS__5 (&__iob[2])  __ME__ , 
        "[12] Having created CFX info file \"%s\",it could not be deleted!\n", 
                     fileName);
            exit (112);
        }
        return (1);
    }
    return (0);
}  


 
 
 
static int      CompareItems (first, second)
    Item        **first, **second;
{
    int         comp;
    
    comp = (*first)->fileAttributed - (*second)->fileAttributed;
    if (comp != 0) return (comp);

    comp = (*first)->objectFile - (*second)->objectFile;
    if (comp != 0) return (comp);

    comp = (*first)->kind - (*second)->kind;
    if (comp != 0) return (comp);

    comp = strcmp ((*first)->itemName, (*second)->itemName);
    if (comp != 0) return (comp);

    comp = (*first)->subjectFile - (*second)->subjectFile;
    if (comp != 0) return (comp);

    return ((*first)->subjectLine - (*second)->subjectLine);
}  


 
 
 
 
 
static Item     **ConvertDataLLToTableAndSort (listHead, numElements, 
                                               comparisonFunction)
    Item        *listHead;
    int         *numElements;
    int         (*comparisonFunction)();
{
    int         i, src, dest;
    Item        *ptr = listHead, **base;

    *numElements = 0;
    while (ptr !=  __MS__5 0  __ME__ )
    {
        if (ptr->kind < IMPORT_FCN_REF_TEMP)
        {
            (*numElements)++;
        }
        ptr = ptr->next;
    }

    base = (Item **) malloc ((*numElements + 1) * sizeof (Item *));
    if (base ==  __MS__5 0  __ME__ )
    {
        fprintf ( __MS__5 (&__iob[2])  __ME__ , "[13] No memory to allocate base\n");
        exit (113);
    }

    ptr = listHead;
    i = 0;
    while (ptr !=  __MS__5 0  __ME__ )
    {
        if (ptr->kind < IMPORT_FCN_REF_TEMP)
        {
            base [i] = ptr;
            i++;
        }
        ptr = ptr->next;
    }

    qsort (base, *numElements, sizeof (Item *), comparisonFunction);

     
    src = 1;
    dest = 1;
    while (src < *numElements)
    {
        while ((( base [src] ->objectLine ==   base [dest - 1] ->objectLine) && ( base [src] ->subjectLine ==   base [dest - 1] ->subjectLine) && ( base [src] ->objectFile ==   base [dest - 1] ->objectFile) && ( base [src] ->subjectFile ==   base [dest - 1] ->subjectFile) && ( base [src] ->fileAttributed ==   base [dest - 1] ->fileAttributed) && ( base [src] ->kind ==   base [dest - 1] ->kind) && (strcmp ( base [src] ->scopeName,   base [dest - 1] ->scopeName) == 0) && (strcmp ( base [src] ->itemName,   base [dest - 1] ->itemName) == 0)) )
        {
            src++;
        }
        if (dest != src)
        {
            base [dest++] = base [src++];
        }
        else
        {
            src++;
            dest++;
        }
    }

    fprintf ( __MS__5 (&__iob[2])  __ME__ , "%d duplicate elements removed\n", *numElements - dest);

    *numElements = dest;
        
     
    base [*numElements] = CreateNewItem (-1, -1, -1, NO_KIND, "*** Undefined Item ***" );

    return (base);
}  


 
 
 
 
 
 
static void     ConvertFileLLToTable ()
{
    int         i;
    File        *ptr = fileHead, *next;

    numFiles = 0;
    while (ptr !=  __MS__5 0  __ME__ )
    {
        numFiles++;
        ptr = ptr->next;
    }

    fileTable = (Files *) malloc ((numFiles + 1) * sizeof (Files));
    if (fileTable ==  __MS__5 0  __ME__ )
    {
        fprintf ( __MS__5 (&__iob[2])  __ME__ , "[14] No memory for file table.\n");
        exit (114);
    }

    ptr = fileHead;
    for (i = 1 ; i <= numFiles ; i++)
    {
        fileTable [i].fileName = ptr->fileName;
        fileTable [i].shortFileName = ptr->shortFileName;
        fileTable [i].mainFile = ptr->mainFile;
        next = ptr->next;
        free (ptr);
        ptr = next;
    }
    fileHead =  __MS__5 0  __ME__ ;

     
     
     
    fileTable [0].fileName = "(No File)";
    fileTable [0].shortFileName = "(No File)";
    fileTable [0].comparisonValue = 0;
    fileTable [0].mainFile = 0;
}  


 
 
 
static void     CorrelateLinkRefsAndDefs (listHead)
    Item        *listHead;
{
    int         counts [NO_KIND];
    int         numItems;
    Item        *ptr = listHead;
    Item        **refBase, **defBase;
    int         ref = 0, def = 0, refPtr, defPtr;
    char        *name;
    int         kind;

    (void) CountElementsInDataLL (listHead, counts);

     
    numItems = counts [IMPORT_LINK_FCN_TEMP] + 
               counts [IMPORT_LINK_VAR_TEMP] + 1;
    refBase = (Item **) malloc (numItems * sizeof (Item *));
    if (refBase ==  __MS__5 0  __ME__ )
    {
        fprintf ( __MS__5 (&__iob[2])  __ME__ , "[15] No memory to allocate link refBase\n");
        exit (115);
    }

     
    numItems = counts [EXPORT_PUBLIC_FCN_DEF] + 
               counts [EXPORT_PUBLIC_VAR_DEF] + 1;
    defBase = (Item **) malloc (numItems * sizeof (Item *));
    if (defBase ==  __MS__5 0  __ME__ )
    {
        fprintf ( __MS__5 (&__iob[2])  __ME__ , "[16] No memory to allocate defBase\n");
        exit (116);
    }

    while (ptr !=  __MS__5 0  __ME__ )
    {
        switch (ptr->kind)
        {
            case IMPORT_LINK_FCN_TEMP:
            case IMPORT_LINK_VAR_TEMP:
                refBase [ref++] = ptr;
                break;
            case EXPORT_PUBLIC_FCN_DEF:
            case EXPORT_PUBLIC_VAR_DEF:
                defBase [def++] = ptr;
                break;
            default:
                break;
        }
        ptr = ptr->next;
    }

    qsort (refBase, ref, sizeof (Item *), SortByName);
    qsort (defBase, def, sizeof (Item *), SortByName);

     
    refBase [ref] = CreateNewItem (-1, -1, -1, NO_KIND, "*** Undefined Item ***" );
    refBase [ref]->itemName = "\377";
    defBase [def] = CreateNewItem (-1, -1, -1, NO_KIND, "*** Undefined Item ***" );
    defBase [def]->itemName = "\377";

     
     
     
    defPtr = 0;
    for (refPtr = 0 ; refPtr < ref ; refPtr++)
    {
        name = refBase [refPtr]->itemName;
        while (strcmp (name, defBase [defPtr]->itemName) > 0)
        {
            defPtr++;
        }
        if (strcmp (name, defBase [defPtr]->itemName) == 0)
        {
            if (refBase [refPtr]->fileAttributed != 
                defBase [defPtr]->fileAttributed)
            {
                if (refBase [refPtr]->kind == IMPORT_LINK_FCN_TEMP)
                    kind = IMPORT_LINK_FCN;
                else if (refBase [refPtr]->kind == IMPORT_LINK_VAR_TEMP)
                    kind = IMPORT_LINK_VAR;
                else Cfx_AssertFailed (4);
                ptr = CreateNewItem (refBase [refPtr]->fileAttributed,
                                     refBase [refPtr]->subjectFile,
                                     refBase [refPtr]->subjectLine,
                                     NO_KIND, "*** Undefined Item ***" );
                ptr->kind = kind;
                ptr->objectFile = defBase [defPtr]->subjectFile;
                ptr->objectLine = defBase [defPtr]->subjectLine;
                ptr->itemName = name;
                ptr->next = masterHead;
                masterHead = ptr;
            }
        }
        else
        {
            if (refBase [refPtr]->kind == IMPORT_LINK_FCN_TEMP)
                kind = IMPORT_EXTERN_FCN;
            else if (refBase [refPtr]->kind == IMPORT_LINK_VAR_TEMP)
                kind = IMPORT_EXTERN_VAR;
            else Cfx_AssertFailed (6);
            ptr = CreateNewItem (refBase [refPtr]->fileAttributed,
                                 refBase [refPtr]->subjectFile,
                                 refBase [refPtr]->subjectLine,
                                 NO_KIND, "*** Undefined Item ***" );
            ptr->kind = kind;
            ptr->objectFile = cfx_externalFileNumber;
            ptr->objectLine = -1;
            ptr->itemName = name;
            ptr->next = masterHead;
            masterHead = ptr;
        }
    }
}  


 
 
 
 
 
 
static void     CorrelateRefsDefsAndDecls (listHead)
    Item        *listHead;
{
    int         counts [NO_KIND];
    int         numItems;
    Item        *ptr = listHead;
    Item        **refBase, **defBase, **declBase;
    int         ref = 0, def = 0, decl = 0, refPtr, defPtr, declPtr;
    char        *name;
    int         kind;

    (void) CountElementsInDataLL (listHead, counts);

     
    numItems = counts [IMPORT_FCN_REF_TEMP] + counts [IMPORT_VAR_REF_TEMP] + 1;
    refBase = (Item **) malloc (numItems * sizeof (Item *));
    if (refBase ==  __MS__5 0  __ME__ )
    {
        fprintf ( __MS__5 (&__iob[2])  __ME__ , "[17] No memory to allocate refBase\n");
        exit (117);
    }

     
    numItems = counts [EXPORT_PUBLIC_FCN_DEF] + counts [EXPORT_PUBLIC_VAR_DEF] +
           counts [EXPORT_STATIC_FCN_DEF] + counts [EXPORT_STATIC_VAR_DEF] + 1;
    defBase = (Item **) malloc (numItems * sizeof (Item *));
    if (defBase ==  __MS__5 0  __ME__ )
    {
        fprintf ( __MS__5 (&__iob[2])  __ME__ , "[18] No memory to allocate defBase\n");
        exit (118);
    }

     
    numItems = counts [EXPORT_PUBLIC_FCN_DECL] + 
               counts [EXPORT_PUBLIC_VAR_DECL] +
               counts [EXPORT_STATIC_FCN_DECL] + 1;
    declBase = (Item **) malloc (numItems * sizeof (Item *));
    if (declBase ==  __MS__5 0  __ME__ )
    {
        fprintf ( __MS__5 (&__iob[2])  __ME__ , "[19] No memory to allocate declBase\n");
        exit (119);
    }

    while (ptr !=  __MS__5 0  __ME__ )
    {
        switch (ptr->kind)
        {
            case IMPORT_FCN_REF_TEMP:
            case IMPORT_VAR_REF_TEMP:
                refBase [ref++] = ptr;
                break;
            case EXPORT_PUBLIC_FCN_DEF:
            case EXPORT_PUBLIC_VAR_DEF:
            case EXPORT_STATIC_FCN_DEF:
            case EXPORT_STATIC_VAR_DEF:
                defBase [def++] = ptr;
                break;
            case EXPORT_PUBLIC_FCN_DECL:
            case EXPORT_PUBLIC_VAR_DECL:
            case EXPORT_STATIC_FCN_DECL:
                declBase [decl++] = ptr;
                break;
            default:
                break;
        }
        ptr = ptr->next;
    }

    qsort (refBase, ref, sizeof (Item *), SortByName);
    qsort (defBase, def, sizeof (Item *), SortByName);
    qsort (declBase, decl, sizeof (Item *), SortByName);

     
    refBase [ref] = CreateNewItem (-1, -1, -1, NO_KIND, "*** Undefined Item ***" );
    refBase [ref]->itemName = "\377";
    defBase [def] = CreateNewItem (-1, -1, -1, NO_KIND, "*** Undefined Item ***" );
    defBase [def]->itemName = "\377";
    declBase [decl] = CreateNewItem (-1, -1, -1, NO_KIND, "*** Undefined Item ***" );
    declBase [decl]->itemName = "\377";

     
     
     
    declPtr = 0;
    for (defPtr = 0 ; defPtr < def ; defPtr++)
    {
        name = defBase [defPtr]->itemName;
        while (strcmp (name, declBase [declPtr]->itemName) > 0)
        {
            declPtr++;
        }
        while (strcmp (name, declBase [declPtr]->itemName) == 0)
        {
            
            if (defBase [defPtr]->fileAttributed != 
                declBase [declPtr]->fileAttributed)
            {
                
                if (defBase [defPtr]->kind == EXPORT_PUBLIC_FCN_DEF)
                {
                    kind = IMPORT_IMPLEMENT_PUBLIC_FCN;
                }
                else if (defBase [defPtr]->kind == EXPORT_PUBLIC_VAR_DEF)
                {
                    kind = IMPORT_IMPLEMENT_PUBLIC_VAR;
                }
                else if (defBase [defPtr]->kind == EXPORT_STATIC_FCN_DEF)
                {
                    kind = IMPORT_IMPLEMENT_STATIC_FCN;
                }
                else if (defBase [defPtr]->kind == EXPORT_STATIC_VAR_DEF)
                {
                    kind = IMPORT_IMPLEMENT_STATIC_VAR;
                }
                else Cfx_AssertFailed (3);
                ptr = CreateNewItem (defBase [defPtr]->fileAttributed,
                                     defBase [defPtr]->subjectFile,
                                     defBase [defPtr]->subjectLine,
                                     kind, "*** Undefined Item ***" );
                ptr->objectFile = declBase [declPtr]->subjectFile;
                ptr->objectLine = declBase [declPtr]->subjectLine;
                ptr->itemName = name;
            }
            declPtr++;
        }
    }

     
     
    declPtr = 0;
    defPtr = 0;
    refPtr = 0;
    while (refPtr < ref)
    {
        name = refBase [refPtr]->itemName;

         
        while (strcmp (name, defBase [defPtr]->itemName) > 0)
        {
            defPtr++;
        }
        if (strcmp (name, defBase [defPtr]->itemName) == 0)
        {
            if (refBase [refPtr]->fileAttributed != 
                defBase [defPtr]->fileAttributed)
            {
                
                if (defBase [defPtr]->kind == EXPORT_PUBLIC_FCN_DEF)
                {
                    kind = IMPORT_PUBLIC_FCN_DEF;
                }
                else if (defBase [defPtr]->kind == EXPORT_PUBLIC_VAR_DEF)
                {    
                    kind = IMPORT_PUBLIC_VAR_DEF;
                }
                else if (defBase [defPtr]->kind == EXPORT_STATIC_FCN_DEF)
                {    
                    kind = IMPORT_STATIC_FCN_DEF;
                }
                else if (defBase [defPtr]->kind == EXPORT_STATIC_VAR_DEF)
                {    
                    kind = IMPORT_STATIC_VAR_DEF;
                }
                else Cfx_AssertFailed (2);
                ptr = CreateNewItem (refBase [refPtr]->fileAttributed,
                                     refBase [refPtr]->subjectFile,
                                     refBase [refPtr]->subjectLine,
                                     kind, refBase [refPtr]->scopeName );  
                ptr->objectFile = defBase [defPtr]->subjectFile;
                ptr->objectLine = defBase [defPtr]->subjectLine;
                ptr->itemName = name;
            }
        }
        else
        {
             
            int origDeclPtr;

            while (strcmp (name, declBase [declPtr]->itemName) > 0)
            {
                declPtr++;
            }

            origDeclPtr = declPtr;

            while (strcmp (name, declBase [declPtr]->itemName) == 0)
            {
                if (refBase [refPtr]->fileAttributed != 
                    declBase [declPtr]->fileAttributed)
                {
                     
                    if (declBase [declPtr]->kind == EXPORT_PUBLIC_FCN_DECL)
                        kind = IMPORT_PUBLIC_FCN_DECL;
                    else if (declBase [declPtr]->kind == EXPORT_PUBLIC_VAR_DECL)
                        kind = IMPORT_PUBLIC_VAR_DECL;
                    else Cfx_AssertFailed (1);
                    ptr = CreateNewItem (refBase [refPtr]->fileAttributed,
                                         refBase [refPtr]->subjectFile,
                                         refBase [refPtr]->subjectLine,
                                         kind, "*** Undefined Item ***" );
                    ptr->objectFile = declBase [declPtr]->subjectFile;
                    ptr->objectLine = declBase [declPtr]->subjectLine;
                    ptr->itemName = name;

                }
                declPtr++;
            }

            declPtr = origDeclPtr;

             
            if (refBase [refPtr]->kind == IMPORT_FCN_REF_TEMP)
                kind = IMPORT_LINK_FCN_TEMP;
            else if (refBase [refPtr]->kind == IMPORT_VAR_REF_TEMP)
                kind = IMPORT_LINK_VAR_TEMP;
            ptr = CreateNewItem(refBase [refPtr]->fileAttributed,
                                 refBase [refPtr]->subjectFile,
                                 refBase [refPtr]->subjectLine,
                                 kind, refBase [refPtr]->scopeName );
            ptr->itemName = name;
        }

         
         
        refPtr++;
        while ((( refBase [refPtr] ->objectLine ==   refBase [refPtr - 1] ->objectLine) && ( refBase [refPtr] ->subjectLine ==   refBase [refPtr - 1] ->subjectLine) && ( refBase [refPtr] ->objectFile ==   refBase [refPtr - 1] ->objectFile) && ( refBase [refPtr] ->subjectFile ==   refBase [refPtr - 1] ->subjectFile) && ( refBase [refPtr] ->fileAttributed ==   refBase [refPtr - 1] ->fileAttributed) && ( refBase [refPtr] ->kind ==   refBase [refPtr - 1] ->kind) && (strcmp ( refBase [refPtr] ->scopeName,   refBase [refPtr - 1] ->scopeName) == 0) && (strcmp ( refBase [refPtr] ->itemName,   refBase [refPtr - 1] ->itemName) == 0)) )
        {
            refPtr++;
        }
    }  
}  


 
 
 
 
static int      CountElementsInDataLL (listHead, counts)
    Item        *listHead;
    int         counts [];
{
    int         cnt, total = 0;
    Item        *ptr = listHead;

    for (cnt = 0 ; cnt < NO_KIND ; cnt++) counts [cnt] = 0;

    while (ptr !=  __MS__5 0  __ME__ )
    {
        total++;
        counts [ptr->kind]++;
        ptr = ptr->next;
    }

    return (total);
}  


 
 
 
 
static Item     *CreateNewItem (fileAttributed, subjectFile, subjectLine, kind, scopeName)
    int fileAttributed, subjectFile, subjectLine, kind;
    char *scopeName;
{
    Item        *ptr; 

    ptr = (Item *) malloc (sizeof (Item));
    if (ptr ==  __MS__5 0  __ME__ )
    {
        fprintf ( __MS__5 (&__iob[2])  __ME__ , "[20] No memory for item.\n");
        exit (120);
    }

    ptr->kind = kind;
    ptr->fileAttributed = fileAttributed;
    ptr->subjectFile = subjectFile;
    ptr->subjectLine = subjectLine;
    ptr->objectFile = -1;
    ptr->objectLine = -1;
    ptr->itemName = "*** Undefined Item ***" ;
    ptr->scopeName = scopeName;

    if (kind == NO_KIND)
    {
         
        return (ptr);
    }

    ptr->next = mainHead;
    mainHead = ptr;

    return (ptr);
}  


 
 
 
static void     FileReadError (line)
    char *line;
{
    if (line ==  __MS__5 0  __ME__ )
    {
        fprintf ( __MS__5 (&__iob[2])  __ME__ , "[21a] Error reading file\n");
    }
    else
    {
        fprintf ( __MS__5 (&__iob[2])  __ME__ , "[21b] Error while reading line: \"%s\"\n", line);
    }
    exit (121);
}  


 
 
 
 
 
       
 
 
 
 
 
 
 
static char     *GetFileNameForRead (firstName, secondName, prefix)
    char *firstName, *secondName;
    int prefix;
{
    char        *fileName;

     
     
     
    if ((secondName !=  __MS__5 0  __ME__ ) && (strcmp (secondName, "") != 0) &&
        (strcmp (secondName, "-") != 0))
    {
        fileName = (char *) malloc (strlen (secondName) + 30);
        Cfx_CreateFileName (secondName, fileName, -1);
        if (CheckReadable (fileName))
        {
            return (fileName);
        }
        fprintf ( __MS__5 (&__iob[2])  __ME__ , "[22] Unable to open \"%s\" for read.\n", fileName);
        exit (122);
    }

     
     
     
     
    if ((firstName !=  __MS__5 0  __ME__ ) && (strcmp (firstName, "") != 0) &&
        (strcmp (firstName, "-") != 0))
    {
        char    *ptr;
         
         
         
        fileName = (char *) malloc (strlen (firstName) + 30);
        Cfx_CreateFileName (firstName, fileName, prefix);
        if (CheckReadable (fileName))
        {
            return (fileName);
        }

         
         
         
        if (strrchr (firstName, '/') ==  __MS__5 0  __ME__ )
        {       
            ptr = firstName;
        }
        else
        {
            ptr = strrchr (firstName, '/') + 1;
        }
        Cfx_CreateFileName (ptr, fileName, prefix);
        if (CheckReadable (fileName))
        {
            return (fileName);
        }
        fprintf ( __MS__5 (&__iob[2])  __ME__ , "[23] Unable to open \"%s\" for write.\n", fileName);
        exit (123);
    }

     
    if (prefix == CPP)
    {
        return (".cfx.cpp" );
    }
    else if (prefix == CC1)
    {
        return (".cfx.cc1" );
    }

    fprintf ( __MS__5 (&__iob[2])  __ME__ , "[24] Unrecognized prefix in GetFileNameForRead\n");
    exit (124);
}  


 
 
 
 
 
       
 
 
 
 
 
 
 
static char     *GetFileNameForWrite (firstName, secondName, prefix)
    char *firstName, *secondName;
    int prefix;
{
    char        *fileName;

     
     
     
    if ((secondName !=  __MS__5 0  __ME__ ) && (strcmp (secondName, "") != 0) &&
        (strcmp (secondName, "-") != 0))
    {
         
         
         
        fileName = (char *) malloc (strlen (secondName) + 30);
        Cfx_CreateFileName (secondName, fileName, -1);
        if (CheckWriteable (fileName))
        {
            return (fileName);
        }
        fprintf ( __MS__5 (&__iob[2])  __ME__ , "[25] Unable to open \"%s\" for write.\n", fileName);
        exit (125);
    }

     
     
     
    if ((firstName !=  __MS__5 0  __ME__ ) && (strcmp (firstName, "") != 0) &&
        (strcmp (firstName, "-") != 0))
    {
        char    *ptr;

         
         
         
        fileName = (char *) malloc (strlen (firstName) + 30);
        Cfx_CreateFileName (firstName, fileName, prefix);
        if (CheckWriteable (fileName))
        {
            return (fileName);
        }

         
         
         
        if (strrchr (firstName, '/') ==  __MS__5 0  __ME__ )
        {       
            ptr = firstName;
        }
        else
        {
            ptr = strrchr (firstName, '/') + 1;
        }
        Cfx_CreateFileName (ptr, fileName, prefix);
        if (CheckWriteable (fileName))
        {
            return (fileName);
        }
        fprintf ( __MS__5 (&__iob[2])  __ME__ , "[26] Unable to open \"%s\" for write.\n", fileName);
        exit (126);
    }

     
    if (prefix == CPP)
    {
        return (".cfx.cpp" );
    }
    else if (prefix == CC1)
    {
        return (".cfx.cc1" );
    }

    fprintf ( __MS__5 (&__iob[2])  __ME__ , "[27] Unrecognized prefix in GetFileNameForWrite\n");
    exit (127);
}  


 
 
 
static void     InitializeFile (fileName)
    char *fileName;
{
    FILE        *f;
   
    unlink (fileName);
}  


 
 
 
static void     MallocString (itemToMalloc, str)
    char **itemToMalloc, *str;
{
    *itemToMalloc = (char *) malloc (strlen (str) + 1);
    if (*itemToMalloc ==  __MS__5 0  __ME__ )
    {
        fprintf ( __MS__5 (&__iob[2])  __ME__ , "[28] No memory for string \"%s\".\n", str);
        exit (128);
    }
    strcpy (*itemToMalloc, str);
}  


 
 
 
 
static void     MallocStringLen (itemToMalloc, str, len)
    char        **itemToMalloc, *str;
    int         len;
{
    *itemToMalloc = (char *) malloc (len + 1);
    if (*itemToMalloc ==  __MS__5 0  __ME__ )
    {
        fprintf ( __MS__5 (&__iob[2])  __ME__ , 
                 "[29] No memory to allocate space for string \"%s\".\n", 
                 str);
        exit (129);
    }
    strncpy (*itemToMalloc, str, len);
    (*itemToMalloc) [len] = 0;
}  


 
 
 
static void     ReadAndVerifyHeader (f, fileName, header)
    FILE *f;
    char *fileName, *header;
{
    char        line [1024];

    if (fgets (line, 1024, f) ==  __MS__5 0  __ME__ ) FileReadError ( __MS__5 0  __ME__ );
    if (strncmp (line, header, strlen (header) - 6))
    {
        fprintf ( __MS__5 (&__iob[2])  __ME__ , "[30] %s did not have expected header!\n", fileName);
        fprintf ( __MS__5 (&__iob[2])  __ME__ , "Actually read: \"%s\"\n", line);
        fprintf ( __MS__5 (&__iob[2])  __ME__ , "Should be:     \"%s\"\n", header);
        exit (130);
    }
}  


 
 
 
static void     ReadFileListIntoTable (f)
    FILE *f;
{
    char        line [1024];
    int         i;

     
     
     
    SkipComments (f);

     
     
     
    if (fgets (line, 1024, f) ==  __MS__5 0  __ME__ ) FileReadError ( __MS__5 0  __ME__ );
    if (sscanf (line, "%d", &numFiles) != 1) FileReadError (line);

     
     
     
    fileTable = (Files *) malloc ((numFiles + 1) * sizeof (Files));
    if (fileTable ==  __MS__5 0  __ME__ )
    {
        fprintf ( __MS__5 (&__iob[2])  __ME__ , "[31] No memory for file table.\n");
        exit (131);
    }
    for (i = 1 ; i <= numFiles ; i++)
    {
        if (fgets (line, 1024, f) ==  __MS__5 0  __ME__ ) FileReadError ( __MS__5 0  __ME__ );
        line [strlen (line) - 1] = 0;    
        MallocString (&(fileTable [i].fileName), line);

        if (fgets (line, 1024, f) ==  __MS__5 0  __ME__ ) FileReadError ( __MS__5 0  __ME__ );
        line [strlen (line) - 1] = 0;    
        MallocString (&(fileTable [i].shortFileName), line);
    }

     
     
     
    fileTable [0].fileName = "(No File)";
    fileTable [0].shortFileName = "(No File)";
    fileTable [0].comparisonValue = 0;
    fileTable [0].mainFile = 0;
    fileTable [0].interfaceFileWritten = 0;
}  


 
 
 
static void     ReadMRDataIntoDataLL (f)
    FILE *f;
{
    char        line [1024];
    int         i, numElements;
    int         kind, fileAttributed, subjectFile, subjectLine;
    int         objectFile, objectLine;
    char        itemName [1024];

     
     
     
    SkipComments (f);

     
     
     
    if (fgets (line, 1024, f) ==  __MS__5 0  __ME__ ) FileReadError ( __MS__5 0  __ME__ );
    if (sscanf (line, "%d", &numElements) != 1) FileReadError (line);

     
     
     
    for (i = 0 ; i < numElements ; i++)
    {
        Item    *newItem;

        if (fgets (line, 1024, f) ==  __MS__5 0  __ME__ ) FileReadError ( __MS__5 0  __ME__ );
        if (sscanf (line, " %4d %4d %4d %6d %4d %6d %s\n", &kind, 
                    &fileAttributed, &subjectFile, &subjectLine, &objectFile, 
                    &objectLine, itemName) != 7)
        {
            FileReadError (line);
        }
        newItem = CreateNewItem (fileAttributed, subjectFile, subjectLine, 
                                 kind, "*** Undefined Item ***" );
        newItem->objectFile = objectFile;
        newItem->objectLine = objectLine;
        MallocString (&(newItem->itemName), itemName);
    }
}  


 
 
 
static void     SkipAn (base, ptr, type, initialFile)
    Item        **base;
    int         *ptr, type, initialFile;
{
    while ((base [*ptr]->kind == type) &&
           (base [*ptr]->fileAttributed == initialFile))
    {
        (*ptr)++;
    }
}  


 
 
 
static void     SkipComments (f)
    FILE *f;
{
    int         pos;
    char        line [1026];
    
    do
    {
        pos = ftell (f);
        if (fgets (line, 1024, f) ==  __MS__5 0  __ME__ )
        {
            FileReadError ( __MS__5 0  __ME__ );
        }
    }
    while (line [0] == '#');
    fseek (f, pos, 0);
}  


 
 
 
static void     Cfx_AssertFailed (error)
    int error;
{
    fprintf ( __MS__5 (&__iob[2])  __ME__ , "Assertion Failure #%d\n", error);
    exit (200 + error);
}  


 
 
 
static int      SortByName (first, second)
    Item        **first, **second;
{
    return (strcmp ((*first)->itemName, (*second)->itemName));
}  


 
 
 
static char     *TimeString ()
{
  time_t        t;
  static char   timeStr [50];

  t = time ( __MS__5 0  __ME__ );
  strcpy (timeStr, ctime (&t));
  timeStr [strlen (timeStr) - 1] = 0;
  return (timeStr);
}  


 
 
 
static void     WriteHRExport (f, base, ptr, type, initialFile, title)
    FILE        *f;
    Item        **base;
    int         *ptr, type, initialFile;
    char        *title;
{
    int         start = 1, col = 80;
    char        *last = "";

    if ((base [*ptr]->kind == type) &&
        (base [*ptr]->fileAttributed == initialFile))
    {
        if (!noHrOption)
        {
            fprintf (f, "        %s:", title);
        }
        while ((base [*ptr]->kind == type) && 
               (base [*ptr]->fileAttributed == initialFile))
        {
            if (!noHrOption && (strcmp (last, base [*ptr]->itemName) != 0))
            {
                if (col + strlen (base [*ptr]->itemName) > 78)
                {
                    fprintf (f, "\n            %s", base [*ptr]->itemName);
                    col = 12 + strlen (base [*ptr]->itemName);
                }
                else
                {
                    fprintf (f, ", %s", base [*ptr]->itemName);
                    col += strlen (base [*ptr]->itemName) + 2;
                }
                last = base [*ptr]->itemName;
            }
            (*ptr)++;
        }
        if (!noHrOption)
        {
            fprintf (f, "\n");
        }
    }
}  


 
 
 
static void     WriteHRImport (f, m, base, ptr, type, objectFile, initialFile,
                               title)
    FILE        *f, *m;
    Item        **base;
    int         *ptr, type, objectFile, initialFile;
    char        *title;
{
    int         start = 1, col = 80;
    char        *last = "";

    if ((base [*ptr]->kind == type) &&
        (base [*ptr]->objectFile == objectFile) &&
        (base [*ptr]->fileAttributed == initialFile))
    {
        if (!noHrOption)
        {
            fprintf (f, "            %s:", title);
        }
        if (!noMinOption)
        {
            fprintf (m, "%d ", type);
        }
        while (start || 
               ((base [*ptr]->kind == type) &&
                (base [*ptr]->fileAttributed == initialFile) &&
                (base [*ptr]->objectFile == base [*ptr - 1]->objectFile)))
        {
            start = 0;
            if (!noHrOption && (strcmp (last, base [*ptr]->itemName) != 0))
            {
                if (col + strlen (base [*ptr]->itemName) > 78)
                {
                    fprintf (f, "\n                %s", base [*ptr]->itemName);
                    col = 16 + strlen (base [*ptr]->itemName);
                }
                else
                {
                    fprintf (f, ", %s", base [*ptr]->itemName);
                    col += strlen (base [*ptr]->itemName) + 2;
                }
                last = base [*ptr]->itemName;
            }
            (*ptr)++;
        }
        if (!noHrOption)
        {
            fprintf (f, "\n");
        }
    }
}  


 
 
 
static void     WriteFileListFromFileLL (f)
    FILE        *f;
{
    File        *ptr = fileHead;
    int         numFiles = 0;

    fprintf (f, "#\n");
    fprintf (f, "# The File Table\n");

    while (ptr !=  __MS__5 0  __ME__ )
    {
        numFiles++;
        ptr = ptr->next;
    }

    fprintf (f, "%d\n", numFiles);
    ptr = fileHead;
    while (ptr !=  __MS__5 0  __ME__ )
    {
        fprintf (f, "%s\n", ptr->fileName);
        fprintf (f, "%s\n", ptr->shortFileName);
        ptr = ptr->next;
    }
}  


 
 
 
static void     WriteFileListFromFileTable (f)
    FILE        *f;
{
    File        *ptr = fileHead;
    int         i;

    fprintf (f, "#\n");
    fprintf (f, "# The File Table\n");

    fprintf (f, "%d\n", numFiles);
    for (i = 1 ; i <= numFiles ; i++)
    {
        fprintf (f, "%s\n", fileTable [i].fileName);
        fprintf (f, "%s\n", fileTable [i].shortFileName);
    }
}  


 
 
 
 
 
static int      WriteHRDataFromDataTable (f, m, base, loc)
    FILE        *f, *m;
    Item        **base;
    int         loc;
{
    int         ptr;
    int         file = base [loc]->fileAttributed;
    int         cnt;
    int         fileIncludedCount;

    if (!noHrOption)
    {
         
        fprintf (f, "File: %s\n", fileTable [file].shortFileName);
    }

    if (!noMinOption)
    {
         
        fprintf (m, "%s\n", fileTable [file].shortFileName);
    }

     
     
     
    ptr = loc;
     
     
     
     
     
     
     
    if (fileTable [file].mainFile)
    {
         
         
         
         
        if (base [ptr]->kind > EXPORT_PUBLIC_VAR_DEF)
        {
            if (!noHrOption)
            {
                fprintf (f, "    No exports\n");
            }
        }
        else
        {
            if (!noHrOption)
            {
                fprintf (f, "    Exports:\n");
            }
            WriteHRExport (f, base, &ptr, EXPORT_PUBLIC_FCN_DEF, file, 
                           "Functions Exported");
            WriteHRExport (f, base, &ptr, EXPORT_PUBLIC_VAR_DEF, file, 
                           "Variables Exported");
        }
        for (cnt = EXPORT_STATIC_FCN_DEF ; cnt < IMPORT_EXPORT_DIVIDER ; cnt++)
        {
            SkipAn (base, &ptr, cnt, file);
        }
    }
    else
    {
         
         
         
        if (base [ptr]->kind >= IMPORT_EXPORT_DIVIDER)
        {
            if (!noHrOption)
            {
                fprintf (f, "    No exports\n");
            }
        }
        else
        {
            if (!noHrOption)
            {
                fprintf (f, "    Exports:\n");
            }
            WriteHRExport (f, base, &ptr, EXPORT_PUBLIC_FCN_DEF, file, 
                           "Functions Exported");
            WriteHRExport (f, base, &ptr, EXPORT_PUBLIC_VAR_DEF, file, 
                           "Variables Exported");
            WriteHRExport (f, base, &ptr, EXPORT_STATIC_FCN_DEF, file, 
                           "Static Functions Exported");
            WriteHRExport (f, base, &ptr, EXPORT_STATIC_VAR_DEF, file, 
                           "Static Variables Exported");
            WriteHRExport (f, base, &ptr, EXPORT_PUBLIC_FCN_DECL, file, 
                           "Function Declarations Exported");
            WriteHRExport (f, base, &ptr, EXPORT_PUBLIC_VAR_DECL, file, 
                           "Variable Declarations Exported");
            WriteHRExport (f, base, &ptr, EXPORT_STATIC_FCN_DECL, file, 
                           "Static Function Declarations Exported");
            WriteHRExport (f, base, &ptr, EXPORT_MACRO, file, 
                           "Macros Exported");
            WriteHRExport (f, base, &ptr, EXPORT_TYPE, file, 
                           "Types Exported");
            WriteHRExport (f, base, &ptr, EXPORT_ENUM_TAG, file, 
                           "Enumerated Type Tags Exported");
            WriteHRExport (f, base, &ptr, EXPORT_ENUM_ITEM, file, 
                           "Enumerated Types Items Exported");
            WriteHRExport (f, base, &ptr, EXPORT_STRUCT, file, 
                           "Structures Exported");
            WriteHRExport (f, base, &ptr, EXPORT_UNION, file, 
                           "Union Types Exported");
            WriteHRExport (f, base, &ptr, EXPORT_PUBLIC_FCN_DEF_END, file, 
                           "Function Ends Exported");                      
            WriteHRExport (f, base, &ptr, EXPORT_STATIC_FCN_DEF_END, file, 
                           "Static Function Ends Exported");               
            WriteHRExport (f, base, &ptr, EXPORT_ENUM_TAG_END, file,       
                           "Enumerated Type Tag End Exported");            
            WriteHRExport (f, base, &ptr, EXPORT_STRUCT_END, file,         
                           "Structure Ends Exported");                     
            WriteHRExport (f, base, &ptr, EXPORT_UNION_END, file,          
                           "Union Type Ends Exported");                    

        }
    }

     
     
     
     
     
    if (base [ptr]->fileAttributed != file)
    {
        if (!noHrOption)
        {
            fprintf (f, "    No imports\n");
        }
    }
    else
    {
         
         
         
         
         
        int     start = 1;

        if (!noHrOption)
        {
            fprintf (f, "    Imports:\n");
        }

         
         
         
         
         
         
        while (base [ptr]->fileAttributed == file)
        {





                int objectFile = base [ptr]->objectFile;

                start = 0;
                if (!noHrOption)
                {
                    if (strcmp (
                             fileTable [objectFile].shortFileName,
                             fileTable [objectFile].fileName) == 0)
                    {
                        fprintf (f, "        %s:\n", 
                             fileTable [objectFile].fileName);
                    }
                    else
                    {
                        fprintf (f, "        %s (%s):\n", 
                             fileTable [objectFile].shortFileName,
                             fileTable [objectFile].fileName);
                    }
                }

                if (!noMinOption)
                {
                    fprintf (m, "%s ", fileTable [objectFile].shortFileName);
                }
        
                fileIncludedCount = 0;

                while ((base [ptr]->kind == INCLUDE_FILE) &&
                       (base [ptr]->objectFile == objectFile) &&
                       (base [ptr]->fileAttributed == file))
                {
                    fileIncludedCount++;
                    ptr++;
                    while ((( base [ptr] ->objectLine ==   base [ptr - 1] ->objectLine) && ( base [ptr] ->subjectLine ==   base [ptr - 1] ->subjectLine) && ( base [ptr] ->objectFile ==   base [ptr - 1] ->objectFile) && ( base [ptr] ->subjectFile ==   base [ptr - 1] ->subjectFile) && ( base [ptr] ->fileAttributed ==   base [ptr - 1] ->fileAttributed) && ( base [ptr] ->kind ==   base [ptr - 1] ->kind) && (strcmp ( base [ptr] ->scopeName,   base [ptr - 1] ->scopeName) == 0) && (strcmp ( base [ptr] ->itemName,   base [ptr - 1] ->itemName) == 0)) )
                    {
                        ptr++;
                    }
                }

                if (fileIncludedCount > 0)
                {
                    if (!noHrOption)
                    {
                        fprintf (f, "            File Included");
                        if (fileIncludedCount > 1)
                        {
                            fprintf (f, " (%d times)", fileIncludedCount);
                        }
                        fprintf (f, "\n");
                    }
                    if (!noMinOption)
                    {
                        fprintf (m, "%d ", INCLUDE_FILE);
                    }
                }

                WriteHRImport (f, m, base, &ptr, IMPORT_IMPLEMENT_PUBLIC_FCN,
                           objectFile, file, "Functions Implemented");
                WriteHRImport (f, m, base, &ptr, IMPORT_IMPLEMENT_PUBLIC_VAR,
                           objectFile, file, "Variables Implemented");
                WriteHRImport (f, m, base, &ptr, IMPORT_IMPLEMENT_STATIC_FCN,
                           objectFile, file, "Static Functions Implemented");
                WriteHRImport (f, m, base, &ptr, IMPORT_IMPLEMENT_STATIC_VAR,
                           objectFile, file, "Static Variables Implemented");
                WriteHRImport (f, m, base, &ptr, IMPORT_PUBLIC_FCN_DEF, 
                           objectFile, file, "Function Definition Imported");
                WriteHRImport (f, m, base, &ptr, IMPORT_PUBLIC_VAR_DEF, 
                           objectFile, file, "Variables Definition Imported");
                WriteHRImport (f, m, base, &ptr, IMPORT_PUBLIC_FCN_DECL, 
                           objectFile, file, "Function Declarations Imported");
                WriteHRImport (f, m, base, &ptr, IMPORT_PUBLIC_VAR_DECL, 
                           objectFile, file, "Variables Declarations Imported");
                WriteHRImport (f, m, base, &ptr, IMPORT_STATIC_FCN_DEF, 
                           objectFile, file, "Static Functions Imported");
                WriteHRImport (f, m, base, &ptr, IMPORT_STATIC_VAR_DEF, 
                           objectFile, file, "Static Variables Imported");
                WriteHRImport (f, m, base, &ptr, IMPORT_LINK_FCN, 
                           objectFile, file, "Link Time Functions Imported");
                WriteHRImport (f, m, base, &ptr, IMPORT_LINK_VAR, 
                           objectFile, file, "Link Time Variables Imported");
                WriteHRImport (f, m, base, &ptr, IMPORT_EXTERN_FCN, 
                           objectFile, file, "External Functions Imported");
                WriteHRImport (f, m, base, &ptr, IMPORT_EXTERN_VAR, 
                           objectFile, file, "External Variables Imported");
                WriteHRImport (f, m, base, &ptr, IMPORT_CODE_AND_VARS, 
                           objectFile, file, "Code and Variables Imported");
                WriteHRImport (f, m, base, &ptr, IMPORT_MACRO,
                           objectFile, file, "Macros Imported");
                WriteHRImport (f, m, base, &ptr, IMPORT_TYPE,
                           objectFile, file, "Types Imported");
                WriteHRImport (f, m, base, &ptr, IMPORT_ENUM_TAG,
                           objectFile, file, "Enumerated Type Tags Imported");
                WriteHRImport (f, m, base, &ptr, IMPORT_ENUM_ITEM,
                           objectFile, file, "Enumerated Types Items Imported");
                WriteHRImport (f, m, base, &ptr, IMPORT_STRUCT,
                           objectFile, file, "Structures Imported");
                WriteHRImport (f, m, base, &ptr, IMPORT_UNION,
                           objectFile, file, "Union Types Imported");
                WriteHRImport (f, m, base, &ptr, IMPORT_FCN_REF_TEMP,
                           objectFile, file, "Function Reference (Temp)");
                WriteHRImport (f, m, base, &ptr, IMPORT_VAR_REF_TEMP,
                           objectFile, file, "Variables Reference (Temp)");
                WriteHRImport (f, m, base, &ptr, IMPORT_LINK_FCN_TEMP,
                           objectFile, file, "Function Reference Link (Temp)");
                WriteHRImport (f, m, base, &ptr, IMPORT_LINK_VAR_TEMP, 
                           objectFile, file, "Variable Reference Link (Temp)");
                if (!noMinOption)
                {
                    fprintf (m, "\n");
                }



        }
    }

    if (!noMinOption)
    {
        fprintf (m, "---\n");
    }
    return (ptr);
}  


 
 
 
 
static void     WriteMRDataFromDataLL_gerry (f, listHead)
    FILE        *f;
    Item        *listHead;
{
    Item        *ptr = listHead;
    int         numElements = 0;

    while (ptr !=  __MS__5 0  __ME__ )
    {
        if ((ptr->kind != IMPORT_FCN_REF_TEMP) &&
            (ptr->kind != IMPORT_VAR_REF_TEMP))
        {
            numElements++;
        }
        ptr = ptr->next;
    }

    fprintf (f, "#\n");
    fprintf (f, "# Imports/Exports\n");
    fprintf (f, "#\n");
    fprintf (f, "#     File   Subject     Object\n");
    fprintf (f, "#Kind Attr File  Line  File  Line          Scope Name         Item Name\n");
    fprintf (f, "#---- ---- ---- ------ ---- ------ -------------------------- ---------\n");

    fprintf (f, "%d\n", numElements);

    ptr = listHead;
    while (ptr !=  __MS__5 0  __ME__ )
    {
        if ((ptr->kind != IMPORT_FCN_REF_TEMP) &&
            (ptr->kind != IMPORT_VAR_REF_TEMP))
        {
            if ( strcmp(ptr ->scopeName, "*** Undefined Item ***" ) == 0) ptr -> scopeName = "-";
            fprintf (f, " %4d %4d %4d %6d %4d %6d %25s %s\n", ptr->kind, 
                     ptr->fileAttributed, ptr->subjectFile, ptr->subjectLine,
                     ptr->objectFile, ptr->objectLine,
                     ptr->scopeName, ptr->itemName);
        }
        ptr = ptr->next;
    }
}  


 
 
 
 
static void     WriteMRDataFromDataLL (f, listHead)
    FILE        *f;
    Item        *listHead;
{
    Item        *ptr = listHead;
    int         numElements = 0;

    while (ptr !=  __MS__5 0  __ME__ )
    {
        if ((ptr->kind != IMPORT_FCN_REF_TEMP) &&
            (ptr->kind != IMPORT_VAR_REF_TEMP))
        {
            numElements++;
        }
        ptr = ptr->next;
    }

    fprintf (f, "#\n");
    fprintf (f, "# Imports/Exports\n");
    fprintf (f, "#\n");
    fprintf (f, "#     File   Subject     Object\n");
    fprintf (f, "#Kind Attr File  Line  File  Line  Item Name\n");
    fprintf (f, "#---- ---- ---- ------ ---- ------ ---------\n");

    fprintf (f, "%d\n", numElements);

    ptr = listHead;
    while (ptr !=  __MS__5 0  __ME__ )
    {
        if ((ptr->kind != IMPORT_FCN_REF_TEMP) &&
            (ptr->kind != IMPORT_VAR_REF_TEMP))
        {
            fprintf (f, " %4d %4d %4d %6d %4d %6d %s\n", ptr->kind, 
                     ptr->fileAttributed, ptr->subjectFile, ptr->subjectLine,
                     ptr->objectFile, ptr->objectLine,
                     ptr->itemName);
        }
        ptr = ptr->next;
    }
}  


 
 
 
 
static int      WriteMRDataFromDataTable (f, base, loc)
    FILE        *f;
    Item        **base;
    int         loc;
{
    int         i, match;
    Item        *ptr;
    int         initialFile = base [loc]->fileAttributed;

     
    fprintf (f, "#\n");
    fprintf (f, "# Imports/Exports from %s\n", 
             fileTable [initialFile].shortFileName);
    fprintf (f, "#\n");
    fprintf (f, "#     File   Subject     Object\n");
    fprintf (f, "#Kind Attr File  Line  File  Line  Item Name\n");
    fprintf (f, "#---- ---- ---- ------ ---- ------ ---------\n");

     
    fprintf (f, "%s %s\n", fileTable [initialFile].shortFileName,
             fileTable [initialFile].fileName);

     
    i = loc;
    while (base [i]->fileAttributed == initialFile)
    {
        i++;
    }
    fprintf (f, "%d\n", i - loc);

    i = loc;
    while (base [i]->fileAttributed == initialFile)
    {
        match = 0;
        ptr = base [i];
        if (i != loc)
        {
            if ((( ptr ->objectLine ==   base [i - 1] ->objectLine) && ( ptr ->subjectLine ==   base [i - 1] ->subjectLine) && ( ptr ->objectFile ==   base [i - 1] ->objectFile) && ( ptr ->subjectFile ==   base [i - 1] ->subjectFile) && ( ptr ->fileAttributed ==   base [i - 1] ->fileAttributed) && ( ptr ->kind ==   base [i - 1] ->kind) && (strcmp ( ptr ->scopeName,   base [i - 1] ->scopeName) == 0) && (strcmp ( ptr ->itemName,   base [i - 1] ->itemName) == 0)) )
            {
                match = 1;
            }
        }
        if (!match)
        {
            fprintf (f, " %4d %4d %4d %6d %4d %6d %s\n", ptr->kind, 
                     ptr->fileAttributed, ptr->subjectFile, ptr->subjectLine,
                     ptr->objectFile, ptr->objectLine,
                     ptr->itemName);
        }
        i++;
    }
    return (i);
}  


