#include <stdio.h>

#include "cfx.h"

main (argc, argv)
    int argc;
    char *argv [];
{
    int i;
    int	noMr, noHr, noMin, allFacts, oneFile, dirAttrib;
    char	*outFile = NULL;

    noMr = 0;
    noHr = 0;
    noMin = 0;
    allFacts = 0;
    oneFile = 1;
    dirAttrib = 0;

    for (i = 1 ; i < argc ; i++)
    {
        if (! strcmp (argv[i], "-sonefile"))
 	  oneFile = 1;
        else if (! strcmp (argv[i], "-sallfacts"))
	  allFacts = 1;
        else if (! strcmp (argv[i], "-snomr"))
	  noMr = 1;
        else if (! strcmp (argv[i], "-snohr"))
	  noHr = 1;
        else if (! strcmp (argv[i], "-snomin"))
	  noMin = 1;
        else if (! strcmp (argv[i], "-sdirect"))
	  dirAttrib = 1;
        else if (! strcmp (argv[i], "-o"))
	{
	  /* Set the object file name */
	  if (i == (argc - 1))
	  {
	      fprintf (stderr, "-o option needs a filename\n");
	      exit (2);
	  }
	  i++;
	  outFile = argv [i];
	}
    }

    Cfx_Initialize (outFile, noMr, noHr, noMin, allFacts, oneFile, dirAttrib);

    for (i = 1 ; i < argc ; i++)
    {
        if (argv[i][0] != '-')
	{
	    fprintf (stderr, "File = \"%s\"\n", argv [i]);
	    Cfx_ReadFile (argv [i]);
	}
	if (strcmp (argv[i], "-o") == 0)
	{
	    i++;
	}
    }

    Cfx_Finalize ();

    exit (0);
}
