#ifndef __CFX_HASH_H
#define __CFX_HASH_H

#include <stdio.h>
#include <stdlib.h>
#include "cfx-common.h"

#define TABLE_SIZE 5000

/* modify these lines to establish data type */

typedef struct {
  char key[BUFSIZE];
  char resolved[BUFSIZE];
}T;

typedef int hashTableIndex;     /* index into hash table */
#define compEQ(a,b) (!strcmp(a,b))

typedef struct Node_ {
    struct Node_ *next;         /* next node */
    T data;                     /* data stored in node */
} Node;

static int hashTableSize = TABLE_SIZE;
static Node *hashTable[TABLE_SIZE];

static hashTableIndex hash(T data);
Node *insertNode(T data);
void deleteNode(T data);
Node *findNode (T data);

#endif
