# 1 "binfmt_aout.c"
 





# 1 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/module.h" 1
 



















 




 


 



 


struct kernel_sym {  
	unsigned long value;		 
	char name[60 ];	 
};

struct module_ref {
	struct module *module;
	struct module_ref *next;
};

struct internal_symbol {
	void *addr;
	const char *name;
	};

struct symbol_table {  
	int size;  
	int n_symbols;
	int n_refs;
	struct internal_symbol symbol[0];  
	struct module_ref ref[0];  
};
 



struct module {
	struct module *next;
	struct module_ref *ref;	 
	struct symbol_table *symtab;
	const char *name;
	int size;			 
	void* addr;			 
	int state;
	void (*cleanup)(void);		 
};

struct mod_routines {
	int (*init)(void);		 
	void (*cleanup)(void);		 
};

 



 



# 102 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/module.h"








 
extern int register_symtab_from(struct symbol_table *, long *);







# 7 "binfmt_aout.c" 2


# 1 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/fs.h" 1



 




# 1 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/config.h" 1



# 1 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/autoconf.h" 1
 



 


















 










 






 








 




 







 





 




 




 





















 




# 4 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/config.h" 2


 


















 




 

 





 





# 9 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/fs.h" 2

# 1 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/linkage.h" 1









# 18 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/linkage.h"



















# 45 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/linkage.h"


# 57 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/linkage.h"



# 10 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/fs.h" 2

# 1 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/limits.h" 1

















# 11 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/fs.h" 2

# 1 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/wait.h" 1










struct wait_queue {
	struct task_struct * task;
	struct wait_queue * next;
};



static inline void init_waitqueue(struct wait_queue **q)
{
	*q = ((struct wait_queue *)(( q )-1)) ;
}

static inline int waitqueue_active(struct wait_queue **q)
{
	struct wait_queue *head = *q;
	return head && head != ((struct wait_queue *)(( q )-1)) ;
}

struct select_table_entry {
	struct wait_queue wait;
	struct wait_queue ** wait_address;
};

typedef struct select_table_struct {
	int nr;
	struct select_table_entry * entry;
} select_table;






# 12 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/fs.h" 2

# 1 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/types.h" 1



# 1 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/posix_types.h" 1



 









 










 


















typedef struct fd_set {
	unsigned long fds_bits [(1024 /(8 * sizeof(unsigned long)) ) ];
} __kernel_fd_set;

# 1 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/asm/posix_types.h" 1



 





typedef unsigned short	__kernel_dev_t;
typedef unsigned long	__kernel_ino_t;
typedef unsigned short	__kernel_mode_t;
typedef unsigned short	__kernel_nlink_t;
typedef long		__kernel_off_t;
typedef int		__kernel_pid_t;
typedef unsigned short	__kernel_uid_t;
typedef unsigned short	__kernel_gid_t;
typedef unsigned int	__kernel_size_t;
typedef int		__kernel_ssize_t;
typedef int		__kernel_ptrdiff_t;
typedef long		__kernel_time_t;
typedef long		__kernel_clock_t;
typedef int		__kernel_daddr_t;
typedef char *		__kernel_caddr_t;


typedef long long	__kernel_loff_t;


typedef struct {

	int	val[2];



} __kernel_fsid_t;

















# 48 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/posix_types.h" 2



# 4 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/types.h" 2

# 1 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/asm/types.h" 1



typedef unsigned short umode_t;

 




typedef __signed__ char __s8;
typedef unsigned char __u8;

typedef __signed__ short __s16;
typedef unsigned short __u16;

typedef __signed__ int __s32;
typedef unsigned int __u32;


typedef __signed__ long long __s64;
typedef unsigned long long __u64;


 




typedef signed char s8;
typedef unsigned char u8;

typedef signed short s16;
typedef unsigned short u16;

typedef signed int s32;
typedef unsigned int u32;

typedef signed long long s64;
typedef unsigned long long u64;




# 5 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/types.h" 2




typedef __kernel_fd_set		fd_set;
typedef __kernel_dev_t		dev_t;
typedef __kernel_ino_t		ino_t;
typedef __kernel_mode_t		mode_t;
typedef __kernel_nlink_t	nlink_t;
typedef __kernel_off_t		off_t;
typedef __kernel_pid_t		pid_t;
typedef __kernel_uid_t		uid_t;
typedef __kernel_gid_t		gid_t;
typedef __kernel_daddr_t	daddr_t;


typedef __kernel_loff_t		loff_t;


 





typedef __kernel_size_t		size_t;




typedef __kernel_ssize_t	ssize_t;




typedef __kernel_ptrdiff_t	ptrdiff_t;




typedef __kernel_time_t		time_t;




typedef __kernel_clock_t	clock_t;




typedef __kernel_caddr_t	caddr_t;


 
typedef unsigned char		u_char;
typedef unsigned short		u_short;
typedef unsigned int		u_int;
typedef unsigned long		u_long;

 
typedef unsigned char		unchar;
typedef unsigned short		ushort;
typedef unsigned int		uint;
typedef unsigned long		ulong;



 




struct ustat {
	__kernel_daddr_t	f_tfree;
	__kernel_ino_t		f_tinode;
	char			f_fname[6];
	char			f_fpack[6];
};


# 13 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/fs.h" 2

# 1 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/vfs.h" 1



# 1 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/asm/statfs.h" 1







typedef __kernel_fsid_t	fsid_t;



struct statfs {
	long f_type;
	long f_bsize;
	long f_blocks;
	long f_bfree;
	long f_bavail;
	long f_files;
	long f_ffree;
	__kernel_fsid_t f_fsid;
	long f_namelen;
	long f_spare[6];
};


# 4 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/vfs.h" 2



# 14 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/fs.h" 2

# 1 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/net.h" 1
 





















# 1 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/socket.h" 1



# 1 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/asm/socket.h" 1



# 1 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/asm/sockios.h" 1



 








# 4 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/asm/socket.h" 2


 
















 


# 4 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/socket.h" 2

# 1 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/sockios.h" 1
 





















 



 































 







 




 




 




 

 





 


 


 


# 5 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/socket.h" 2

# 1 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/uio.h" 1



 









 


struct iovec
{
	void *iov_base;		 
	int iov_len;
};





# 6 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/socket.h" 2


struct sockaddr 
{
	unsigned short	sa_family;	 
	char		sa_data[14];	 
};

struct linger {
	int		l_onoff;	 
	int		l_linger;	 
};

 




 
struct msghdr 
{
	void	*	msg_name;	 
	int		msg_namelen;	 
	struct iovec *	msg_iov;	 
	int 		msg_iovlen;	 
	void 	*	msg_control;	 
	int		msg_controllen;	 
	int		msg_flags;	 
};

 



 






					 
					 
					 
					 

 













 














 


 



 


 








 















 



 
 


 



 





extern void memcpy_fromiovec(unsigned char *kdata, struct iovec *iov, int len);
extern int verify_iovec(struct msghdr *m, struct iovec *iov, char *address, int mode);
extern void memcpy_toiovec(struct iovec *v, unsigned char *kdata, int len);
extern int move_addr_to_user(void *kaddr, int klen, void *uaddr, int *ulen);
extern int move_addr_to_kernel(void *uaddr, int ulen, void *kaddr);


# 23 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/net.h" 2
























typedef enum {
  SS_FREE = 0,				 
  SS_UNCONNECTED,			 
  SS_CONNECTING,			 
  SS_CONNECTED,				 
  SS_DISCONNECTING			 
} socket_state;






 










struct socket {
  short			type;		 
  socket_state		state;
  long			flags;
  struct proto_ops	*ops;		 
  void			*data;		 
  struct socket		*conn;		 
  struct socket		*iconn;		 
  struct socket		*next;
  struct wait_queue	**wait;		 
  struct inode		*inode;
  struct fasync_struct  *fasync_list;	 
  struct file		*file;		 
};



struct proto_ops {
  int	family;

  int	(*create)	(struct socket *sock, int protocol);
  int	(*dup)		(struct socket *newsock, struct socket *oldsock);
  int	(*release)	(struct socket *sock, struct socket *peer);
  int	(*bind)		(struct socket *sock, struct sockaddr *umyaddr,
			 int sockaddr_len);
  int	(*connect)	(struct socket *sock, struct sockaddr *uservaddr,
			 int sockaddr_len, int flags);
  int	(*socketpair)	(struct socket *sock1, struct socket *sock2);
  int	(*accept)	(struct socket *sock, struct socket *newsock,
			 int flags);
  int	(*getname)	(struct socket *sock, struct sockaddr *uaddr,
			 int *usockaddr_len, int peer);
  int	(*select)	(struct socket *sock, int sel_type,
			 select_table *wait);
  int	(*ioctl)	(struct socket *sock, unsigned int cmd,
			 unsigned long arg);
  int	(*listen)	(struct socket *sock, int len);
  int	(*shutdown)	(struct socket *sock, int flags);
  int	(*setsockopt)	(struct socket *sock, int level, int optname,
			 char *optval, int optlen);
  int	(*getsockopt)	(struct socket *sock, int level, int optname,
			 char *optval, int *optlen);
  int	(*fcntl)	(struct socket *sock, unsigned int cmd,
			 unsigned long arg);	
  int   (*sendmsg)	(struct socket *sock, struct msghdr *m, int total_len, int nonblock, int flags);
  int   (*recvmsg)	(struct socket *sock, struct msghdr *m, int total_len, int nonblock, int flags, int *addr_len);
};

struct net_proto {
	const char *name;		 
	void (*init_func)(struct net_proto *);	 
};

extern int	sock_wake_async(struct socket *sock, int how);
extern int	sock_register(int family, struct proto_ops *ops);
extern int	sock_unregister(int family);
extern struct socket *sock_alloc(void);
extern void	sock_release(struct socket *sock);


# 15 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/fs.h" 2

# 1 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/kdev_t.h" 1



 























































 






typedef unsigned short kdev_t;








extern char * kdevname(kdev_t);	 

 




static inline unsigned int kdev_t_to_nr(kdev_t dev) {
	return ((( dev ) >> 8 ) <<8) | (( dev ) & ((1<<8 ) - 1) ) ;
}

static inline kdev_t to_kdev_t(int dev)
{
	int major, minor;








	major = (dev >> 8);
	minor = (dev & 0xff);

	return ((( major ) << 8 ) | (  minor )) ;
}

# 113 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/kdev_t.h"


# 16 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/fs.h" 2

# 1 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/ioctl.h" 1



# 1 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/asm/ioctl.h" 1
 







 









 






















 












 





 





 








# 4 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/ioctl.h" 2




# 17 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/fs.h" 2


 








 







 
extern int max_inodes, nr_inodes;
extern int max_files, nr_files;
























 












 




 





 

















 
















# 1 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/asm/semaphore.h" 1





 





struct semaphore {
	int count;
	int waiting;
	struct wait_queue * wait;
};




 __MS__7   __ME__  void down_failed(void  );
 __MS__7   __ME__  void up_wakeup(void  );

extern void __down(struct semaphore * sem);
extern void __up(struct semaphore * sem);

 




extern inline void down(struct semaphore * sem)
{
}

 





extern inline void up(struct semaphore * sem)
{
}


# 122 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/fs.h" 2

# 1 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/asm/bitops.h" 1



 



 















 


struct __dummy { unsigned long a[100]; };



extern __inline__ int set_bit(int nr,   void * addr)
{
	int oldbit;

	return oldbit;
}

extern __inline__ int clear_bit(int nr,   void * addr)
{
	int oldbit;

	return oldbit;
}

extern __inline__ int change_bit(int nr,   void * addr)
{
	int oldbit;

	return oldbit;
}

 


extern __inline__ int test_bit(int nr, const   void * addr)
{
	return ((1UL << (nr & 31)) & (((const unsigned int *) addr)[nr >> 5])) != 0;
}

 


extern __inline__ int find_first_zero_bit(void * addr, unsigned size)
{
	int res;

	if (!size)
		return 0;
	return res;
}

extern __inline__ int find_next_zero_bit (void * addr, int size, int offset)
{
	unsigned long * p = ((unsigned long *) addr) + (offset >> 5);
	int set = 0, bit = offset & 31, res;
	
	if (bit) {
		 


		if (set < (32 - bit))
			return set + offset;
		set = 32 - bit;
		p++;
	}
	 


	res = find_first_zero_bit (p, size - 32 * (p - (unsigned long *) addr));
	return (offset + set + res);
}

 



extern __inline__ unsigned long ffz(unsigned long word)
{
	return word;
}


# 123 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/fs.h" 2


extern void buffer_init(void);
extern unsigned long inode_init(unsigned long start, unsigned long end);
extern unsigned long file_table_init(unsigned long start, unsigned long end);
extern unsigned long name_cache_init(unsigned long start, unsigned long end);

typedef char buffer_block[1024 ];

 









 











struct buffer_head {
	 
	unsigned long b_blocknr;	 
	kdev_t b_dev;			 
	kdev_t b_rdev;			 
	unsigned long b_rsector;	 
	struct buffer_head * b_next;	 
	struct buffer_head * b_this_page;	 

	 
	unsigned long b_state;		 
	struct buffer_head * b_next_free;
	unsigned int b_count;		 
	unsigned long b_size;		 

	 
	char * b_data;			 
	unsigned int b_list;		 
	unsigned long b_flushtime;       

	unsigned long b_lru_time;        

	struct wait_queue * b_wait;
	struct buffer_head * b_prev;		 
	struct buffer_head * b_prev_free;	 
	struct buffer_head * b_reqnext;		 
};

static inline int buffer_uptodate(struct buffer_head * bh)
{
	return test_bit(0 , &bh->b_state);
}	

static inline int buffer_dirty(struct buffer_head * bh)
{
	return test_bit(1 , &bh->b_state);
}

static inline int buffer_locked(struct buffer_head * bh)
{
	return test_bit(2 , &bh->b_state);
}

static inline int buffer_req(struct buffer_head * bh)
{
	return test_bit(3 , &bh->b_state);
}

static inline int buffer_touched(struct buffer_head * bh)
{
	return test_bit(4 , &bh->b_state);
}

static inline int buffer_has_aged(struct buffer_head * bh)
{
	return test_bit(5 , &bh->b_state);
}

static inline int buffer_protected(struct buffer_head * bh)
{
	return test_bit(6 , &bh->b_state);
}

# 1 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/pipe_fs_i.h" 1



struct pipe_inode_info {
	struct wait_queue * wait;
	char * base;
	unsigned int start;
	unsigned int len;
	unsigned int lock;
	unsigned int rd_openers;
	unsigned int wr_openers;
	unsigned int readers;
	unsigned int writers;
};





















# 217 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/fs.h" 2

# 1 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/minix_fs_i.h" 1



 


struct minix_inode_info {
	union {
		__u16 i1_data[16];
		__u32 i2_data[16];
	} u;
};


# 218 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/fs.h" 2

# 1 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/ext_fs_i.h" 1



 


struct ext_inode_info {
	unsigned long i_data[16];
};


# 219 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/fs.h" 2

# 1 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/ext2_fs_i.h" 1
 

















 


struct ext2_inode_info {
	__u32	i_data[15];
	__u32	i_flags;
	__u32	i_faddr;
	__u8	i_frag_no;
	__u8	i_frag_size;
	__u16	i_osync;
	__u32	i_file_acl;
	__u32	i_dir_acl;
	__u32	i_dtime;
	__u32	i_version;
	__u32	i_block_group;
	__u32	i_next_alloc_block;
	__u32	i_next_alloc_goal;
	__u32	i_prealloc_block;
	__u32	i_prealloc_count;
	int	i_new_inode:1;	 
};


# 220 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/fs.h" 2

# 1 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/hpfs_fs_i.h" 1



struct hpfs_inode_info {
	ino_t i_parent_dir;	 
	unsigned i_dno;		 
	unsigned i_dpos;	 
	unsigned i_dsubdno;	 
	unsigned i_file_sec;	 
	unsigned i_disk_sec;	 
	unsigned i_n_secs;	 
	unsigned i_conv : 2;	 
};











# 221 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/fs.h" 2

# 1 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/msdos_fs_i.h" 1







 



struct msdos_inode_info {
	 













	struct pipe_inode_info reserved;
	int i_start;	 
	int i_attrs;	 
	int i_busy;	 

	struct inode *i_depend;  

	struct inode *i_old;	 

	struct inode *i_linked;	 

	struct inode *i_oldlink; 

	int i_binary;	 
};


# 222 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/fs.h" 2

# 1 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/umsdos_fs_i.h" 1









 




































struct dir_locking_info {
	struct wait_queue *p;
	short int looking;		 
	short int creating;		 
							 
							 
	long pid;				 
							 
};
struct umsdos_inode_info {
	union {
		struct msdos_inode_info msdos_info;
		struct pipe_inode_info pipe_info;
		struct dir_locking_info dir_info;
	}u;	 
	unsigned long i_dir_owner;	 
								 
	unsigned long i_emd_owner;	 
	off_t pos;					 
	 
	unsigned long i_emd_dir;	 
};


# 223 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/fs.h" 2

# 1 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/iso_fs_i.h" 1



 


struct iso_inode_info {
	unsigned int i_first_extent;
	unsigned int i_backlink;
	unsigned char i_file_format;
};


# 224 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/fs.h" 2

# 1 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/nfs_fs_i.h" 1



# 1 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/nfs.h" 1
























enum rpc_auth_flavor {
	RPC_AUTH_NULL = 0,
	RPC_AUTH_UNIX = 1,
	RPC_AUTH_SHORT = 2
};

enum rpc_msg_type {
	RPC_CALL = 0,
	RPC_REPLY = 1
};

enum rpc_reply_stat {
	RPC_MSG_ACCEPTED = 0,
	RPC_MSG_DENIED = 1
};

enum rpc_accept_stat {
	RPC_SUCCESS = 0,
	RPC_PROG_UNAVAIL = 1,
	RPC_PROG_MISMATCH = 2,
	RPC_PROC_UNAVAIL = 3,
	RPC_GARBAGE_ARGS = 4
};

enum rpc_reject_stat {
	RPC_MISMATCH = 0,
	RPC_AUTH_ERROR = 1
};

enum rpc_auth_stat {
	RPC_AUTH_BADCRED = 1,
	RPC_AUTH_REJECTEDCRED = 2,
	RPC_AUTH_BADVERF = 3,
	RPC_AUTH_REJECTEDVERF = 4,
	RPC_AUTH_TOOWEAK = 5
};


	
enum nfs_stat {
	NFS_OK = 0,
	NFSERR_PERM = 1,
	NFSERR_NOENT = 2,
	NFSERR_IO = 5,
	NFSERR_NXIO = 6,
	NFSERR_EAGAIN = 11,
	NFSERR_ACCES = 13,
	NFSERR_EXIST = 17,
	NFSERR_NODEV = 19,
	NFSERR_NOTDIR = 20,
	NFSERR_ISDIR = 21,
	NFSERR_INVAL = 22,	 
	NFSERR_FBIG = 27,
	NFSERR_NOSPC = 28,
	NFSERR_ROFS = 30,
	NFSERR_NAMETOOLONG = 63,
	NFSERR_NOTEMPTY = 66,
	NFSERR_DQUOT = 69,
	NFSERR_STALE = 70,
	NFSERR_WFLUSH = 99
};

enum nfs_ftype {
	NFNON = 0,
	NFREG = 1,
	NFDIR = 2,
	NFBLK = 3,
	NFCHR = 4,
	NFLNK = 5,
	NFSOCK = 6,
	NFBAD = 7,
	NFFIFO = 8
};






















struct nfs_fh {
	char data[32 ];
};

struct nfs_time {
	u_int seconds;
	u_int useconds;
};

struct nfs_fattr {
	enum nfs_ftype type;
	u_int mode;
	u_int nlink;
	u_int uid;
	u_int gid;
	u_int size;
	u_int blocksize;
	u_int rdev;
	u_int blocks;
	u_int fsid;
	u_int fileid;
	struct nfs_time atime;
	struct nfs_time mtime;
	struct nfs_time ctime;
};

struct nfs_sattr {
	u_int mode;
	u_int uid;
	u_int gid;
	u_int size;
	struct nfs_time atime;
	struct nfs_time mtime;
};

struct nfs_entry {
	u_int fileid;
	char *name;
	int cookie;
	int eof;
};

struct nfs_fsinfo {
	u_int tsize;
	u_int bsize;
	u_int blocks;
	u_int bfree;
	u_int bavail;
};


# 4 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/nfs_fs_i.h" 2



 


struct nfs_inode_info {
	struct pipe_inode_info pipeinfo;
	struct nfs_fh fhandle;
	 









	unsigned long read_cache_jiffies;
	unsigned long read_cache_mtime;
	 




	struct inode *silly_rename_dir;
	 


	unsigned long attrtimeo;
};


# 225 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/fs.h" 2

# 1 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/xia_fs_i.h" 1



 








struct xiafs_inode_info { 		 
    unsigned long  i_zone[8];
    unsigned long  i_ind_zone;
    unsigned long  i_dind_zone;
};


# 226 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/fs.h" 2

# 1 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/sysv_fs_i.h" 1



 


struct sysv_inode_info {
	unsigned long i_data[10+1+1+1];	 




};



# 227 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/fs.h" 2

# 1 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/affs_fs_i.h" 1






 


struct affs_inode_info {
	__u32	i_protect;		 
	__s32	i_parent;		 
	__s32	i_original;		 
	__s32	i_ext[12 ];	 
	__s32	i_data[8 ];	 
	int	i_lastblock;		 
	short	i_max_ext;		 
	short	i_pa_cnt;		 
	short	i_pa_next;		 
	short	i_pa_last;		 
	short	i_zone;			 
	unsigned char i_hlink;		 
	unsigned char i_pad;
};


# 228 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/fs.h" 2

# 1 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/ufs_fs_i.h" 1
 














# 1 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/ufs_fs.h" 1
 















# 1 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/kernel.h" 1



 





# 1 "/usr/include/stdarg.h" 1 3
 
 

 
 
 

 







#pragma ident	"@(#)stdarg.h	1.38	96/01/26 SMI"	



# 1 "/usr/include/sys/va_list.h" 1 3
 







#pragma ident	"@(#)va_list.h	1.6	96/01/26 SMI"

 













# 41 "/usr/include/sys/va_list.h" 3



typedef void *__va_list;











# 20 "/usr/include/stdarg.h" 2 3






 







typedef __va_list va_list;


 



















# 69 "/usr/include/stdarg.h" 3


 








# 113 "/usr/include/stdarg.h" 3


extern void va_end(va_list);


 



# 131 "/usr/include/stdarg.h" 3













# 10 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/kernel.h" 2



 






















extern void math_error(void);
  void panic(const char * fmt, ...)
	__attribute__ ((  format (printf, 1, 2)));
  void do_exit(long error_code)
	 ;
extern unsigned long simple_strtoul(const char *,char **,unsigned int);
extern int sprintf(char * buf, const char * fmt, ...);
extern int vsprintf(char *buf, const char *, va_list);

extern int session_of_pgrp(int pgrp);

extern int kill_proc(int pid, int sig, int priv);
extern int kill_pg(int pgrp, int sig, int priv);
extern int kill_sl(int sess, int sig, int priv);

 __MS__7   __ME__  int printk(const char * fmt, ...)
	__attribute__ ((format (printf, 1, 2)));












 








struct sysinfo {
	long uptime;			 
	unsigned long loads[3];		 
	unsigned long totalram;		 
	unsigned long freeram;		 
	unsigned long sharedram;	 
	unsigned long bufferram;	 
	unsigned long totalswap;	 
	unsigned long freeswap;		 
	unsigned short procs;		 
	char _f[22];			 
};


# 17 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/ufs_fs.h" 2

# 1 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/time.h" 1





struct timespec {
	long	tv_sec;		 
	long	tv_nsec;	 
};


struct timeval {
	int	tv_sec;		 
	int	tv_usec;	 
};

struct timezone {
	int	tz_minuteswest;	 
	int	tz_dsttime;	 
};




void do_gettimeofday(struct timeval *tv);
void do_settimeofday(struct timeval *tv);








 







struct  itimerspec {
        struct  timespec it_interval;     
        struct  timespec it_value;        
};

struct	itimerval {
	struct	timeval it_interval;	 
	struct	timeval it_value;	 
};


# 18 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/ufs_fs.h" 2

# 1 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/stat.h" 1





# 1 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/asm/stat.h" 1



struct old_stat {
	unsigned short st_dev;
	unsigned short st_ino;
	unsigned short st_mode;
	unsigned short st_nlink;
	unsigned short st_uid;
	unsigned short st_gid;
	unsigned short st_rdev;
	unsigned long  st_size;
	unsigned long  st_atime;
	unsigned long  st_mtime;
	unsigned long  st_ctime;
};

struct new_stat {
	unsigned short st_dev;
	unsigned short __pad1;
	unsigned long st_ino;
	unsigned short st_mode;
	unsigned short st_nlink;
	unsigned short st_uid;
	unsigned short st_gid;
	unsigned short st_rdev;
	unsigned short __pad2;
	unsigned long  st_size;
	unsigned long  st_blksize;
	unsigned long  st_blocks;
	unsigned long  st_atime;
	unsigned long  __unused1;
	unsigned long  st_mtime;
	unsigned long  __unused2;
	unsigned long  st_ctime;
	unsigned long  __unused3;
	unsigned long  __unused4;
	unsigned long  __unused5;
};


# 6 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/stat.h" 2
















































# 19 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/ufs_fs.h" 2

























 






 



 



 



 
 




struct ufs_direct {
	__u32  d_ino;			 
	__u16  d_reclen;		 
	__u16  d_namlen;		 
	char   d_name[255  + 1];	 
};




struct ufs_csum {
	__u32	cs_ndir;	 
	__u32	cs_nbfree;	 
	__u32	cs_nifree;	 
	__u32	cs_nffree;	 
};

typedef struct _ufsquad {
	__u32 val[2];
} ufsquad;

 


struct ufs_superblock {
	__u32	fs_link;	 
	__u32	fs_rlink;	 
	__u32	fs_sblkno;
	__u32	fs_cblkno;
	__u32	fs_iblkno;
	__u32	fs_dblkno;
	__u32	fs_cgoffset;
	__u32	fs_cgmask;
	time_t	fs_time;	 
	__u32	fs_size;
	__u32	fs_dsize;
	__u32	fs_ncg;
	__u32	fs_bsize;
	__u32	fs_fsize;
	__u32	fs_frag;
	__u32	fs_minfree;
	__u32	fs_rotdelay;
	__u32	fs_rps;
	__u32	fs_bmask;
	__u32	fs_fmask;
	__u32	fs_bshift;
	__u32	fs_fshift;
	__u32	fs_maxcontig;
	__u32	fs_maxbpg;
	__u32	fs_fragshift;
	__u32	fs_fsbtodb;
	__u32	fs_sbsize;
	__u32	fs_csmask;
	__u32	fs_csshift;
	__u32	fs_nindir;
	__u32	fs_inopb;
	__u32	fs_nspf;
	__u32	fs_optim;
	__u32	fs_XXX1;
	__u32	fs_interleave;
	__u32	fs_trackskew;
	__u32	fs_id[2];
	__u32	fs_csaddr;
	__u32	fs_cssize;
	__u32	fs_cgsize;
	__u32	fs_ntrak;
	__u32	fs_nsect;
	__u32	fs_spc;
	__u32	fs_ncyl;
	__u32	fs_cpg;
	__u32	fs_ipg;
	__u32	fs_fpg;
	struct ufs_csum fs_cstotal;
	__u8	fs_fmod;
	__u8	fs_clean;
	__u8	fs_ronly;
	__u8	fs_flags;
	__u8	fs_fsmnt[512 ];
	__u32	fs_cgrotor;
	struct ufs_csum * fs_csp[32 ];
	__u32	fs_cpc;
	__u16	fs_opostbl[16][8];	 
	__s32	fs_sparecon[55];	 
	__s32	fs_state;		 
	ufsquad	fs_qbmask;		 
	ufsquad	fs_qfmask;		 
	__s32	fs_postblformat;	 
	__s32	fs_nrpos;		 
	__s32	fs_postbloff;		 
	__s32	fs_rotbloff;		 
	__s32	fs_magic;		 
	__u8	fs_space[1];		 

};

 


struct ufs_inode {
	__u16	ui_mode;		 
	__u16	ui_nlink;		 
	__u16	ui_suid;		 
	__u16	ui_sgid;		 
	ufsquad	ui_size;		    
	struct timeval ui_atime;	 
	struct timeval ui_mtime;	 
	struct timeval ui_ctime;	 
	__u32	ui_db[12 ];		 
	__u32	ui_ib[3 ];		 
	__u32	ui_flags;		 
	__u32	ui_blocks;		 
	__u32	ui_gen;			 
	__u32	ui_shadow;		 
	__u32	ui_uid;			 
	__u32	ui_gid;			 
	__u32	ui_oeftflag;		 
};

extern int init_ufs_fs(void);


 








# 16 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/ufs_fs_i.h" 2


struct ufs_inode_info {
	__u64	ui_size;
	__u32	ui_flags;
	__u32	ui_gen;
	__u32	ui_shadow;
	__u32	ui_uid;
	__u32	ui_gid;
	__u32	ui_oeftflag;
	__u32	ui_db[ __MS__41 12  __ME__ ];
	__u32	ui_ib[ __MS__41 3  __ME__ ];
};


# 229 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/fs.h" 2


 














 








struct iattr {
	unsigned int	ia_valid;
	umode_t		ia_mode;
	uid_t		ia_uid;
	gid_t		ia_gid;
	off_t		ia_size;
	time_t		ia_atime;
	time_t		ia_mtime;
	time_t		ia_ctime;
};

# 1 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/quota.h" 1
 








































# 1 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/errno.h" 1



# 1 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/asm/errno.h" 1

































































































































# 4 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/errno.h" 2




 








# 42 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/quota.h" 2


 






 





 















 














 


















 




struct dqblk {
    __u32 dqb_bhardlimit;	 
    __u32 dqb_bsoftlimit;	 
    __u32 dqb_curblocks;	 
    __u32 dqb_ihardlimit;	 
    __u32 dqb_isoftlimit;	 
    __u32 dqb_curinodes;	 
    time_t dqb_btime;		 
    time_t dqb_itime;		 
};

 













struct dqstats {
   __u32 lookups;
   __u32 drops;
   __u32 reads;
   __u32 writes;
   __u32 cache_hits;
   __u32 pages_allocated;
   __u32 allocated_dquots;
   __u32 free_dquots;
   __u32 syncs;
};



# 1 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/mount.h" 1
 












struct vfsmount
{
   kdev_t mnt_dev;                      
   char *mnt_devname;                   
   char *mnt_dirname;                   
   unsigned int mnt_flags;              
   struct semaphore mnt_sem;            
   struct super_block *mnt_sb;          
   struct file *mnt_quotas[ __MS__48 2  __ME__ ];  
   time_t mnt_iexp[ __MS__48 2  __ME__ ];          
   time_t mnt_bexp[ __MS__48 2  __ME__ ];          
   struct vfsmount *mnt_next;           
};

struct vfsmount *lookup_vfsmnt(kdev_t dev);


# 151 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/quota.h" 2


 












struct dquot {
   unsigned int dq_id;		 
   short dq_type;		 
   kdev_t dq_dev;                 
   short dq_flags;		 
   short dq_count;		 
   struct vfsmount *dq_mnt;      
   struct dqblk dq_dqb;          
   struct wait_queue *dq_wait;	 
   struct dquot *dq_prev;	 
   struct dquot *dq_next;	 
   struct dquot *dq_hash_prev;	 
   struct dquot *dq_hash_next;	 
};



 










 



extern void dquot_initialize(struct inode *inode, short type);
extern void dquot_drop(struct inode *inode);
extern int dquot_alloc_block(const struct inode *inode, unsigned long number);
extern int dquot_alloc_inode(const struct inode *inode, unsigned long number);
extern void dquot_free_block(const struct inode *inode, unsigned long number);
extern void dquot_free_inode(const struct inode *inode, unsigned long number);
extern int dquot_transfer(struct inode *inode, struct iattr *iattr, char direction);

extern void invalidate_dquots(kdev_t dev, short type);
extern int quota_off(kdev_t dev, short type);
extern int sync_dquots(kdev_t dev, short type);

# 218 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/quota.h"


# 266 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/fs.h" 2


struct inode {
	kdev_t		i_dev;
	unsigned long	i_ino;
	umode_t		i_mode;
	nlink_t		i_nlink;
	uid_t		i_uid;
	gid_t		i_gid;
	kdev_t		i_rdev;
	off_t		i_size;
	time_t		i_atime;
	time_t		i_mtime;
	time_t		i_ctime;
	unsigned long	i_blksize;
	unsigned long	i_blocks;
	unsigned long	i_version;
	unsigned long	i_nrpages;
	struct semaphore i_sem;
	struct inode_operations *i_op;
	struct super_block *i_sb;
	struct wait_queue *i_wait;
	struct file_lock *i_flock;
	struct vm_area_struct *i_mmap;
	struct page *i_pages;
	struct dquot *i_dquot[ __MS__48 2  __ME__ ];
	struct inode *i_next, *i_prev;
	struct inode *i_hash_next, *i_hash_prev;
	struct inode *i_bound_to, *i_bound_by;
	struct inode *i_mount;
	unsigned short i_count;
	unsigned short i_flags;
	unsigned char i_lock;
	unsigned char i_dirt;
	unsigned char i_pipe;
	unsigned char i_sock;
	unsigned char i_seek;
	unsigned char i_update;
	unsigned short i_writecount;
	union {
		struct pipe_inode_info pipe_i;
		struct minix_inode_info minix_i;
		struct ext_inode_info ext_i;
		struct ext2_inode_info ext2_i;
		struct hpfs_inode_info hpfs_i;
		struct msdos_inode_info msdos_i;
		struct umsdos_inode_info umsdos_i;
		struct iso_inode_info isofs_i;
		struct nfs_inode_info nfs_i;
		struct xiafs_inode_info xiafs_i;
		struct sysv_inode_info sysv_i;
		struct affs_inode_info affs_i;
		struct ufs_inode_info ufs_i;
		struct socket socket_i;
		void * generic_ip;
	} u;
};

struct file {
	mode_t f_mode;
	loff_t f_pos;
	unsigned short f_flags;
	unsigned short f_count;
	unsigned long f_reada, f_ramax, f_raend, f_ralen, f_rawin;
	struct file *f_next, *f_prev;
	int f_owner;		 
	struct inode * f_inode;
	struct file_operations * f_op;
	unsigned long f_version;
	void *private_data;	 
};

struct file_lock {
	struct file_lock *fl_next;	 
	struct file_lock *fl_nextlink;	 
	struct file_lock *fl_prevlink;	 
	struct file_lock *fl_block;
	struct task_struct *fl_owner;
	struct wait_queue *fl_wait;
	struct file *fl_file;
	char fl_flags;
	char fl_type;
	off_t fl_start;
	off_t fl_end;
};

# 1 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/fcntl.h" 1



# 1 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/asm/fcntl.h" 1



 



























 


 




 



 












struct flock {
	short l_type;
	short l_whence;
	off_t l_start;
	off_t l_len;
	pid_t l_pid;
};


# 4 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/fcntl.h" 2



# 352 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/fs.h" 2


extern int fcntl_getlk(unsigned int fd, struct flock *l);
extern int fcntl_setlk(unsigned int fd, unsigned int cmd, struct flock *l);
extern void locks_remove_locks(struct task_struct *task, struct file *filp);






extern int locks_mandatory_locked(struct inode *inode);
extern int locks_mandatory_area(int read_write, struct inode *inode,
				struct file *filp, unsigned int offset,
				unsigned int count);

extern inline int locks_verify_locked(struct inode *inode)
{

	 


	if ((inode->i_mode & ( __MS__46 0002000  __ME__  |  __MS__46 00010  __ME__ )) ==  __MS__46 0002000  __ME__ )
		return (locks_mandatory_locked(inode));

	return (0);
}
extern inline int locks_verify_area(int read_write, struct inode *inode,
				    struct file *filp, unsigned int offset,
				    unsigned int count)
{

	 


	if ((inode->i_mode & ( __MS__46 0002000  __ME__  |  __MS__46 00010  __ME__ )) ==  __MS__46 0002000  __ME__ )
		return (locks_mandatory_area(read_write, inode, filp, offset,
					     count));

	return (0);
}

struct fasync_struct {
	int    magic;
	struct fasync_struct	*fa_next;  
	struct file 		*fa_file;
};



extern int fasync_helper(struct inode *, struct file *, int, struct fasync_struct **);

# 1 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/minix_fs_sb.h" 1



 


struct minix_sb_info {
			unsigned long s_ninodes;
			unsigned long s_nzones;
			unsigned long s_imap_blocks;
			unsigned long s_zmap_blocks;
			unsigned long s_firstdatazone;
			unsigned long s_log_zone_size;
			unsigned long s_max_size;
			struct buffer_head * s_imap[8];
			struct buffer_head * s_zmap[64];
			unsigned long s_dirsize;
			unsigned long s_namelen;
			struct buffer_head * s_sbh;
			struct minix_super_block * s_ms;
			unsigned short s_mount_state;
			unsigned short s_version;
};


# 404 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/fs.h" 2

# 1 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/ext_fs_sb.h" 1



 


struct ext_sb_info {
			unsigned long s_ninodes;
			unsigned long s_nzones;
			unsigned long s_firstdatazone;
			unsigned long s_log_zone_size;
			unsigned long s_max_size;
			unsigned long s_firstfreeblocknumber;
			unsigned long s_freeblockscount;
			struct buffer_head * s_firstfreeblock;
			unsigned long s_firstfreeinodenumber;
			unsigned long s_freeinodescount;
			struct buffer_head * s_firstfreeinodeblock;
};


# 405 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/fs.h" 2

# 1 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/ext2_fs_sb.h" 1
 

















# 1 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/ext2_fs.h" 1
 



















 



 




 




 





 












 









 


 




 




 






























 













 


struct ext2_acl_header	 
{
	__u32	aclh_size;
	__u32	aclh_file_count;
	__u32	aclh_acle_count;
	__u32	aclh_first_acle;
};

struct ext2_acl_entry	 
{
	__u32	acle_size;
	__u16	acle_perms;	 
	__u16	acle_type;	 
	__u16	acle_tag;	 
	__u16	acle_pad1;
	__u32	acle_next;	 
					 
};

 


struct ext2_group_desc
{
	__u32	bg_block_bitmap;		 
	__u32	bg_inode_bitmap;		 
	__u32	bg_inode_table;		 
	__u16	bg_free_blocks_count;	 
	__u16	bg_free_inodes_count;	 
	__u16	bg_used_dirs_count;	 
	__u16	bg_pad;
	__u32	bg_reserved[3];
};

 













 








 










	
 







 


struct ext2_inode {
	__u16	i_mode;		 
	__u16	i_uid;		 
	__u32	i_size;		 
	__u32	i_atime;	 
	__u32	i_ctime;	 
	__u32	i_mtime;	 
	__u32	i_dtime;	 
	__u16	i_gid;		 
	__u16	i_links_count;	 
	__u32	i_blocks;	 
	__u32	i_flags;	 
	union {
		struct {
			__u32  l_i_reserved1;
		} linux1;
		struct {
			__u32  h_i_translator;
		} hurd1;
		struct {
			__u32  m_i_reserved1;
		} masix1;
	} osd1;				 
	__u32	i_block[(((12   + 1)  + 1)  + 1) ]; 
	__u32	i_version;	 
	__u32	i_file_acl;	 
	__u32	i_dir_acl;	 
	__u32	i_faddr;	 
	union {
		struct {
			__u8	l_i_frag;	 
			__u8	l_i_fsize;	 
			__u16	i_pad1;
			__u32	l_i_reserved2[2];
		} linux2;
		struct {
			__u8	h_i_frag;	 
			__u8	h_i_fsize;	 
			__u16	h_i_mode_high;
			__u16	h_i_uid_high;
			__u16	h_i_gid_high;
			__u32	h_i_author;
		} hurd2;
		struct {
			__u8	m_i_frag;	 
			__u8	m_i_fsize;	 
			__u16	m_pad1;
			__u32	m_i_reserved2[2];
		} masix2;
	} osd2;				 
};
























 





 

















 





 







 


struct ext2_super_block {
	__u32	s_inodes_count;		 
	__u32	s_blocks_count;		 
	__u32	s_r_blocks_count;	 
	__u32	s_free_blocks_count;	 
	__u32	s_free_inodes_count;	 
	__u32	s_first_data_block;	 
	__u32	s_log_block_size;	 
	__s32	s_log_frag_size;	 
	__u32	s_blocks_per_group;	 
	__u32	s_frags_per_group;	 
	__u32	s_inodes_per_group;	 
	__u32	s_mtime;		 
	__u32	s_wtime;		 
	__u16	s_mnt_count;		 
	__s16	s_max_mnt_count;	 
	__u16	s_magic;		 
	__u16	s_state;		 
	__u16	s_errors;		 
	__u16	s_minor_rev_level; 	 
	__u32	s_lastcheck;		 
	__u32	s_checkinterval;	 
	__u32	s_creator_os;		 
	__u32	s_rev_level;		 
	__u16	s_def_resuid;		 
	__u16	s_def_resgid;		 
	 












	__u32	s_first_ino; 		 
	__u16   s_inode_size; 		 
	__u16	s_block_group_nr; 	 
	__u32	s_feature_compat; 	 
	__u32	s_feature_incompat; 	 
	__u32	s_feature_ro_compat; 	 
	__u32	s_reserved[230];	 
};

 








 










 





 




struct ext2_dir_entry {
	__u32	inode;			 
	__u16	rec_len;		 
	__u16	name_len;		 
	char	name[255 ];	 
};

 









 







 



 







 
extern int ext2_permission (struct inode *, int);

 
extern int ext2_new_block (const struct inode *, unsigned long,
			   __u32 *, __u32 *, int *);
extern void ext2_free_blocks (const struct inode *, unsigned long,
			      unsigned long);
extern unsigned long ext2_count_free_blocks (struct super_block *);
extern void ext2_check_blocks_bitmap (struct super_block *);

 
extern unsigned long ext2_count_free (struct buffer_head *, unsigned);

 
extern int ext2_check_dir_entry (const char *, struct inode *,
				 struct ext2_dir_entry *, struct buffer_head *,
				 unsigned long);

 
extern int ext2_read (struct inode *, struct file *, char *, int);
extern int ext2_write (struct inode *, struct file *, char *, int);

 
extern int ext2_sync_file (struct inode *, struct file *);

 
extern struct inode * ext2_new_inode (const struct inode *, int, int *);
extern void ext2_free_inode (struct inode *);
extern unsigned long ext2_count_free_inodes (struct super_block *);
extern void ext2_check_inodes_bitmap (struct super_block *);

 
extern int ext2_bmap (struct inode *, int);

extern struct buffer_head * ext2_getblk (struct inode *, long, int, int *);
extern struct buffer_head * ext2_bread (struct inode *, int, int, int *);

extern int ext2_getcluster (struct inode * inode, long block);
extern void ext2_read_inode (struct inode *);
extern void ext2_write_inode (struct inode *);
extern void ext2_put_inode (struct inode *);
extern int ext2_sync_inode (struct inode *);
extern void ext2_discard_prealloc (struct inode *);

 
extern int ext2_ioctl (struct inode *, struct file *, unsigned int,
		       unsigned long);

 
extern void ext2_release (struct inode *, struct file *);
extern int ext2_lookup (struct inode *,const char *, int, struct inode **);
extern int ext2_create (struct inode *,const char *, int, int,
			struct inode **);
extern int ext2_mkdir (struct inode *, const char *, int, int);
extern int ext2_rmdir (struct inode *, const char *, int);
extern int ext2_unlink (struct inode *, const char *, int);
extern int ext2_symlink (struct inode *, const char *, int, const char *);
extern int ext2_link (struct inode *, struct inode *, const char *, int);
extern int ext2_mknod (struct inode *, const char *, int, int, int);
extern int ext2_rename (struct inode *, const char *, int,
			struct inode *, const char *, int, int);

 
extern void ext2_error (struct super_block *, const char *, const char *, ...)
	__attribute__ ((format (printf, 3, 4)));
extern   void ext2_panic (struct super_block *, const char *,
				   const char *, ...)
	__attribute__ ((  format (printf, 3, 4)));
extern void ext2_warning (struct super_block *, const char *, const char *, ...)
	__attribute__ ((format (printf, 3, 4)));
extern void ext2_put_super (struct super_block *);
extern void ext2_write_super (struct super_block *);
extern int ext2_remount (struct super_block *, int *, char *);
extern struct super_block * ext2_read_super (struct super_block *,void *,int);
extern int init_ext2_fs(void);
extern void ext2_statfs (struct super_block *, struct statfs *, int);

 
extern void ext2_truncate (struct inode *);

 



 
extern struct inode_operations ext2_dir_inode_operations;

 
extern struct inode_operations ext2_file_inode_operations;

 
extern struct inode_operations ext2_symlink_inode_operations;




# 19 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/ext2_fs_sb.h" 2


 



 



 


struct ext2_sb_info {
	unsigned long s_frag_size;	 
	unsigned long s_frags_per_block; 
	unsigned long s_inodes_per_block; 
	unsigned long s_frags_per_group; 
	unsigned long s_blocks_per_group; 
	unsigned long s_inodes_per_group; 
	unsigned long s_itb_per_group;	 
	unsigned long s_db_per_group;	 
	unsigned long s_desc_per_block;	 
	unsigned long s_groups_count;	 
	struct buffer_head * s_sbh;	 
	struct ext2_super_block * s_es;	 
	struct buffer_head ** s_group_desc;
	unsigned short s_loaded_inode_bitmaps;
	unsigned short s_loaded_block_bitmaps;
	unsigned long s_inode_bitmap_number[8 ];
	struct buffer_head * s_inode_bitmap[8 ];
	unsigned long s_block_bitmap_number[8 ];
	struct buffer_head * s_block_bitmap[8 ];
	int s_rename_lock;
	struct wait_queue * s_rename_wait;
	unsigned long  s_mount_opt;
	unsigned short s_resuid;
	unsigned short s_resgid;
	unsigned short s_mount_state;
	unsigned short s_pad;
	int s_addr_per_block_bits;
	int s_desc_per_block_bits;
	int s_inode_size;
	int s_first_ino;
};


# 406 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/fs.h" 2

# 1 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/hpfs_fs_sb.h" 1



struct hpfs_sb_info {
	ino_t sb_root;			 
	unsigned sb_fs_size;		 
	unsigned sb_bitmaps;		 
	unsigned sb_dirband_size;	 
	unsigned sb_dmap;		 
	unsigned sb_n_free;		 
	unsigned sb_n_free_dnodes;	 
	uid_t sb_uid;			 
	gid_t sb_gid;			 
	umode_t sb_mode;		 
	unsigned sb_lowercase : 1;	 
	unsigned sb_conv : 2;		 
};















# 407 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/fs.h" 2

# 1 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/msdos_fs_sb.h" 1



 



struct fat_mount_options {
	uid_t fs_uid;
	gid_t fs_gid;
	unsigned short fs_umask;
	unsigned char name_check;  
	unsigned char conversion;  
	unsigned quiet:1,          
		 showexec:1,       
		 sys_immutable:1,  
		 dotsOK:1,         
		 isvfat:1,         
		 unicode_xlate:1,  
		 posixfs:1,        
		 numtail:1;        
};


struct msdos_sb_info {
	unsigned short cluster_size;  
	unsigned char fats,fat_bits;  
	unsigned short fat_start,fat_length;  
	unsigned short dir_start,dir_entries;  
	unsigned short data_start;    
	unsigned long clusters;       
	struct wait_queue *fat_wait;
	int fat_lock;
	int prev_free;                
	int free_clusters;            
	struct fat_mount_options options;
};


# 408 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/fs.h" 2

# 1 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/iso_fs_sb.h" 1



 


struct isofs_sb_info {
			unsigned long s_ninodes;
			unsigned long s_nzones;
			unsigned long s_firstdatazone;
			unsigned long s_log_zone_size;
			unsigned long s_max_size;

			unsigned char s_high_sierra;  
			unsigned char s_mapping;
			unsigned char s_conversion;
			unsigned char s_rock;
			unsigned char s_name_check;  
			unsigned char s_cruft;  


			unsigned char s_unhide;
			unsigned char s_nosuid;
			unsigned char s_nodev;
			mode_t s_mode;
			gid_t s_gid;
			uid_t s_uid;
};









# 409 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/fs.h" 2

# 1 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/nfs_fs_sb.h" 1



# 1 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/rpcsock.h" 1
 









 

















 



 




 


struct rpc_timeout {
	unsigned long		to_initval,
				to_maxval,
				to_increment;
	int			to_retries;
	char			to_exponential;
};

 


struct rpc_ioreq {
	struct rpc_wait *	rq_slot;
	struct sockaddr	*	rq_addr;
	int			rq_alen;
	struct iovec		rq_svec[ __MS__21 16  __ME__ ];
	unsigned int		rq_snr;
	unsigned long		rq_slen;
	struct iovec		rq_rvec[ __MS__21 16  __ME__ ];
	unsigned int		rq_rnr;
	unsigned long		rq_rlen;
};

 


struct rpc_wait;
typedef void	(*rpc_callback_fn_t)(int, struct rpc_wait *, void *);

 



struct rpc_wait {
	struct rpc_sock *	w_sock;
	struct rpc_wait *	w_prev;
	struct rpc_wait *	w_next;
	struct rpc_ioreq *	w_req;
	int			w_result;
	struct wait_queue *	w_wait;
	rpc_callback_fn_t	w_handler;
	void *			w_cdata;
	char			w_queued;
	char			w_gotit;
	__u32			w_xid;
};

struct rpc_sock {
	struct file *		file;
	struct socket *		sock;
	struct sock *		inet;
	struct rpc_wait		waiting[32 ];
	unsigned long		cong;
	unsigned long		cwnd;
	struct rpc_wait *	pending;
	struct rpc_wait *	free;
	struct wait_queue *	backlog;
	struct wait_queue *	shutwait;
	int			shutdown;
};



 
int			rpc_call(struct rpc_sock *, struct rpc_ioreq *,
					 struct rpc_timeout *);
 



int			rpc_reserve(struct rpc_sock *, struct rpc_ioreq *, int);
void			rpc_release(struct rpc_sock *, struct rpc_ioreq *);
int			rpc_transmit(struct rpc_sock *, struct rpc_ioreq *);
int			rpc_doio(struct rpc_sock *, struct rpc_ioreq *,
					 struct rpc_timeout *, int);
struct rpc_sock	*	rpc_makesock(struct file *);
int			rpc_closesock(struct rpc_sock *);




# 4 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/nfs_fs_sb.h" 2



struct nfs_server {
	struct file *file;
	struct rpc_sock *rsock;
	struct sockaddr toaddr ;   
	int lock;
	struct wait_queue *wait;
	int flags;
	int rsize;
	int wsize;
	int timeo;
	int retrans;
	int acregmin;
	int acregmax;
	int acdirmin;
	int acdirmax;
	char hostname[256];
};

 



struct nfs_sb_info {
	struct nfs_server s_server;
	struct nfs_fh s_root;
};


# 410 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/fs.h" 2

# 1 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/xia_fs_sb.h" 1



 











struct xiafs_sb_info {
    u_long   s_nzones;
    u_long   s_ninodes;
    u_long   s_ndatazones;
    u_long   s_imap_zones;
    u_long   s_zmap_zones;
    u_long   s_firstdatazone;
    u_long   s_zone_shift;
    u_long   s_max_size;				 
    struct buffer_head * s_imap_buf[8 ];	 
    struct buffer_head * s_zmap_buf[32 ];	 
    int      s_imap_iznr[8 ];		 
    int      s_zmap_zznr[32 ];		 
    u_char   s_imap_cached;			 
    u_char   s_zmap_cached;			 
};





# 411 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/fs.h" 2

# 1 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/sysv_fs_sb.h" 1



 








struct sysv_sb_info {
	int	       s_type;		 
	unsigned int   s_block_size;	 
	unsigned int   s_block_size_1;	 
	unsigned int   s_block_size_bits;	 
	unsigned int   s_block_size_ratio;	 
	unsigned int   s_block_size_ratio_bits;	 
	char	       s_convert;	 
	char	       s_kludge_symlinks;  
	char	       s_truncate;	 
					 
	nlink_t        s_link_max;	 
	unsigned int   s_inodes_per_block;	 
	unsigned int   s_inodes_per_block_1;	 
	unsigned int   s_inodes_per_block_bits;	 
	unsigned int   s_ind_per_block;		 
	unsigned int   s_ind_per_block_1;	 
	unsigned int   s_ind_per_block_bits;	 
	unsigned int   s_ind_per_block_2;	 
	unsigned int   s_ind_per_block_2_1;	 
	unsigned int   s_ind_per_block_2_bits;	 
	unsigned int   s_ind_per_block_3;	 
	unsigned int   s_ind_per_block_block_size_1;	 
	unsigned int   s_ind_per_block_block_size_bits;	 
	unsigned int   s_ind_per_block_2_block_size_1;	 
	unsigned int   s_ind_per_block_2_block_size_bits;  
	unsigned int   s_ind0_size;		 
	unsigned int   s_ind1_size;		 
	unsigned int   s_ind2_size;		 
	unsigned int   s_toobig_block;		 
	unsigned int   s_block_base;	 
	unsigned short s_fic_size;	 
	unsigned short s_flc_size;	 
	 
	struct buffer_head *s_bh1;
	struct buffer_head *s_bh2;
	 

	char *         s_sbd1;		 
	char *         s_sbd2;		 
	unsigned short *s_sb_fic_count;	 
        unsigned short *s_sb_fic_inodes;  
	unsigned short *s_sb_total_free_inodes;  
	unsigned short *s_sb_flc_count;	 
	unsigned long  *s_sb_flc_blocks;  
	unsigned long  *s_sb_total_free_blocks; 
	unsigned long  *s_sb_time;	 
	unsigned long  *s_sb_state;	 
	 

	unsigned long  s_firstinodezone;  
	unsigned long  s_firstdatazone;	 
	unsigned long  s_ninodes;	 
	unsigned long  s_ndatazones;	 
	unsigned long  s_nzones;	 
};
 

 



















































# 412 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/fs.h" 2

# 1 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/affs_fs_sb.h" 1



 











struct affs_bm_info {
	struct buffer_head *bm_bh;	 
	int bm_firstblk;		 
	int bm_key;			 
	int bm_count;			 
};

struct affs_alloc_zone {
	short az_size;			 
	short az_count;			 
	int az_free;			 
};

struct affs_zone {
	unsigned long z_ino;		 
	struct affs_bm_info *z_bm;	 
	int z_start;			 
	int z_end;			 
	int z_az_no;			 
	unsigned long z_lru_time;	 
};

struct affs_sb_info {
	int s_partition_size;		 
	int s_root_block;		 
	int s_hashsize;			 
	unsigned long s_flags;		 
	short s_uid;			 
	short s_gid;			 
	umode_t s_mode;			 
	int s_reserved;			 
	struct buffer_head *s_root_bh;	 
	struct affs_bm_info *s_bitmap;	 
	int s_bm_count;			 
	int s_nextzone;			 
	int s_num_az;			 
	struct affs_zone *s_zones;	 
	struct affs_alloc_zone *s_alloc; 
	char *s_zonemap;		 
	char *s_prefix;			 
	int s_prefix_len;		 
	char s_volume[32];		 
};














# 413 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/fs.h" 2

# 1 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/ufs_fs_sb.h" 1
 















struct ufs_sb_info {
	struct ufs_superblock * s_raw_sb;
	__u32	s_flags;  
	__u32	s_ncg;	  
	__u32	s_ipg;	  
	__u32	s_fpg;
	__u32	s_fsize;
	__u32	s_bsize;
	__u32	s_iblkno;
	__u32	s_dblkno;
	__u32	s_cgoffset;
	__u32	s_cgmask;
	__u32	s_inopb;
	__u32	s_fsfrag;
};



 








# 414 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/fs.h" 2


struct super_block {
	kdev_t s_dev;
	unsigned long s_blocksize;
	unsigned char s_blocksize_bits;
	unsigned char s_lock;
	unsigned char s_rd_only;
	unsigned char s_dirt;
	struct file_system_type *s_type;
	struct super_operations *s_op;
	struct dquot_operations *dq_op;
	unsigned long s_flags;
	unsigned long s_magic;
	unsigned long s_time;
	struct inode * s_covered;
	struct inode * s_mounted;
	struct wait_queue * s_wait;
	union {
		struct minix_sb_info minix_sb;
		struct ext_sb_info ext_sb;
		struct ext2_sb_info ext2_sb;
		struct hpfs_sb_info hpfs_sb;
		struct msdos_sb_info msdos_sb;
		struct isofs_sb_info isofs_sb;
		struct nfs_sb_info nfs_sb;
		struct xiafs_sb_info xiafs_sb;
		struct sysv_sb_info sysv_sb;
		struct affs_sb_info affs_sb;
		struct ufs_sb_info ufs_sb;
		void *generic_sbp;
	} u;
};

 





typedef int (*filldir_t)(void *, const char *, int, off_t, ino_t);
	
struct file_operations {
	int (*lseek) (struct inode *, struct file *, off_t, int);
	int (*read) (struct inode *, struct file *, char *, int);
	int (*write) (struct inode *, struct file *, const char *, int);
	int (*readdir) (struct inode *, struct file *, void *, filldir_t);
	int (*select) (struct inode *, struct file *, int, select_table *);
	int (*ioctl) (struct inode *, struct file *, unsigned int, unsigned long);
	int (*mmap) (struct inode *, struct file *, struct vm_area_struct *);
	int (*open) (struct inode *, struct file *);
	void (*release) (struct inode *, struct file *);
	int (*fsync) (struct inode *, struct file *);
	int (*fasync) (struct inode *, struct file *, int);
	int (*check_media_change) (kdev_t dev);
	int (*revalidate) (kdev_t dev);
};

struct inode_operations {
	struct file_operations * default_file_ops;
	int (*create) (struct inode *,const char *,int,int,struct inode **);
	int (*lookup) (struct inode *,const char *,int,struct inode **);
	int (*link) (struct inode *,struct inode *,const char *,int);
	int (*unlink) (struct inode *,const char *,int);
	int (*symlink) (struct inode *,const char *,int,const char *);
	int (*mkdir) (struct inode *,const char *,int,int);
	int (*rmdir) (struct inode *,const char *,int);
	int (*mknod) (struct inode *,const char *,int,int,int);
	int (*rename) (struct inode *,const char *,int,struct inode *,const char *,int, int);
	int (*readlink) (struct inode *,char *,int);
	int (*follow_link) (struct inode *,struct inode *,int,int,struct inode **);
	int (*readpage) (struct inode *, struct page *);
	int (*writepage) (struct inode *, struct page *);
	int (*bmap) (struct inode *,int);
	void (*truncate) (struct inode *);
	int (*permission) (struct inode *, int);
	int (*smap) (struct inode *,int);
};

struct super_operations {
	void (*read_inode) (struct inode *);
	int (*notify_change) (struct inode *, struct iattr *);
	void (*write_inode) (struct inode *);
	void (*put_inode) (struct inode *);
	void (*put_super) (struct super_block *);
	void (*write_super) (struct super_block *);
	void (*statfs) (struct super_block *, struct statfs *, int);
	int (*remount_fs) (struct super_block *, int *, char *);
};

struct dquot_operations {
	void (*initialize) (struct inode *, short);
	void (*drop) (struct inode *);
	int (*alloc_block) (const struct inode *, unsigned long);
	int (*alloc_inode) (const struct inode *, unsigned long);
	void (*free_block) (const struct inode *, unsigned long);
	void (*free_inode) (const struct inode *, unsigned long);
	int (*transfer) (struct inode *, struct iattr *, char);
};

struct file_system_type {
	struct super_block *(*read_super) (struct super_block *, void *, int);
	const char *name;
	int requires_dev;
	struct file_system_type * next;
};

extern int register_filesystem(struct file_system_type *);
extern int unregister_filesystem(struct file_system_type *);

 __MS__7   __ME__  int sys_open(const char *, int, int);
 __MS__7   __ME__  int sys_close(unsigned int);		 

extern void kill_fasync(struct fasync_struct *fa, int sig);

extern int getname(const char * filename, char **result);
extern void putname(char * name);
extern int do_truncate(struct inode *, unsigned long);
extern int register_blkdev(unsigned int, const char *, struct file_operations *);
extern int unregister_blkdev(unsigned int major, const char * name);
extern int blkdev_open(struct inode * inode, struct file * filp);
extern void blkdev_release (struct inode * inode);
extern struct file_operations def_blk_fops;
extern struct inode_operations blkdev_inode_operations;

extern int register_chrdev(unsigned int, const char *, struct file_operations *);
extern int unregister_chrdev(unsigned int major, const char * name);
extern int chrdev_open(struct inode * inode, struct file * filp);
extern struct file_operations def_chr_fops;
extern struct inode_operations chrdev_inode_operations;

extern void init_fifo(struct inode * inode);
extern struct inode_operations fifo_inode_operations;

extern struct file_operations connecting_fifo_fops;
extern struct file_operations read_fifo_fops;
extern struct file_operations write_fifo_fops;
extern struct file_operations rdwr_fifo_fops;
extern struct file_operations read_pipe_fops;
extern struct file_operations write_pipe_fops;
extern struct file_operations rdwr_pipe_fops;

extern struct file_system_type *get_fs_type(const char *name);

extern int fs_may_mount(kdev_t dev);
extern int fs_may_umount(kdev_t dev, struct inode * mount_root);
extern int fs_may_remount_ro(kdev_t dev);

extern struct file *first_file;
extern struct super_block super_blocks[64 ];

extern void refile_buffer(struct buffer_head * buf);
extern void set_writetime(struct buffer_head * buf, int flag);
extern void refill_freelist(int size);
extern int try_to_free_buffer(struct buffer_head*, struct buffer_head**, int);

extern int nr_buffers;
extern int buffermem;
extern int nr_buffer_heads;









void mark_buffer_uptodate(struct buffer_head * bh, int on);

extern inline void mark_buffer_clean(struct buffer_head * bh)
{
	if (clear_bit(1 , &bh->b_state)) {
		if (bh->b_list == 4 )
			refile_buffer(bh);
	}
}

extern inline void mark_buffer_dirty(struct buffer_head * bh, int flag)
{
	if (!set_bit(1 , &bh->b_state)) {
		set_writetime(bh, flag);
		if (bh->b_list != 4 )
			refile_buffer(bh);
	}
}

extern int check_disk_change(kdev_t dev);
extern void invalidate_inodes(kdev_t dev);
extern void invalidate_inode_pages(struct inode *);
extern void invalidate_buffers(kdev_t dev);
extern int floppy_is_wp(int minor);
extern void sync_inodes(kdev_t dev);
extern void sync_dev(kdev_t dev);
extern int fsync_dev(kdev_t dev);
extern void sync_supers(kdev_t dev);
extern int bmap(struct inode * inode,int block);
extern int notify_change(struct inode *, struct iattr *);
extern int namei(const char * pathname, struct inode ** res_inode);
extern int lnamei(const char * pathname, struct inode ** res_inode);
extern int permission(struct inode * inode,int mask);
extern int get_write_access(struct inode *inode);
extern void put_write_access(struct inode *inode);
extern int open_namei(const char * pathname, int flag, int mode,
	struct inode ** res_inode, struct inode * base);
extern int do_mknod(const char * filename, int mode, dev_t dev);
extern int do_pipe(int *);
extern void iput(struct inode * inode);
extern struct inode * __iget(struct super_block * sb,int nr,int crsmnt);
extern struct inode * get_empty_inode(void);
extern void insert_inode_hash(struct inode *);
extern void clear_inode(struct inode *);
extern struct inode * get_pipe_inode(void);
extern int get_unused_fd(void);
extern void put_unused_fd(int);
extern struct file * get_empty_filp(void);
extern int close_fp(struct file *filp);
extern struct buffer_head * get_hash_table(kdev_t dev, int block, int size);
extern struct buffer_head * getblk(kdev_t dev, int block, int size);
extern void ll_rw_block(int rw, int nr, struct buffer_head * bh[]);
extern void ll_rw_page(int rw, kdev_t dev, unsigned long nr, char * buffer);
extern void ll_rw_swap_file(int rw, kdev_t dev, unsigned int *b, int nb, char *buffer);
extern int is_read_only(kdev_t dev);
extern void __brelse(struct buffer_head *buf);
extern inline void brelse(struct buffer_head *buf)
{
	if (buf)
		__brelse(buf);
}
extern void __bforget(struct buffer_head *buf);
extern inline void bforget(struct buffer_head *buf)
{
	if (buf)
		__bforget(buf);
}
extern void set_blocksize(kdev_t dev, int size);
extern struct buffer_head * bread(kdev_t dev, int block, int size);
extern struct buffer_head * breada(kdev_t dev,int block, int size, 
				   unsigned int pos, unsigned int filesize);

extern int generic_readpage(struct inode *, struct page *);
extern int generic_file_read(struct inode *, struct file *, char *, int);
extern int generic_file_mmap(struct inode *, struct file *, struct vm_area_struct *);
extern int brw_page(int, struct page *, kdev_t, int [], int, int);

extern void put_super(kdev_t dev);
unsigned long generate_cluster(kdev_t dev, int b[], int size);
extern kdev_t ROOT_DEV;

extern void show_buffers(void);
extern void mount_root(void);


extern kdev_t real_root_dev;
extern int change_root(kdev_t new_root_dev,const char *put_old);


extern int char_read(struct inode *, struct file *, char *, int);
extern int block_read(struct inode *, struct file *, char *, int);
extern int read_ahead[];

extern int char_write(struct inode *, struct file *, const char *, int);
extern int block_write(struct inode *, struct file *, const char *, int);

extern int block_fsync(struct inode *, struct file *);
extern int file_fsync(struct inode *, struct file *);

extern void dcache_add(struct inode *, const char *, int, unsigned long);
extern int dcache_lookup(struct inode *, const char *, int, unsigned long *);

extern int inode_change_ok(struct inode *, struct iattr *);
extern void inode_setattr(struct inode *, struct iattr *);

extern inline struct inode * iget(struct super_block * sb,int nr)
{
	return __iget(sb, nr, 1);
}

 
# 1 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/minix_fs.h" 1



 



 







 



















 



struct minix_inode {
	__u16 i_mode;
	__u16 i_uid;
	__u32 i_size;
	__u32 i_time;
	__u8  i_gid;
	__u8  i_nlinks;
	__u16 i_zone[9];
};

 





struct minix2_inode {
	__u16 i_mode;
	__u16 i_nlinks;
	__u16 i_uid;
	__u16 i_gid;
	__u32 i_size;
	__u32 i_atime;
	__u32 i_mtime;
	__u32 i_ctime;
	__u32 i_zone[10];
};

 


struct minix_super_block {
	__u16 s_ninodes;
	__u16 s_nzones;
	__u16 s_imap_blocks;
	__u16 s_zmap_blocks;
	__u16 s_firstdatazone;
	__u16 s_log_zone_size;
	__u32 s_max_size;
	__u16 s_magic;
	__u16 s_state;
	__u32 s_zones;
};

struct minix_dir_entry {
	__u16 inode;
	char name[0];
};



extern int minix_lookup(struct inode * dir,const char * name, int len,
                        struct inode ** result);
extern int minix_create(struct inode * dir,const char * name, int len, int mode,
	struct inode ** result);
extern int minix_mkdir(struct inode * dir, const char * name, int len, int mode);
extern int minix_rmdir(struct inode * dir, const char * name, int len);
extern int minix_unlink(struct inode * dir, const char * name, int len);
extern int minix_symlink(struct inode * inode, const char * name, int len,
	const char * symname);
extern int minix_link(struct inode * oldinode, struct inode * dir, const char * name, int len);
extern int minix_mknod(struct inode * dir, const char * name, int len, int mode, int rdev);
extern int minix_rename(struct inode * old_dir, const char * old_name, int old_len,
	struct inode * new_dir, const char * new_name, int new_len, int must_be_dir);
extern struct inode * minix_new_inode(const struct inode * dir);
extern void minix_free_inode(struct inode * inode);
extern unsigned long minix_count_free_inodes(struct super_block *sb);
extern int minix_new_block(struct super_block * sb);
extern void minix_free_block(struct super_block * sb, int block);
extern unsigned long minix_count_free_blocks(struct super_block *sb);

extern int minix_bmap(struct inode *,int);

extern struct buffer_head * minix_getblk(struct inode *, int, int);
extern struct buffer_head * minix_bread(struct inode *, int, int);

extern void minix_truncate(struct inode *);
extern void minix_put_super(struct super_block *);
extern struct super_block *minix_read_super(struct super_block *,void *,int);
extern int init_minix_fs(void);
extern void minix_write_super(struct super_block *);
extern int minix_remount (struct super_block * sb, int * flags, char * data);
extern void minix_read_inode(struct inode *);
extern void minix_write_inode(struct inode *);
extern void minix_put_inode(struct inode *);
extern void minix_statfs(struct super_block *, struct statfs *, int);
extern int minix_sync_inode(struct inode *);
extern int minix_sync_file(struct inode *, struct file *);

extern struct inode_operations minix_file_inode_operations;
extern struct inode_operations minix_dir_inode_operations;
extern struct inode_operations minix_symlink_inode_operations;




# 693 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/fs.h" 2






# 9 "binfmt_aout.c" 2

# 1 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/sched.h" 1



 







# 1 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/asm/param.h" 1




















# 12 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/sched.h" 2


extern unsigned long event;

# 1 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/binfmts.h" 1



# 1 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/ptrace.h" 1


 
 

 

















# 1 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/asm/ptrace.h" 1






















 


struct pt_regs {
	long ebx;
	long ecx;
	long edx;
	long esi;
	long edi;
	long ebp;
	long eax;
	unsigned short ds, __dsu;
	unsigned short es, __esu;
	unsigned short fs, __fsu;
	unsigned short gs, __gsu;
	long orig_eax;
	long eip;
	unsigned short cs, __csu;
	long eflags;
	long esp;
	unsigned short ss, __ssu;
};




extern void show_regs(struct pt_regs *);



# 24 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/ptrace.h" 2



# 4 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/binfmts.h" 2


 






 


struct linux_binprm{
	char buf[128];
	unsigned long page[32 ];
	unsigned long p;
	int sh_bang;
	struct inode * inode;
	int e_uid, e_gid;
	int argc, envc;
	char * filename;	 
	unsigned long loader, exec;
	int dont_iput;		 
};

 



struct linux_binfmt {
	struct linux_binfmt * next;
	long *use_count;
	int (*load_binary)(struct linux_binprm *, struct  pt_regs * regs);
	int (*load_shlib)(int fd);
	int (*core_dump)(long signr, struct pt_regs * regs);
};

extern int register_binfmt(struct linux_binfmt *);
extern int unregister_binfmt(struct linux_binfmt *);

extern int read_exec(struct inode *inode, unsigned long offset,
	char * addr, unsigned long count, int to_kmem);

extern int open_inode(struct inode * inode, int mode);

extern int init_elf_binfmt(void);
extern int init_aout_binfmt(void);
extern int init_script_binfmt(void);
extern int init_java_binfmt(void);

extern int prepare_binprm(struct linux_binprm *);
extern void remove_arg_zero(struct linux_binprm *);
extern int search_binary_handler(struct linux_binprm *,struct pt_regs *);
extern void flush_old_exec(struct linux_binprm * bprm);
extern unsigned long setup_arg_pages(unsigned long p, struct linux_binprm * bprm);
extern unsigned long copy_strings(int argc,char ** argv,unsigned long *page,
		unsigned long p, int from_kmem);

 



# 16 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/sched.h" 2

# 1 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/personality.h" 1







 



 












 
typedef  __MS__7   __ME__  void (*lcall7_func)(struct pt_regs *);


 




struct exec_domain {
	const char *name;
	lcall7_func handler;
	unsigned char pers_low, pers_high;
	unsigned long * signal_map;
	unsigned long * signal_invmap;
	long *use_count;
	struct exec_domain *next;
};

extern struct exec_domain default_exec_domain;

extern struct exec_domain *lookup_exec_domain(unsigned long personality);
extern int register_exec_domain(struct exec_domain *it);
extern int unregister_exec_domain(struct exec_domain *it);
 __MS__7   __ME__  int sys_personality(unsigned long personality);


# 17 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/sched.h" 2

# 1 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/tasks.h" 1



 


 












# 18 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/sched.h" 2



# 1 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/asm/system.h" 1



# 1 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/asm/segment.h" 1











 







 




extern int bad_user_access_length(void);

 



struct __segment_dummy { unsigned long a[100]; };



static inline void __put_user(unsigned long x, void * y, int size)
{
}

static inline unsigned long __get_user(const void * y, int size)
{
}

static inline void __generic_memcpy_tofs(void * to, const void * from, unsigned long n)
{
}

static inline void __constant_memcpy_tofs(void * to, const void * from, unsigned long n)
{
	switch (n) {
		case 0:
			return;
		case 1:
			__put_user(*(const char *) from, (char *) to, 1);
			return;
		case 2:
			__put_user(*(const short *) from, (short *) to, 2);
			return;
		case 3:
			__put_user(*(const short *) from, (short *) to, 2);
			__put_user(*(2+(const char *) from), 2+(char *) to, 1);
			return;
		case 4:
			__put_user(*(const int *) from, (int *) to, 4);
			return;
		case 8:
			__put_user(*(const int *) from, (int *) to, 4);
			__put_user(*(1+(const int *) from), 1+(int *) to, 4);
			return;
		case 12:
			__put_user(*(const int *) from, (int *) to, 4);
			__put_user(*(1+(const int *) from), 1+(int *) to, 4);
			__put_user(*(2+(const int *) from), 2+(int *) to, 4);
			return;
		case 16:
			__put_user(*(const int *) from, (int *) to, 4);
			__put_user(*(1+(const int *) from), 1+(int *) to, 4);
			__put_user(*(2+(const int *) from), 2+(int *) to, 4);
			__put_user(*(3+(const int *) from), 3+(int *) to, 4);
			return;
	}


	switch (n % 4) {
		case 0:
			 ;
			return;
		case 1:
			 ;
			return;
		case 2:
			 ;
			return;
		case 3:
			 ;
			return;
	}

}

static inline void __generic_memcpy_fromfs(void * to, const void * from, unsigned long n)
{
}

static inline void __constant_memcpy_fromfs(void * to, const void * from, unsigned long n)
{
	switch (n) {
		case 0:
			return;
		case 1:
			*(char *)to = __get_user((const char *) from, 1);
			return;
		case 2:
			*(short *)to = __get_user((const short *) from, 2);
			return;
		case 3:
			*(short *) to = __get_user((const short *) from, 2);
			*((char *) to + 2) = __get_user(2+(const char *) from, 1);
			return;
		case 4:
			*(int *) to = __get_user((const int *) from, 4);
			return;
		case 8:
			*(int *) to = __get_user((const int *) from, 4);
			*(1+(int *) to) = __get_user(1+(const int *) from, 4);
			return;
		case 12:
			*(int *) to = __get_user((const int *) from, 4);
			*(1+(int *) to) = __get_user(1+(const int *) from, 4);
			*(2+(int *) to) = __get_user(2+(const int *) from, 4);
			return;
		case 16:
			*(int *) to = __get_user((const int *) from, 4);
			*(1+(int *) to) = __get_user(1+(const int *) from, 4);
			*(2+(int *) to) = __get_user(2+(const int *) from, 4);
			*(3+(int *) to) = __get_user(3+(const int *) from, 4);
			return;
	}


	switch (n % 4) {
		case 0:
			 ;
			return;
		case 1:
			 ;
			return;
		case 2:
			 ;
			return;
		case 3:
			 ;
			return;
	}

}











 













# 213 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/asm/segment.h"


 






static inline unsigned long get_fs(void)
{
	unsigned long _v;
	return _v;
}

static inline unsigned long get_ds(void)
{
	unsigned long _v;
	return _v;
}

static inline void set_fs(unsigned long val)
{
}




# 4 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/asm/system.h" 2


 





















 




 








 
# 78 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/asm/system.h"


# 89 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/asm/system.h"









static inline unsigned long _get_base(char * addr)
{
	unsigned long __base;
	return __base;
}



static inline unsigned long get_limit(unsigned long segment)
{
	unsigned long __limit;
	return __limit+1;
}



 









struct __xchg_dummy { unsigned long a[100]; };


static inline unsigned long __xchg(unsigned long x, void * ptr, int size)
{
	switch (size) {
		case 1:
			break;
		case 2:
			break;
		case 4:
			break;
	}
	return x;
}




























# 175 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/asm/system.h"







 



extern struct desc_struct default_ldt;

 



void disable_hlt(void);
void enable_hlt(void);


# 21 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/sched.h" 2


# 1 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/asm/page.h" 1



 









 


typedef struct { unsigned long pte; } pte_t;
typedef struct { unsigned long pmd; } pmd_t;
typedef struct { unsigned long pgd; } pgd_t;
typedef struct { unsigned long pgprot; } pgprot_t;











# 51 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/asm/page.h"


 


 






# 23 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/sched.h" 2


# 1 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/smp.h" 1



 




# 42 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/smp.h"


 


 







# 25 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/sched.h" 2

# 1 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/tty.h" 1



 



 






		 




# 1 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/termios.h" 1




# 1 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/asm/termios.h" 1



# 1 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/asm/termbits.h" 1





typedef unsigned char	cc_t;
typedef unsigned int	speed_t;
typedef unsigned int	tcflag_t;


struct termios {
	tcflag_t c_iflag;		 
	tcflag_t c_oflag;		 
	tcflag_t c_cflag;		 
	tcflag_t c_lflag;		 
	cc_t c_line;			 
	cc_t c_cc[19 ];		 
};

 


















 















 
































 






































 
















 





 




 





# 4 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/asm/termios.h" 2

# 1 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/asm/ioctls.h" 1





 
























































 











# 5 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/asm/termios.h" 2


struct winsize {
	unsigned short ws_row;
	unsigned short ws_col;
	unsigned short ws_xpixel;
	unsigned short ws_ypixel;
};


struct termio {
	unsigned short c_iflag;		 
	unsigned short c_oflag;		 
	unsigned short c_cflag;		 
	unsigned short c_lflag;		 
	unsigned char c_line;		 
	unsigned char c_cc[8 ];	 
};


 








 












 

 








# 1 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/string.h" 1













extern char * ___strtok;
extern char * strcpy(char *,const char *);
extern char * strncpy(char *,const char *, __kernel_size_t);
extern char * strcat(char *, const char *);
extern char * strncat(char *, const char *, __kernel_size_t);
extern char * strchr(const char *,int);
extern char * strrchr(const char *,int);
extern char * strpbrk(const char *,const char *);
extern char * strtok(char *,const char *);
extern char * strstr(const char *,const char *);
extern __kernel_size_t strlen(const char *);
extern __kernel_size_t strnlen(const char *,__kernel_size_t);
extern __kernel_size_t strspn(const char *,const char *);
extern int strcmp(const char *,const char *);
extern int strncmp(const char *,const char *,__kernel_size_t);

extern void * memset(void *,int,__kernel_size_t);
   
extern void * memmove(void *,const void *,__kernel_size_t);
extern void * memscan(void *,int,__kernel_size_t);
   

 


# 1 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/asm/string.h" 1



 












 












extern inline char * strcpy(char * dest,const char *src)
{
return dest;
}


extern inline char * strncpy(char * dest,const char *src,size_t count)
{
return dest;
}


extern inline char * strcat(char * dest,const char * src)
{
return dest;
}


extern inline char * strncat(char * dest,const char * src,size_t count)
{
return dest;
}


extern inline int strcmp(const char * cs,const char * ct)
{
register int __res;
return __res;
}


extern inline int strncmp(const char * cs,const char * ct,size_t count)
{
register int __res;
return __res;
}


extern inline char * strchr(const char * s, int c)
{
register char * __res;
return __res;
}


extern inline char * strrchr(const char * s, int c)
{
register char * __res;
return __res;
}


extern inline size_t strspn(const char * cs, const char * ct)
{
register char * __res;
return __res-cs;
}


extern inline size_t strcspn(const char * cs, const char * ct)
{
register char * __res;
return __res-cs;
}


extern inline char * strpbrk(const char * cs,const char * ct)
{
register char * __res;
return __res;
}


extern inline char * strstr(const char * cs,const char * ct)
{
register char * __res;
return __res;
}


extern inline size_t strlen(const char * s)
{
register int __res;
return __res;
}


extern inline char * strtok(char * s,const char * ct)
{
register char * __res;
return __res;
}

extern inline void * __memcpy(void * to, const void * from, size_t n)
{
return (to);
}

 



extern inline void * __constant_memcpy(void * to, const void * from, size_t n)
{
	switch (n) {
		case 0:
			return to;
		case 1:
			*(unsigned char *)to = *(const unsigned char *)from;
			return to;
		case 2:
			*(unsigned short *)to = *(const unsigned short *)from;
			return to;
		case 3:
			*(unsigned short *)to = *(const unsigned short *)from;
			*(2+(unsigned char *)to) = *(2+(const unsigned char *)from);
			return to;
		case 4:
			*(unsigned long *)to = *(const unsigned long *)from;
			return to;
		case 8:
			*(unsigned long *)to = *(const unsigned long *)from;
			*(1+(unsigned long *)to) = *(1+(const unsigned long *)from);
			return to;
		case 12:
			*(unsigned long *)to = *(const unsigned long *)from;
			*(1+(unsigned long *)to) = *(1+(const unsigned long *)from);
			*(2+(unsigned long *)to) = *(2+(const unsigned long *)from);
			return to;
		case 16:
			*(unsigned long *)to = *(const unsigned long *)from;
			*(1+(unsigned long *)to) = *(1+(const unsigned long *)from);
			*(2+(unsigned long *)to) = *(2+(const unsigned long *)from);
			*(3+(unsigned long *)to) = *(3+(const unsigned long *)from);
			return to;
		case 20:
			*(unsigned long *)to = *(const unsigned long *)from;
			*(1+(unsigned long *)to) = *(1+(const unsigned long *)from);
			*(2+(unsigned long *)to) = *(2+(const unsigned long *)from);
			*(3+(unsigned long *)to) = *(3+(const unsigned long *)from);
			*(4+(unsigned long *)to) = *(4+(const unsigned long *)from);
			return to;
	}


	switch (n % 4) {
		case 0:  ; return to;
		case 1:  ; return to;
		case 2:  ; return to;
		case 3:  ; return to;
	}

}








extern inline void * memmove(void * dest,const void * src, size_t n)
{
return dest;
}




extern inline void * memchr(const void * cs,int c,size_t count)
{
register void * __res;
if (!count)
	return  __MS__11 ((void *) 0)  __ME__ ;
return __res;
}

extern inline void * __memset_generic(void * s, char c,size_t count)
{
return s;
}

 


 




extern inline void * __constant_c_memset(void * s, unsigned long c, size_t count)
{
return (s);	
}

 

extern inline size_t strnlen(const char * s, size_t count)
{
register int __res;
return __res;
}
 

 



extern inline void * __constant_c_and_count_memset(void * s, unsigned long pattern, size_t count)
{
	switch (count) {
		case 0:
			return s;
		case 1:
			*(unsigned char *)s = pattern;
			return s;
		case 2:
			*(unsigned short *)s = pattern;
			return s;
		case 3:
			*(unsigned short *)s = pattern;
			*(2+(unsigned char *)s) = pattern;
			return s;
		case 4:
			*(unsigned long *)s = pattern;
			return s;
	}



}

















 



extern inline void * memscan(void * addr, int c, size_t size)
{
	if (!size)
		return addr;
	return addr;
}



# 39 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/string.h" 2







# 58 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/asm/termios.h" 2


 


extern inline void trans_from_termio(struct termio * termio,
	struct termios * termios)
{

	(*(unsigned short *)(& termios->c_iflag ) = (  termio->c_iflag )) ;
	(*(unsigned short *)(& termios->c_oflag ) = (  termio->c_oflag )) ;
	(*(unsigned short *)(& termios->c_cflag ) = (  termio->c_cflag )) ;
	(*(unsigned short *)(& termios->c_lflag ) = (  termio->c_lflag )) ;

	 __MS__85 (__builtin_constant_p( __ME__   8   __MS__85 ) ? __constant_memcpy(( __ME__  termios->c_cc  __MS__85 ),( __ME__   termio->c_cc  __MS__85 ),( __ME__   8   __MS__85 )) : __memcpy(( __ME__  termios->c_cc  __MS__85 ),( __ME__   termio->c_cc  __MS__85 ),( __ME__   8   __MS__85 )))  __ME__ ;
}

 


extern inline void trans_to_termio(struct termios * termios,
	struct termio * termio)
{
	termio->c_iflag = termios->c_iflag;
	termio->c_oflag = termios->c_oflag;
	termio->c_cflag = termios->c_cflag;
	termio->c_lflag = termios->c_lflag;
	termio->c_line	= termios->c_line;
	 __MS__85 (__builtin_constant_p( __ME__   8   __MS__85 ) ? __constant_memcpy(( __ME__  termio->c_cc  __MS__85 ),( __ME__   termios->c_cc  __MS__85 ),( __ME__   8   __MS__85 )) : __memcpy(( __ME__  termio->c_cc  __MS__85 ),( __ME__   termios->c_cc  __MS__85 ),( __ME__   8   __MS__85 )))  __ME__ ;
}




# 5 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/termios.h" 2



# 20 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/tty.h" 2

# 1 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/tqueue.h" 1
 

















 






















struct tq_struct {
	struct tq_struct *next;		 
	int sync;			 
	void (*routine)(void *);	 
	void *data;			 
};

typedef struct tq_struct * task_queue;



extern task_queue tq_timer, tq_immediate, tq_scheduler, tq_disk;

 





















 




extern __inline__ void queue_task_irq(struct tq_struct *bh_pointer,
			       task_queue *bh_list)
{
	if (!set_bit(0,&bh_pointer->sync)) {
		bh_pointer->next = *bh_list;
		*bh_list = bh_pointer;
	}
}

 



extern __inline__ void queue_task_irq_off(struct tq_struct *bh_pointer,
				 task_queue *bh_list)
{
	if (!(bh_pointer->sync & 1)) {
		bh_pointer->sync = 1;
		bh_pointer->next = *bh_list;
		*bh_list = bh_pointer;
	}
}


 


extern __inline__ void queue_task(struct tq_struct *bh_pointer,
			   task_queue *bh_list)
{
	if (!set_bit(0,&bh_pointer->sync)) {
		unsigned long flags = 0;
		 __MS__75   __ME__ ;
		 __MS__75   __ME__ ;
		bh_pointer->next = *bh_list;
		*bh_list = bh_pointer;
		 __MS__75   __ME__ ;
	}
}

 


extern __inline__ void run_task_queue(task_queue *list)
{
	struct tq_struct *p;

	p =  __MS__75 ((__typeof__(*( __ME__  list  __MS__75 )))__xchg((unsigned long)( __ME__   __MS__11 ((void *) 0)  __ME__   __MS__75 ),( __ME__  list  __MS__75 ),sizeof(*( __ME__  list  __MS__75 ))))  __ME__ ;
	while (p) {
		void *arg;
		void (*f) (void *);
		struct tq_struct *save_p;
		arg    = p -> data;
		f      = p -> routine;
		save_p = p;
		p      = p -> next;
		save_p -> sync = 0;
		(*f)(arg);
	}
}


# 21 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/tty.h" 2

# 1 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/tty_driver.h" 1



 






























































































struct tty_driver {
	int	magic;		 
	const char	*name;
	int	name_base;	 
	short	major;		 
	short	minor_start;	 
	short	num;		 
	short	type;		 
	short	subtype;	 
	struct termios init_termios;  
	int	flags;		 
	int	*refcount;	 
	struct tty_driver *other;  

	 


	struct tty_struct **table;
	struct termios **termios;
	struct termios **termios_locked;
	
	 



	int  (*open)(struct tty_struct * tty, struct file * filp);
	void (*close)(struct tty_struct * tty, struct file * filp);
	int  (*write)(struct tty_struct * tty, int from_user,
		      const unsigned char *buf, int count);
	void (*put_char)(struct tty_struct *tty, unsigned char ch);
	void (*flush_chars)(struct tty_struct *tty);
	int  (*write_room)(struct tty_struct *tty);
	int  (*chars_in_buffer)(struct tty_struct *tty);
	int  (*ioctl)(struct tty_struct *tty, struct file * file,
		    unsigned int cmd, unsigned long arg);
	void (*set_termios)(struct tty_struct *tty, struct termios * old);
	void (*throttle)(struct tty_struct * tty);
	void (*unthrottle)(struct tty_struct * tty);
	void (*stop)(struct tty_struct *tty);
	void (*start)(struct tty_struct *tty);
	void (*hangup)(struct tty_struct *tty);
	void (*flush_buffer)(struct tty_struct *tty);
	void (*set_ldisc)(struct tty_struct *tty);

	 


	struct tty_driver *next;
	struct tty_driver *prev;
};

 


 




















 






 



 




# 22 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/tty.h" 2

# 1 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/tty_ldisc.h" 1



 






struct tty_ldisc {
	int	magic;
	int	num;
	int	flags;
	 


	int	(*open)(struct tty_struct *);
	void	(*close)(struct tty_struct *);
	void	(*flush_buffer)(struct tty_struct *tty);
	int	(*chars_in_buffer)(struct tty_struct *tty);
	int	(*read)(struct tty_struct * tty, struct file * file,
			unsigned char * buf, unsigned int nr);
	int	(*write)(struct tty_struct * tty, struct file * file,
			 const unsigned char * buf, unsigned int nr);	
	int	(*ioctl)(struct tty_struct * tty, struct file * file,
			 unsigned int cmd, unsigned long arg);
	void	(*set_termios)(struct tty_struct *tty, struct termios * old);
	int	(*select)(struct tty_struct * tty, struct inode * inode,
			  struct file * file, int sel_type,
			  struct select_table_struct *wait);
	
	 


	void	(*receive_buf)(struct tty_struct *, const unsigned char *cp,
			       char *fp, int count);
	int	(*receive_room)(struct tty_struct *);
	void	(*write_wakeup)(struct tty_struct *);
};






# 23 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/tty.h" 2





 








 



struct screen_info {
	unsigned char  orig_x;
	unsigned char  orig_y;
	unsigned char  unused1[2];
	unsigned short orig_video_page;
	unsigned char  orig_video_mode;
	unsigned char  orig_video_cols;
	unsigned short unused2;
	unsigned short orig_video_ega_bx;
	unsigned short unused3;
	unsigned char  orig_video_lines;
	unsigned char  orig_video_isVGA;
	unsigned short orig_video_points;
};

extern struct screen_info screen_info;




















 






 






struct tty_flip_buffer {
	struct tq_struct tqueue;
	unsigned char	char_buf[2*512 ];
	char		flag_buf[2*512 ];
	char		*char_buf_ptr;
	unsigned char	*flag_buf_ptr;
	int		count;
	int		buf_num;
};

 

























































































 













struct tty_struct {
	int	magic;
	struct tty_driver driver;
	struct tty_ldisc ldisc;
	struct termios *termios, *termios_locked;
	int pgrp;
	int session;
	kdev_t	device;
	unsigned long flags;
	int count;
	struct winsize winsize;
	unsigned char stopped:1, hw_stopped:1, packet:1;
	unsigned char ctrl_status;

	struct tty_struct *link;
	struct fasync_struct *fasync;
	struct tty_flip_buffer flip;
	int max_flip_cnt;
	struct wait_queue *write_wait;
	struct wait_queue *read_wait;
	void *disc_data;
	void *driver_data;


	
	 



	unsigned int column;
	unsigned char lnext:1, erasing:1, raw:1, real_raw:1, icanon:1;
	unsigned char closing:1;
	unsigned short minimum_to_wake;
	unsigned overrun_time;
	int num_overrun;
	unsigned long process_char_map[256/(8*sizeof(unsigned long))];
	char *read_buf;
	int read_head;
	int read_tail;
	int read_cnt;
	unsigned long read_flags[4096 /(8*sizeof(unsigned long))];
	int canon_data;
	unsigned long canon_head;
	unsigned int canon_column;
};

 


 


















extern void tty_write_flush(struct tty_struct *);

extern struct termios tty_std_termios;
extern struct tty_struct * redirect;
extern struct tty_ldisc ldiscs[];
extern int fg_console, last_console, want_console;

extern int kmsg_redirect;
extern struct wait_queue * keypress_wait;

extern unsigned long con_init(unsigned long);

extern int rs_init(void);
extern int lp_init(void);
extern int pty_init(void);
extern int tty_init(void);
extern int pcxe_init(void);
extern int vcs_init(void);
extern int cy_init(void);
extern int stl_init(void);
extern int stli_init(void);
extern int riscom8_init(void);
extern int baycom_init(void);

extern int tty_paranoia_check(struct tty_struct *tty, kdev_t device,
			      const char *routine);
extern char *_tty_name(struct tty_struct *tty, char *buf);
extern char *tty_name(struct tty_struct *tty);
extern void tty_wait_until_sent(struct tty_struct * tty, int timeout);
extern int tty_check_change(struct tty_struct * tty);
extern void stop_tty(struct tty_struct * tty);
extern void start_tty(struct tty_struct * tty);
extern int tty_register_ldisc(int disc, struct tty_ldisc *new_ldisc);
extern int tty_register_driver(struct tty_driver *driver);
extern int tty_unregister_driver(struct tty_driver *driver);
extern int tty_read_raw_data(struct tty_struct *tty, unsigned char *bufp,
			     int buflen);
extern void tty_write_message(struct tty_struct *tty, char *msg);

extern int is_orphaned_pgrp(int pgrp);
extern int is_ignored(int sig);
extern int tty_signal(int sig, struct tty_struct *tty);
extern void tty_hangup(struct tty_struct * tty);
extern void tty_vhangup(struct tty_struct * tty);
extern void tty_unhangup(struct file *filp);
extern int tty_hung_up_p(struct file * filp);
extern void do_SAK(struct tty_struct *tty);
extern void disassociate_ctty(int priv);

 
extern struct tty_ldisc tty_ldisc_N_TTY;

 
extern int n_tty_ioctl(struct tty_struct * tty, struct file * file,
		       unsigned int cmd, unsigned long arg);

 

extern int  rs_open(struct tty_struct * tty, struct file * filp);

 

extern int  pty_open(struct tty_struct * tty, struct file * filp);
extern int pcxe_open(struct tty_struct *tty, struct file *filp);

 

extern int con_open(struct tty_struct * tty, struct file * filp);
extern void update_screen(int new_console);
extern void console_print(const char *);

 

extern int vt_ioctl(struct tty_struct *tty, struct file * file,
		    unsigned int cmd, unsigned long arg);



# 26 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/sched.h" 2

# 1 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/sem.h" 1


# 1 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/ipc.h" 1




typedef int key_t; 		 


struct ipc_perm
{
  key_t  key;
  ushort uid;    
  ushort gid;
  ushort cuid;   
  ushort cgid;
  ushort mode;   
  ushort seq;    
};


 





 










 



 


struct ipc_kludge {
    struct msgbuf *msgp;
    long msgtyp;
};




















# 3 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/sem.h" 2


 


 








 
struct semid_ds {
  struct ipc_perm sem_perm;             
  time_t          sem_otime;            
  time_t          sem_ctime;            
  struct sem      *sem_base;            
  struct sem_queue *sem_pending;        
  struct sem_queue **sem_pending_last;  
  struct sem_undo *undo;	        
  ushort          sem_nsems;            
};

 
struct sembuf {
  ushort  sem_num;         
  short   sem_op;          
  short   sem_flg;         
};

 
union semun {
  int val;			 
  struct semid_ds *buf;		 
  ushort *array;		 
  struct seminfo *__buf;	 
  void *__pad;
};

struct  seminfo {
    int semmap;
    int semmni;
    int semmns;
    int semmnu;
    int semmsl;
    int semopm;
    int semume;
    int semusz;
    int semvmx;
    int semaem;
};







 








 
struct sem {
  short   semval;          
  short   sempid;          
};

 



 
struct sem_queue {
    struct sem_queue *	next;	  
    struct sem_queue **	prev;	  
    struct wait_queue *	sleeper;  
    struct sem_undo *	undo;	  
    int    		pid;	  
    int    		status;	  
    struct semid_ds *	sma;	  
    struct sembuf *	sops;	  
    int			nsops;	  
};

 


struct sem_undo {
    struct sem_undo *  proc_next;  
    struct sem_undo *  id_next;	   
    int		       semid;	   
    short *	       semadj;	   
};

 __MS__7   __ME__  int sys_semget (key_t key, int nsems, int semflg);
 __MS__7   __ME__  int sys_semop (int semid, struct sembuf *sops, unsigned nsops);
 __MS__7   __ME__  int sys_semctl (int semid, int semnum, int cmd, union semun arg);




# 27 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/sched.h" 2


 









 









extern unsigned long avenrun[];		 
















extern int nr_running, nr_tasks;
extern int last_pid;




# 1 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/head.h" 1



typedef struct desc_struct {
	unsigned long a,b;
} desc_table[256];

extern desc_table idt,gdt;











# 72 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/sched.h" 2


# 1 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/signal.h" 1



# 1 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/asm/signal.h" 1



typedef unsigned long sigset_t;		 



































 





 

















 














 
typedef void (*__sighandler_t)(int);





struct sigaction {
	__sighandler_t sa_handler;
	sigset_t sa_mask;
	unsigned long sa_flags;
	void (*sa_restorer)(void);
};


# 1 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/asm/sigcontext.h" 1



 







struct _fpreg {
	unsigned short significand[4];
	unsigned short exponent;
};

struct _fpstate {
	unsigned long 	cw,
			sw,
			tag,
			ipoff,
			cssel,
			dataoff,
			datasel;
	struct _fpreg	_st[8];
	unsigned long	status;
};

struct sigcontext_struct {
	unsigned short gs, __gsh;
	unsigned short fs, __fsh;
	unsigned short es, __esh;
	unsigned short ds, __dsh;
	unsigned long edi;
	unsigned long esi;
	unsigned long ebp;
	unsigned long esp;
	unsigned long ebx;
	unsigned long edx;
	unsigned long ecx;
	unsigned long eax;
	unsigned long trapno;
	unsigned long err;
	unsigned long eip;
	unsigned short cs, __csh;
	unsigned long eflags;
	unsigned long esp_at_signal;
	unsigned short ss, __ssh;
	struct _fpstate * fpstate;
	unsigned long oldmask;
	unsigned long cr2;
};


# 94 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/asm/signal.h" 2




# 4 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/signal.h" 2



# 74 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/sched.h" 2


# 1 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/param.h" 1






# 76 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/sched.h" 2

# 1 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/resource.h" 1





 



 










struct	rusage {
	struct timeval ru_utime;	 
	struct timeval ru_stime;	 
	long	ru_maxrss;		 
	long	ru_ixrss;		 
	long	ru_idrss;		 
	long	ru_isrss;		 
	long	ru_minflt;		 
	long	ru_majflt;		 
	long	ru_nswap;		 
	long	ru_inblock;		 
	long	ru_oublock;		 
	long	ru_msgsnd;		 
	long	ru_msgrcv;		 
	long	ru_nsignals;		 
	long	ru_nvcsw;		 
	long	ru_nivcsw;		 
};



struct rlimit {
	long	rlim_cur;
	long	rlim_max;
};








 



# 1 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/asm/resource.h" 1



 



















# 36 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/asm/resource.h"




# 58 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/resource.h" 2



# 77 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/sched.h" 2


# 1 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/timer.h" 1



 




 


















































struct timer_struct {
	unsigned long expires;
	void (*fn)(void);
};

extern unsigned long timer_active;
extern struct timer_struct timer_table[32];

 












struct timer_list {
	struct timer_list *next;
	struct timer_list *prev;
	unsigned long expires;
	unsigned long data;
	void (*function)(unsigned long);
};

extern void add_timer(struct timer_list * timer);
extern int  del_timer(struct timer_list * timer);

extern void it_real_fn(unsigned long);

extern inline void init_timer(struct timer_list * timer)
{
	timer->next =  __MS__11 ((void *) 0)  __ME__ ;
	timer->prev =  __MS__11 ((void *) 0)  __ME__ ;
}


# 79 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/sched.h" 2


# 1 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/asm/processor.h" 1
 








# 1 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/asm/vm86.h" 1



 





























 










 








struct vm86_regs {
 


	long ebx;
	long ecx;
	long edx;
	long esi;
	long edi;
	long ebp;
	long eax;
	long __null_ds;
	long __null_es;
	long __null_fs;
	long __null_gs;
	long orig_eax;
	long eip;
	unsigned short cs, __csh;
	long eflags;
	long esp;
	unsigned short ss, __ssh;
 


	unsigned short es, __esh;
	unsigned short ds, __dsh;
	unsigned short fs, __fsh;
	unsigned short gs, __gsh;
};

struct revectored_struct {
	unsigned long __map[8];			 
};

struct vm86_struct {
	struct vm86_regs regs;
	unsigned long flags;
	unsigned long screen_bitmap;
	unsigned long cpu_type;
	struct revectored_struct int_revectored;
	struct revectored_struct int21_revectored;
};

 






void handle_vm86_fault(struct vm86_regs *, long);
void handle_vm86_debug(struct vm86_regs *, long);




# 10 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/asm/processor.h" 2

# 1 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/asm/math_emu.h" 1





void restore_i387_soft(struct _fpstate *buf);
struct _fpstate * save_i387_soft(struct _fpstate * buf);

struct fpu_reg {
	char sign;
	char tag;
	long exp;
	unsigned sigl;
	unsigned sigh;
};


 



struct info {
	long ___orig_eip;
	long ___ret_from_system_call;
	long ___ebx;
	long ___ecx;
	long ___edx;
	long ___esi;
	long ___edi;
	long ___ebp;
	long ___eax;
	long ___ds;
	long ___es;
	long ___fs;
	long ___gs;
	long ___orig_eax;
	long ___eip;
	long ___cs;
	long ___eflags;
	long ___esp;
	long ___ss;
	long ___vm86_es;  
	long ___vm86_ds;
	long ___vm86_fs;
	long ___vm86_gs;
};


# 11 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/asm/processor.h" 2


 




extern char hard_math;
extern char x86;		 
extern char x86_vendor_id[13];
extern char x86_model;		 
extern char x86_mask;		 
extern int  x86_capability;	 
extern int  fdiv_bug;		
extern char ignore_irq13;
extern char wp_works_ok;	 
extern char hlt_works_ok;	 
extern int  have_cpuid;		 

 



extern int EISA_bus;



 





 




struct i387_hard_struct {
	long	cwd;
	long	swd;
	long	twd;
	long	fip;
	long	fcs;
	long	foo;
	long	fos;
	long	st_space[20];	 
	long	status;		 
};

struct i387_soft_struct {
	long	cwd;
	long	swd;
	long	twd;
	long	fip;
	long	fcs;
	long	foo;
	long	fos;
	long    top;
	struct fpu_reg	regs[8];	 
	unsigned char	lookahead;
	struct info	*info;
	unsigned long	entry_eip;
};

union i387_union {
	struct i387_hard_struct hard;
	struct i387_soft_struct soft;
};

struct thread_struct {
	unsigned short	back_link,__blh;
	unsigned long	esp0;
	unsigned short	ss0,__ss0h;
	unsigned long	esp1;
	unsigned short	ss1,__ss1h;
	unsigned long	esp2;
	unsigned short	ss2,__ss2h;
	unsigned long	cr3;
	unsigned long	eip;
	unsigned long	eflags;
	unsigned long	eax,ecx,edx,ebx;
	unsigned long	esp;
	unsigned long	ebp;
	unsigned long	esi;
	unsigned long	edi;
	unsigned short	es, __esh;
	unsigned short	cs, __csh;
	unsigned short	ss, __ssh;
	unsigned short	ds, __dsh;
	unsigned short	fs, __fsh;
	unsigned short	gs, __gsh;
	unsigned short	ldt, __ldth;
	unsigned short	trace, bitmap;
	unsigned long	io_bitmap[32 +1];
	unsigned long	tr;
	unsigned long	cr2, trap_no, error_code;
 
	union i387_union i387;
 
	struct vm86_struct * vm86_info;
	unsigned long screen_bitmap;
	unsigned long v86flags, v86mask, v86mode;
};




# 133 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/asm/processor.h"




static inline void start_thread(struct pt_regs * regs, unsigned long eip, unsigned long esp)
{
	regs->cs =  __MS__76 0x23  __ME__ ;
	regs->ds = regs->es = regs->ss = regs->fs = regs->gs =  __MS__76 0x2B  __ME__ ;
	regs->eip = eip;
	regs->esp = esp;
}

 


extern inline unsigned long thread_saved_pc(struct thread_struct *t)
{
	return ((unsigned long *)t->esp)[3];
}


# 81 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/sched.h" 2









 






struct sched_param {
	int sched_priority;
};







extern void sched_init(void);
extern void show_state(void);
extern void trap_init(void);

 __MS__7   __ME__  void schedule(void);

 
struct files_struct {
	int count;
	fd_set close_on_exec;
	fd_set open_fds;
	struct file * fd[ __MS__4 256  __ME__ ];
};








struct fs_struct {
	int count;
	unsigned short umask;
	struct inode * root, * pwd;
};







struct mm_struct {
	int count;
	pgd_t * pgd;
	unsigned long context;
	unsigned long start_code, end_code, start_data, end_data;
	unsigned long start_brk, brk, start_stack, start_mmap;
	unsigned long arg_start, arg_end, env_start, env_end;
	unsigned long rss, total_vm, locked_vm;
	unsigned long def_flags;
	struct vm_area_struct * mmap;
	struct vm_area_struct * mmap_avl;
	struct semaphore mmap_sem;
};


# 164 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/sched.h"

struct signal_struct {
	int count;
	struct sigaction action[32];
};





struct task_struct {
 
	volatile long state;	 
	long counter;
	long priority;
	unsigned long signal;
	unsigned long blocked;	 
	unsigned long flags;	 
	int errno;
	long debugreg[8];   
	struct exec_domain *exec_domain;
 
	struct linux_binfmt *binfmt;
	struct task_struct *next_task, *prev_task;
	struct task_struct *next_run,  *prev_run;
	unsigned long saved_kernel_stack;
	unsigned long kernel_stack_page;
	int exit_code, exit_signal;
	 
	unsigned long personality;
	int dumpable:1;
	int did_exec:1;
	 
	int pid;
	int pgrp;
	int tty_old_pgrp;
	int session;
	 
	int leader;
	int	groups[ __MS__69 32  __ME__ ];
	 




	struct task_struct *p_opptr, *p_pptr, *p_cptr, *p_ysptr, *p_osptr;
	struct wait_queue *wait_chldexit;	 
	unsigned short uid,euid,suid,fsuid;
	unsigned short gid,egid,sgid,fsgid;
	unsigned long timeout, policy, rt_priority;
	unsigned long it_real_value, it_prof_value, it_virt_value;
	unsigned long it_real_incr, it_prof_incr, it_virt_incr;
	struct timer_list real_timer;
	long utime, stime, cutime, cstime, start_time;
 
	unsigned long min_flt, maj_flt, nswap, cmin_flt, cmaj_flt, cnswap;
	int swappable:1;
	unsigned long swap_address;
	unsigned long old_maj_flt;	 
	unsigned long dec_flt;		 
	unsigned long swap_cnt;		 
 
	struct rlimit rlim[ __MS__97 10  __ME__ ];
	unsigned short used_math;
	char comm[16];
 
	int link_count;
	struct tty_struct *tty;  
 
	struct sem_undo *semundo;
	struct sem_queue *semsleeping;
 
	struct desc_struct *ldt;
 
	struct thread_struct tss;
 
	struct fs_struct *fs;
 
	struct files_struct *files;
 
	struct mm_struct *mm;
 
	struct signal_struct *sig;





};

 



					 













 







 




# 313 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/sched.h"

extern struct   mm_struct init_mm;
extern struct task_struct init_task;
extern struct task_struct *task[ __MS__74 512  __ME__ ];
extern struct task_struct *last_task_used_math;
extern struct task_struct *current_set[ __MS__74 1  __ME__ ];
 




extern unsigned long volatile jiffies;
extern unsigned long itimer_ticks;
extern unsigned long itimer_next;
extern struct timeval xtime;
extern int need_resched;
extern void do_timer(struct pt_regs *);

extern unsigned int * prof_buffer;
extern unsigned long prof_len;
extern unsigned long prof_shift;

extern int securelevel;	 



extern void sleep_on(struct wait_queue ** p);
extern void interruptible_sleep_on(struct wait_queue ** p);
extern void wake_up(struct wait_queue ** p);
extern void wake_up_interruptible(struct wait_queue ** p);
extern void wake_up_process(struct task_struct * tsk);

extern void notify_parent(struct task_struct * tsk);
extern void force_sig(unsigned long sig,struct task_struct * p);
extern int send_sig(unsigned long sig,struct task_struct * p,int priv);
extern int in_group_p(gid_t grp);

extern int request_irq(unsigned int irq,
		       void (*handler)(int, void *, struct pt_regs *),
		       unsigned long flags, 
		       const char *device,
		       void *dev_id);
extern void free_irq(unsigned int irq, void *dev_id);

 





extern inline int suser(void)
{
	if ((0+current_set[ __MS__78 0  __ME__ ]) ->euid == 0) {
		(0+current_set[ __MS__78 0  __ME__ ]) ->flags |= 0x00000100 ;
		return 1;
	}
	return 0;
}

extern void copy_thread(int, unsigned long, unsigned long, struct task_struct *, struct pt_regs *);
extern void flush_thread(void);
extern void exit_thread(void);

extern void exit_mm(struct task_struct *);
extern void exit_fs(struct task_struct *);
extern void exit_files(struct task_struct *);
extern void exit_sighand(struct task_struct *);
extern void release_thread(struct task_struct *);

extern int do_execve(char *, char **, char **, struct pt_regs *);
extern int do_fork(unsigned long, unsigned long, struct pt_regs *);


 



extern inline struct file *file_from_fd(const unsigned int fd)
{

	if (fd >=  __MS__4 256  __ME__ )
		return  __MS__11 ((void *) 0)  __ME__ ;
	 
	return (0+current_set[ __MS__78 0  __ME__ ]) ->files->fd[fd];
}
	
 




extern inline void __add_wait_queue(struct wait_queue ** p, struct wait_queue * wait)
{
	struct wait_queue *head = *p;
	struct wait_queue *next =  __MS__9 ((struct wait_queue *)(( __ME__  p  __MS__9 )-1))  __ME__ ;

	if (head)
		next = head;
	*p = wait;
	wait->next = next;
}

extern inline void add_wait_queue(struct wait_queue ** p, struct wait_queue * wait)
{
	unsigned long flags;

	 __MS__75   __ME__ ;
	 __MS__75   __ME__ ;
	__add_wait_queue(p, wait);
	 __MS__75   __ME__ ;
}

extern inline void __remove_wait_queue(struct wait_queue ** p, struct wait_queue * wait)
{
	struct wait_queue * next = wait->next;
	struct wait_queue * head = next;

	for (;;) {
		struct wait_queue * nextlist = head->next;
		if (nextlist == wait)
			break;
		head = nextlist;
	}
	head->next = next;
}

extern inline void remove_wait_queue(struct wait_queue ** p, struct wait_queue * wait)
{
	unsigned long flags;

	 __MS__75   __ME__ ;
	 __MS__75   __ME__ ;
	__remove_wait_queue(p, wait);
	 __MS__75   __ME__ ;
}

extern inline void select_wait(struct wait_queue ** wait_address, select_table * p)
{
	struct select_table_entry * entry;

	if (!p || !wait_address)
		return;
	if (p->nr >=  __MS__9 (4096 / sizeof (struct select_table_entry))  __ME__ )
		return;
 	entry = p->entry + p->nr;
	entry->wait_address = wait_address;
	entry->wait.task = (0+current_set[ __MS__78 0  __ME__ ]) ;
	entry->wait.next =  __MS__11 ((void *) 0)  __ME__ ;
	add_wait_queue(wait_address,&entry->wait);
	p->nr++;
}


# 477 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/sched.h"


# 490 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/sched.h"







# 10 "binfmt_aout.c" 2


# 1 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/mm.h" 1











extern unsigned long high_memory;


# 1 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/asm/atomic.h" 1



 










 






typedef int atomic_t;

static __inline__ void atomic_add(atomic_t i, atomic_t *v)
{
}

static __inline__ void atomic_sub(atomic_t i, atomic_t *v)
{
}

static __inline__ void atomic_inc(atomic_t *v)
{
}

static __inline__ void atomic_dec(atomic_t *v)
{
}

static __inline__ int atomic_dec_and_test(atomic_t *v)
{
	unsigned char c;

	return c != 0;
}


# 15 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/mm.h" 2





extern int verify_area(int, const void *, unsigned long);

 








 





struct vm_area_struct {
	struct mm_struct * vm_mm;	 
	unsigned long vm_start;
	unsigned long vm_end;
	pgprot_t vm_page_prot;
	unsigned short vm_flags;
 
	short vm_avl_height;
	struct vm_area_struct * vm_avl_left;
	struct vm_area_struct * vm_avl_right;
 
	struct vm_area_struct * vm_next;
 
 
 
	struct vm_area_struct * vm_next_share;
	struct vm_area_struct * vm_prev_share;
 
	struct vm_operations_struct * vm_ops;
	unsigned long vm_offset;
	struct inode * vm_inode;
	unsigned long vm_pte;			 
};

 






















 



extern pgprot_t protection_map[16];


 




struct vm_operations_struct {
	void (*open)(struct vm_area_struct * area);
	void (*close)(struct vm_area_struct * area);
	void (*unmap)(struct vm_area_struct *area, unsigned long, size_t);
	void (*protect)(struct vm_area_struct *area, unsigned long, size_t, unsigned int newprot);
	int (*sync)(struct vm_area_struct *area, unsigned long, size_t, unsigned int flags);
	void (*advise)(struct vm_area_struct *area, unsigned long, size_t, unsigned int advise);
	unsigned long (*nopage)(struct vm_area_struct * area, unsigned long address, int write_access);
	unsigned long (*wppage)(struct vm_area_struct * area, unsigned long address,
		unsigned long page);
	int (*swapout)(struct vm_area_struct *,  unsigned long, pte_t *);
	pte_t (*swapin)(struct vm_area_struct *, unsigned long, unsigned long);
};

 







typedef struct page {
	 
	struct page *next;
	struct page *prev;
	struct inode *inode;
	unsigned long offset;
	struct page *next_hash;
	atomic_t count;
	unsigned flags;	 
	unsigned dirty:16,
		 age:8;
	struct wait_queue *wait;
	struct page *prev_hash;
	struct buffer_head * buffers;
	unsigned long swap_unlock_entry;
	unsigned long map_nr;	 
} mem_map_t;

 










 











 


































































extern mem_map_t * mem_map;

 






extern unsigned long __get_free_pages(int priority, unsigned long gfporder, int dma);

extern inline unsigned long get_free_page(int priority)
{
	unsigned long page;

	page = __get_free_pages(( priority ),0,0) ;
	if (page)
		 __MS__85 (__builtin_constant_p( __ME__   0  __MS__85 ) ? (__builtin_constant_p( ( __ME__    __MS__77 (1UL << 12 )  __ME__   __MS__85 ) ) ? __constant_c_and_count_memset(( ( __ME__  (void *) page  __MS__85 ) ),( (0x01010101UL*(unsigned char) __ME__   0  __MS__85 ) ),( ( __ME__    __MS__77 (1UL << 12 )  __ME__   __MS__85 ) )) : __constant_c_memset(( ( __ME__  (void *) page  __MS__85 ) ),( (0x01010101UL*(unsigned char) __ME__   0  __MS__85 ) ),( ( __ME__    __MS__77 (1UL << 12 )  __ME__   __MS__85 ) )))  : (__builtin_constant_p( ( __ME__    __MS__77 (1UL << 12 )  __ME__   __MS__85 ) ) ? __memset_generic(( ( ( __ME__  (void *) page  __MS__85 ) ) ),( ( ( __ME__   0  __MS__85 ) ) ),( ( ( __ME__    __MS__77 (1UL << 12 )  __ME__   __MS__85 ) ) ))  : __memset_generic(( ( __ME__  (void *) page  __MS__85 ) ),( ( __ME__   0  __MS__85 ) ),( ( __ME__    __MS__77 (1UL << 12 )  __ME__   __MS__85 ) ))) )  __ME__ ;
	return page;
}

 


extern void free_pages(unsigned long addr, unsigned long order);
extern void __free_page(struct page *);

extern void show_free_areas(void);
extern unsigned long put_dirty_page(struct task_struct * tsk,unsigned long page,
	unsigned long address);

extern void free_page_tables(struct mm_struct * mm);
extern void clear_page_tables(struct task_struct * tsk);
extern int new_page_tables(struct task_struct * tsk);
extern int copy_page_tables(struct task_struct * to);

extern int zap_page_range(struct mm_struct *mm, unsigned long address, unsigned long size);
extern int copy_page_range(struct mm_struct *dst, struct mm_struct *src, struct vm_area_struct *vma);
extern int remap_page_range(unsigned long from, unsigned long to, unsigned long size, pgprot_t prot);
extern int zeromap_page_range(unsigned long from, unsigned long size, pgprot_t prot);

extern void vmtruncate(struct inode * inode, unsigned long offset);
extern void handle_mm_fault(struct vm_area_struct *vma, unsigned long address, int write_access);
extern void do_wp_page(struct task_struct * tsk, struct vm_area_struct * vma, unsigned long address, int write_access);
extern void do_no_page(struct task_struct * tsk, struct vm_area_struct * vma, unsigned long address, int write_access);

extern unsigned long paging_init(unsigned long start_mem, unsigned long end_mem);
extern void mem_init(unsigned long start_mem, unsigned long end_mem);
extern void show_mem(void);
extern void oom(struct task_struct * tsk);
extern void si_meminfo(struct sysinfo * val);

 

extern void * vmalloc(unsigned long size);
extern void * vremap(unsigned long offset, unsigned long size);
extern void vfree(void * addr);
extern int vread(char *buf, char *addr, int count);

 
extern unsigned long do_mmap(struct file * file, unsigned long addr, unsigned long len,
	unsigned long prot, unsigned long flags, unsigned long off);
extern void merge_segments(struct mm_struct *, unsigned long, unsigned long);
extern void insert_vm_struct(struct mm_struct *, struct vm_area_struct *);
extern void remove_shared_vm_struct(struct vm_area_struct *);
extern void build_mmap_avl(struct mm_struct *);
extern void exit_mmap(struct mm_struct *);
extern int do_munmap(unsigned long, size_t);
extern unsigned long get_unmapped_area(unsigned long, unsigned long);

 
extern unsigned long page_unuse(unsigned long);
extern int shrink_mmap(int, int);
extern void truncate_inode_pages(struct inode *, unsigned long);








 






 

static inline int expand_stack(struct vm_area_struct * vma, unsigned long address)
{
	unsigned long grow;

	address &=  __MS__77 (~((1UL << 12 ) -1))  __ME__ ;
	grow = vma->vm_start - address;
	if (vma->vm_end - address
	    > (unsigned long)  __MS__68 (0+current_set[ __MS__78 0  __ME__ ])  __ME__ ->rlim[ __MS__97 3  __ME__ ].rlim_cur ||
	    (vma->vm_mm->total_vm <<  __MS__77 12  __ME__ ) + grow
	    > (unsigned long)  __MS__68 (0+current_set[ __MS__78 0  __ME__ ])  __ME__ ->rlim[ __MS__97 9  __ME__ ].rlim_cur)
		return -  __MS__50 12  __ME__ ;
	vma->vm_start = address;
	vma->vm_offset -= grow;
	vma->vm_mm->total_vm += grow >>  __MS__77 12  __ME__ ;
	if (vma->vm_flags & 0x2000 )
		vma->vm_mm->locked_vm += grow >>  __MS__77 12  __ME__ ;
	return 0;
}



 
static inline struct vm_area_struct * find_vma(struct mm_struct * mm, unsigned long addr)
{
	struct vm_area_struct * result =  __MS__11 ((void *) 0)  __ME__ ;

	if (mm) {
		struct vm_area_struct * tree = mm->mmap_avl;
		for (;;) {
			if (tree == (struct vm_area_struct *)  __MS__11 ((void *) 0)  __ME__  )
				break;
			if (tree->vm_end > addr) {
				result = tree;
				if (tree->vm_start <= addr)
					break;
				tree = tree->vm_avl_left;
			} else
				tree = tree->vm_avl_right;
		}
	}
	return result;
}

 

static inline struct vm_area_struct * find_vma_intersection(struct mm_struct * mm, unsigned long start_addr, unsigned long end_addr)
{
	struct vm_area_struct * vma;

	vma = find_vma(mm,start_addr);
	if (vma && end_addr <= vma->vm_start)
		vma =  __MS__11 ((void *) 0)  __ME__ ;
	return vma;
}




# 12 "binfmt_aout.c" 2

# 1 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/mman.h" 1



# 1 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/asm/mman.h" 1


























 




# 4 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/mman.h" 2





# 13 "binfmt_aout.c" 2

# 1 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/a.out.h" 1







# 1 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/asm/a.out.h" 1



struct exec
{
  unsigned long a_info;		 
  unsigned a_text;		 
  unsigned a_data;		 
  unsigned a_bss;		 
  unsigned a_syms;		 
  unsigned a_entry;		 
  unsigned a_trsize;		 
  unsigned a_drsize;		 
};












# 8 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/a.out.h" 2




 
enum machine_type {



  M_OLDSUN2 = 0,




  M_68010 = 1,




  M_68020 = 2,




  M_SPARC = 3,

   
  M_386 = 100,
  M_MIPS1 = 151,	 
  M_MIPS2 = 152,	 
};





















 

 

 

 



 





































 




 
















# 139 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/a.out.h"












 





struct nlist {
  union {
    char *n_name;
    struct nlist *n_next;
    long n_strx;
  } n_un;
  unsigned char n_type;
  char n_other;
  short n_desc;
  unsigned long n_value;
};































 









 










 





 



 




struct relocation_info
{
   
  int r_address;
   
  unsigned int r_symbolnum:24;
   


  unsigned int r_pcrel:1;
   

  unsigned int r_length:2;
   





  unsigned int r_extern:1;
   






  unsigned int r_pad:4;

};




# 14 "binfmt_aout.c" 2







# 1 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/user.h" 1
# 1 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/asm/user.h" 1





 


























struct user_i387_struct {
	long	cwd;
	long	swd;
	long	twd;
	long	fip;
	long	fcs;
	long	foo;
	long	fos;
	long	st_space[20];	 
};

 


struct user{
 

  struct pt_regs regs;		 
 
  int u_fpvalid;		 
                                 
  struct user_i387_struct i387;	 
 
  unsigned long int u_tsize;	 
  unsigned long int u_dsize;	 
  unsigned long int u_ssize;	 
  unsigned long start_code;      
  unsigned long start_stack;	 



  long int signal;     		 
  int reserved;			 
  struct pt_regs * u_ar0;	 
				 
  struct user_i387_struct* u_fpstate;	 
  unsigned long magic;		 
  char u_comm[32];		 
  int u_debugreg[8];
};






# 1 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/user.h" 2

# 21 "binfmt_aout.c" 2

# 1 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/linux/malloc.h" 1





void * kmalloc(unsigned int size, int priority);
void kfree(void * obj);




# 22 "binfmt_aout.c" 2






# 1 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/asm/pgtable.h" 1





 





 









 






 





















 






static inline void flush_tlb_mm(struct mm_struct *mm)
{
	if (mm ==  __MS__68 (0+current_set[ __MS__78 0  __ME__ ])  __ME__ ->mm)
		do { unsigned long tmpreg;  } while (0) ;
}

static inline void flush_tlb_page(struct vm_area_struct *vma,
	unsigned long addr)
{
	if (vma->vm_mm ==  __MS__68 (0+current_set[ __MS__78 0  __ME__ ])  __ME__ ->mm)
		 ;
}

static inline void flush_tlb_range(struct mm_struct *mm,
	unsigned long start, unsigned long end)
{
	if (mm ==  __MS__68 (0+current_set[ __MS__78 0  __ME__ ])  __ME__ ->mm)
		do { unsigned long tmpreg;  } while (0) ;
}

# 162 "/u/brewste/public_html/bkshelf/linux/src/V2.0.27/include/asm/pgtable.h"



 





 




 




 







 










 























 





















 






 
extern unsigned long pg0[1024];
 
extern unsigned long empty_zero_page[1024];

 






extern pte_t __bad_page(void);
extern pte_t * __bad_pagetable(void);





 


 


 
 


 



 














 




extern inline int pgd_none(pgd_t pgd)		{ return 0; }
extern inline int pgd_bad(pgd_t pgd)		{ return 0; }
extern inline int pgd_present(pgd_t pgd)	{ return 1; }
extern inline void pgd_clear(pgd_t * pgdp)	{ }

 



extern inline int pte_read(pte_t pte)		{ return  __MS__77 (( __ME__  pte  __MS__77 ).pte)  __ME__  & 0x004 ; }
extern inline int pte_write(pte_t pte)		{ return  __MS__77 (( __ME__  pte  __MS__77 ).pte)  __ME__  & 0x002 ; }
extern inline int pte_exec(pte_t pte)		{ return  __MS__77 (( __ME__  pte  __MS__77 ).pte)  __ME__  & 0x004 ; }
extern inline int pte_dirty(pte_t pte)		{ return  __MS__77 (( __ME__  pte  __MS__77 ).pte)  __ME__  & 0x040 ; }
extern inline int pte_young(pte_t pte)		{ return  __MS__77 (( __ME__  pte  __MS__77 ).pte)  __ME__  & 0x020 ; }

extern inline pte_t pte_wrprotect(pte_t pte)	{  __MS__77 (( __ME__  pte  __MS__77 ).pte)  __ME__  &= ~0x002 ; return pte; }
extern inline pte_t pte_rdprotect(pte_t pte)	{  __MS__77 (( __ME__  pte  __MS__77 ).pte)  __ME__  &= ~0x004 ; return pte; }
extern inline pte_t pte_exprotect(pte_t pte)	{  __MS__77 (( __ME__  pte  __MS__77 ).pte)  __ME__  &= ~0x004 ; return pte; }
extern inline pte_t pte_mkclean(pte_t pte)	{  __MS__77 (( __ME__  pte  __MS__77 ).pte)  __ME__  &= ~0x040 ; return pte; }
extern inline pte_t pte_mkold(pte_t pte)	{  __MS__77 (( __ME__  pte  __MS__77 ).pte)  __ME__  &= ~0x020 ; return pte; }
extern inline pte_t pte_mkwrite(pte_t pte)	{  __MS__77 (( __ME__  pte  __MS__77 ).pte)  __ME__  |= 0x002 ; return pte; }
extern inline pte_t pte_mkread(pte_t pte)	{  __MS__77 (( __ME__  pte  __MS__77 ).pte)  __ME__  |= 0x004 ; return pte; }
extern inline pte_t pte_mkexec(pte_t pte)	{  __MS__77 (( __ME__  pte  __MS__77 ).pte)  __ME__  |= 0x004 ; return pte; }
extern inline pte_t pte_mkdirty(pte_t pte)	{  __MS__77 (( __ME__  pte  __MS__77 ).pte)  __ME__  |= 0x040 ; return pte; }
extern inline pte_t pte_mkyoung(pte_t pte)	{  __MS__77 (( __ME__  pte  __MS__77 ).pte)  __ME__  |= 0x020 ; return pte; }

 



extern inline pte_t mk_pte(unsigned long page, pgprot_t pgprot)
{ pte_t pte;  __MS__77 (( __ME__  pte  __MS__77 ).pte)  __ME__  = page |  __MS__77 (( __ME__  pgprot  __MS__77 ).pgprot)  __ME__ ; return pte; }

extern inline pte_t pte_modify(pte_t pte, pgprot_t newprot)
{  __MS__77 (( __ME__  pte  __MS__77 ).pte)  __ME__  = ( __MS__77 (( __ME__  pte  __MS__77 ).pte)  __ME__  & ( __MS__77 (~((1UL << 12 ) -1))  __ME__  | 0x020  | 0x040 ) ) |  __MS__77 (( __ME__  newprot  __MS__77 ).pgprot)  __ME__ ; return pte; }

extern inline unsigned long pte_page(pte_t pte)
{ return  __MS__77 (( __ME__  pte  __MS__77 ).pte)  __ME__  &  __MS__77 (~((1UL << 12 ) -1))  __ME__ ; }

extern inline unsigned long pmd_page(pmd_t pmd)
{ return  __MS__77 (( __ME__  pmd  __MS__77 ).pmd)  __ME__  &  __MS__77 (~((1UL << 12 ) -1))  __ME__ ; }

 
extern inline pgd_t * pgd_offset(struct mm_struct * mm, unsigned long address)
{
	return mm->pgd + (address >> 22 );
}

 
extern inline pmd_t * pmd_offset(pgd_t * dir, unsigned long address)
{
	return (pmd_t *) dir;
}

  
extern inline pte_t * pte_offset(pmd_t * dir, unsigned long address)
{
	return (pte_t *) pmd_page(*dir) + ((address >>  __MS__77 12  __ME__ ) & (1024  - 1));
}

 




extern inline void pte_free_kernel(pte_t * pte)
{
	 __MS__102 free_pages(( __ME__  (unsigned long) pte  __MS__102 ),0)  __ME__ ;
}

extern inline pte_t * pte_alloc_kernel(pmd_t * pmd, unsigned long address)
{
	address = (address >>  __MS__77 12  __ME__ ) & (1024  - 1);
	if ((! __MS__77 (( __ME__   *pmd   __MS__77 ).pmd)  __ME__ ) ) {
		pte_t * page = (pte_t *) get_free_page( __MS__102 0x03  __ME__ );
		if ((! __MS__77 (( __ME__   *pmd   __MS__77 ).pmd)  __ME__ ) ) {
			if (page) {
				 __MS__77 (( __ME__  *pmd  __MS__77 ).pmd)  __ME__  = (0x001  | 0x002  | 0x004  | 0x020  | 0x040 )  | (unsigned long) page;
				return page + address;
			}
			 __MS__77 (( __ME__  *pmd  __MS__77 ).pmd)  __ME__  = (0x001  | 0x002  | 0x004  | 0x020  | 0x040 )  | (unsigned long) __bad_pagetable() ;
			return  __MS__11 ((void *) 0)  __ME__ ;
		}
		 __MS__102 free_pages(( __ME__  (unsigned long) page  __MS__102 ),0)  __ME__ ;
	}
	if ((( __MS__77 (( __ME__   *pmd   __MS__77 ).pmd)  __ME__  & ~ __MS__77 (~((1UL << 12 ) -1))  __ME__ ) != (0x001  | 0x002  | 0x004  | 0x020  | 0x040 ) ) ) {
		printk("Bad pmd in pte_alloc: %08lx\n",  __MS__77 (( __ME__  *pmd  __MS__77 ).pmd)  __ME__ );
		 __MS__77 (( __ME__  *pmd  __MS__77 ).pmd)  __ME__  = (0x001  | 0x002  | 0x004  | 0x020  | 0x040 )  | (unsigned long) __bad_pagetable() ;
		return  __MS__11 ((void *) 0)  __ME__ ;
	}
	return (pte_t *) pmd_page(*pmd) + address;
}

 



extern inline void pmd_free_kernel(pmd_t * pmd)
{
	 __MS__77 (( __ME__  *pmd  __MS__77 ).pmd)  __ME__  = 0;
}

extern inline pmd_t * pmd_alloc_kernel(pgd_t * pgd, unsigned long address)
{
	return (pmd_t *) pgd;
}

extern inline void pte_free(pte_t * pte)
{
	 __MS__102 free_pages(( __ME__  (unsigned long) pte  __MS__102 ),0)  __ME__ ;
}

extern inline pte_t * pte_alloc(pmd_t * pmd, unsigned long address)
{
	address = (address >> ( __MS__77 12  __ME__ -2)) & 4*(1024  - 1);

repeat:
	if ((! __MS__77 (( __ME__   *pmd   __MS__77 ).pmd)  __ME__ ) )
		goto getnew;
	if ((( __MS__77 (( __ME__   *pmd   __MS__77 ).pmd)  __ME__  & ~ __MS__77 (~((1UL << 12 ) -1))  __ME__ ) != (0x001  | 0x002  | 0x004  | 0x020  | 0x040 ) ) )
		goto fix;
	return (pte_t *) (pmd_page(*pmd) + address);
	
getnew:
{
	unsigned long page =  __MS__102 __get_free_pages(( __ME__   __MS__102 0x03  __ME__   __MS__102 ),0,0)  __ME__ ;
	if (!(! __MS__77 (( __ME__   *pmd   __MS__77 ).pmd)  __ME__ ) )
		goto freenew;
	if (!page)
		goto oom;
	 __MS__85 (__builtin_constant_p( __ME__   0  __MS__85 ) ? (__builtin_constant_p( ( __ME__    __MS__77 (1UL << 12 )  __ME__   __MS__85 ) ) ? __constant_c_and_count_memset(( ( __ME__  (void *) page  __MS__85 ) ),( (0x01010101UL*(unsigned char) __ME__   0  __MS__85 ) ),( ( __ME__    __MS__77 (1UL << 12 )  __ME__   __MS__85 ) )) : __constant_c_memset(( ( __ME__  (void *) page  __MS__85 ) ),( (0x01010101UL*(unsigned char) __ME__   0  __MS__85 ) ),( ( __ME__    __MS__77 (1UL << 12 )  __ME__   __MS__85 ) )))  : (__builtin_constant_p( ( __ME__    __MS__77 (1UL << 12 )  __ME__   __MS__85 ) ) ? __memset_generic(( ( ( __ME__  (void *) page  __MS__85 ) ) ),( ( ( __ME__   0  __MS__85 ) ) ),( ( ( __ME__    __MS__77 (1UL << 12 )  __ME__   __MS__85 ) ) ))  : __memset_generic(( ( __ME__  (void *) page  __MS__85 ) ),( ( __ME__   0  __MS__85 ) ),( ( __ME__    __MS__77 (1UL << 12 )  __ME__   __MS__85 ) ))) )  __ME__ ;
	 __MS__77 (( __ME__  *pmd  __MS__77 ).pmd)  __ME__  = (0x001  | 0x002  | 0x004  | 0x020  | 0x040 )  | page;
	return (pte_t *) (page + address);
freenew:
	 __MS__102 free_pages(( __ME__  page  __MS__102 ),0)  __ME__ ;
	goto repeat;
}

fix:
	printk("Bad pmd in pte_alloc: %08lx\n",  __MS__77 (( __ME__  *pmd  __MS__77 ).pmd)  __ME__ );
oom:
	 __MS__77 (( __ME__  *pmd  __MS__77 ).pmd)  __ME__  = (0x001  | 0x002  | 0x004  | 0x020  | 0x040 )  | (unsigned long) __bad_pagetable() ;
	return  __MS__11 ((void *) 0)  __ME__ ;
}

 



extern inline void pmd_free(pmd_t * pmd)
{
	 __MS__77 (( __ME__  *pmd  __MS__77 ).pmd)  __ME__  = 0;
}

extern inline pmd_t * pmd_alloc(pgd_t * pgd, unsigned long address)
{
	return (pmd_t *) pgd;
}

extern inline void pgd_free(pgd_t * pgd)
{
	 __MS__102 free_pages(( __ME__  (unsigned long) pgd  __MS__102 ),0)  __ME__ ;
}

extern inline pgd_t * pgd_alloc(void)
{
	return (pgd_t *) get_free_page( __MS__102 0x03  __ME__ );
}

extern pgd_t swapper_pg_dir[1024];

 



extern inline void update_mmu_cache(struct vm_area_struct * vma,
	unsigned long address, pte_t pte)
{
}






# 28 "binfmt_aout.c" 2


static int load_aout_binary(struct linux_binprm *, struct pt_regs * regs);
static int load_aout_library(int fd);
static int aout_core_dump(long signr, struct pt_regs * regs);

extern void dump_thread(struct pt_regs *, struct user *);

static struct linux_binfmt aout_format = {

	 __MS__11 ((void *) 0)  __ME__ ,  __MS__11 ((void *) 0)  __ME__ , load_aout_binary, load_aout_library, aout_core_dump



};

static void set_brk(unsigned long start, unsigned long end)
{
	start =  __MS__77 ((( __ME__  start  __MS__77 )+(1UL << 12 ) -1)&(~((1UL << 12 ) -1)) )  __ME__ ;
	end =  __MS__77 ((( __ME__  end  __MS__77 )+(1UL << 12 ) -1)&(~((1UL << 12 ) -1)) )  __ME__ ;
	if (end <= start)
		return;
	do_mmap( __MS__11 ((void *) 0)  __ME__ , start, end - start,
		 __MS__105 0x1  __ME__  |  __MS__105 0x2  __ME__  |  __MS__105 0x4  __ME__ ,
		 __MS__105 0x10  __ME__  |  __MS__105 0x02  __ME__ , 0);
}

 












 









static inline int
do_aout_core_dump(long signr, struct pt_regs * regs)
{
	struct inode * inode =  __MS__11 ((void *) 0)  __ME__ ;
	struct file file;
	unsigned short fs;
	int has_dumped = 0;
	char corefile[6+sizeof( __MS__68 (0+current_set[ __MS__78 0  __ME__ ])  __ME__ ->comm)];
	unsigned long dump_start, dump_size;
	struct user dump;






	if (! __MS__68 (0+current_set[ __MS__78 0  __ME__ ])  __ME__ ->dumpable ||  __MS__68 (0+current_set[ __MS__78 0  __ME__ ])  __ME__ ->mm->count != 1)
		return 0;
	 __MS__68 (0+current_set[ __MS__78 0  __ME__ ])  __ME__ ->dumpable = 0;

 
	if ( __MS__68 (0+current_set[ __MS__78 0  __ME__ ])  __ME__ ->rlim[ __MS__97 4  __ME__ ].rlim_cur <  __MS__77 (1UL << 12 )  __ME__ )
		return 0;
	fs = get_fs();
	set_fs( __MS__76 0x18  __ME__ );
	 __MS__85 (__builtin_constant_p( __ME__  5  __MS__85 ) ? __constant_memcpy(( __ME__  corefile  __MS__85 ),( __ME__  "core."  __MS__85 ),( __ME__  5  __MS__85 )) : __memcpy(( __ME__  corefile  __MS__85 ),( __ME__  "core."  __MS__85 ),( __ME__  5  __MS__85 )))  __ME__ ;



	corefile[4] = '\0';

	if (open_namei(corefile, __MS__53 0100  __ME__  | 2 |  __MS__53 01000  __ME__ ,0600,&inode, __MS__11 ((void *) 0)  __ME__ )) {
		inode =  __MS__11 ((void *) 0)  __ME__ ;
		goto end_coredump;
	}
	if (! __MS__46 ((( __ME__  inode->i_mode  __MS__46 ) & 00170000 ) == 0100000 )  __ME__ )
		goto end_coredump;
	if (!inode->i_op || !inode->i_op->default_file_ops)
		goto end_coredump;
	if (get_write_access(inode))
		goto end_coredump;
	file.f_mode = 3;
	file.f_flags = 0;
	file.f_count = 1;
	file.f_inode = inode;
	file.f_pos = 0;
	file.f_reada = 0;
	file.f_op = inode->i_op->default_file_ops;
	if (file.f_op->open)
		if (file.f_op->open(inode,&file))
			goto done_coredump;
	if (!file.f_op->write)
		goto close_coredump;
	has_dumped = 1;
	 __MS__68 (0+current_set[ __MS__78 0  __ME__ ])  __ME__ ->flags |=  __MS__68 0x00000200  __ME__ ;
       	strncpy(dump.u_comm,  __MS__68 (0+current_set[ __MS__78 0  __ME__ ])  __ME__ ->comm, sizeof( __MS__68 (0+current_set[ __MS__78 0  __ME__ ])  __ME__ ->comm));
	dump.u_ar0 = (void *)(((unsigned long)(&dump.regs)) - ((unsigned long)(&dump)));
	dump.signal = signr;
	dump_thread(regs, &dump);

 

	if ((dump.u_dsize+dump.u_ssize+1) *  __MS__77 (1UL << 12 )  __ME__  >
	     __MS__68 (0+current_set[ __MS__78 0  __ME__ ])  __ME__ ->rlim[ __MS__97 4  __ME__ ].rlim_cur)
		dump.u_dsize = 0;

 
	if ((dump.u_ssize+1) *  __MS__77 (1UL << 12 )  __ME__  >
	     __MS__68 (0+current_set[ __MS__78 0  __ME__ ])  __ME__ ->rlim[ __MS__97 4  __ME__ ].rlim_cur)
		dump.u_ssize = 0;

 
	set_fs( __MS__76 0x2B  __ME__ );
	if (verify_area( __MS__102 0  __ME__ , (void *) ( dump .u_tsize <<  __MS__77 12  __ME__ ) , dump.u_dsize <<  __MS__77 12  __ME__ ))
		dump.u_dsize = 0;
	if (verify_area( __MS__102 0  __ME__ , (void *) dump.start_stack, dump.u_ssize <<  __MS__77 12  __ME__ ))
		dump.u_ssize = 0;

	set_fs( __MS__76 0x18  __ME__ );
 
	while (file.f_op->write(inode,&file,(char *)( &dump ),( sizeof(dump) )) != ( sizeof(dump) )) goto close_coredump ;
 
	if (file.f_op->lseek) { if (file.f_op->lseek(inode,&file,(  __MS__77 (1UL << 12 )  __ME__  ),0) != (  __MS__77 (1UL << 12 )  __ME__  )) goto close_coredump; } else file.f_pos = (  __MS__77 (1UL << 12 )  __ME__  ) ;
 
	set_fs( __MS__76 0x2B  __ME__ );
 
	if (dump.u_dsize != 0) {
		dump_start = ( dump .u_tsize <<  __MS__77 12  __ME__ ) ;
		dump_size = dump.u_dsize <<  __MS__77 12  __ME__ ;
		while (file.f_op->write(inode,&file,(char *)( dump_start ),( dump_size )) != ( dump_size )) goto close_coredump ;
	}
 
	if (dump.u_ssize != 0) {
		dump_start = dump.start_stack;
		dump_size = dump.u_ssize <<  __MS__77 12  __ME__ ;
		while (file.f_op->write(inode,&file,(char *)( dump_start ),( dump_size )) != ( dump_size )) goto close_coredump ;
	}
 
	set_fs( __MS__76 0x18  __ME__ );
	while (file.f_op->write(inode,&file,(char *)(  __MS__68 (0+current_set[ __MS__78 0  __ME__ ])  __ME__  ),( sizeof(* __MS__68 (0+current_set[ __MS__78 0  __ME__ ])  __ME__ ) )) != ( sizeof(* __MS__68 (0+current_set[ __MS__78 0  __ME__ ])  __ME__ ) )) goto close_coredump ;
close_coredump:
	if (file.f_op->release)
		file.f_op->release(inode,&file);
done_coredump:
	put_write_access(inode);
end_coredump:
	set_fs(fs);
	iput(inode);
	return has_dumped;
}

static int
aout_core_dump(long signr, struct pt_regs * regs)
{
	int retval;

	 __MS__3 do { } while (0)  __ME__ ;
	retval = do_aout_core_dump(signr, regs);
	 __MS__3 do { } while (0)  __ME__ ;
	return retval;
}

 




static unsigned long * create_aout_tables(char * p, struct linux_binprm * bprm)
{
	unsigned long *argv,*envp;
	unsigned long * sp;
	int argc = bprm->argc;
	int envc = bprm->envc;

	sp = (unsigned long *) ((-(unsigned long)sizeof(char *)) & (unsigned long) p);
# 225 "binfmt_aout.c"

	sp -= envc+1;
	envp = sp;
	sp -= argc+1;
	argv = sp;




	 __MS__76 __put_user((unsigned long)( __ME__  argc  __MS__76 ),( __ME__  --sp  __MS__76 ),sizeof(*( __ME__  --sp  __MS__76 )))  __ME__ ;
	 __MS__68 (0+current_set[ __MS__78 0  __ME__ ])  __ME__ ->mm->arg_start = (unsigned long) p;
	while (argc-->0) {
		 __MS__76 __put_user((unsigned long)( __ME__  p  __MS__76 ),( __ME__  argv++  __MS__76 ),sizeof(*( __ME__  argv++  __MS__76 )))  __ME__ ;
		while ( __MS__76 ((__typeof__(*( __ME__  p++  __MS__76 )))__get_user(( __ME__  p++  __MS__76 ),sizeof(*( __ME__  p++  __MS__76 ))))  __ME__ )   ;
	}
	 __MS__76 __put_user((unsigned long)( __ME__   __MS__11 ((void *) 0)  __ME__   __MS__76 ),( __ME__  argv  __MS__76 ),sizeof(*( __ME__  argv  __MS__76 )))  __ME__ ;
	 __MS__68 (0+current_set[ __MS__78 0  __ME__ ])  __ME__ ->mm->arg_end =  __MS__68 (0+current_set[ __MS__78 0  __ME__ ])  __ME__ ->mm->env_start = (unsigned long) p;
	while (envc-->0) {
		 __MS__76 __put_user((unsigned long)( __ME__  p  __MS__76 ),( __ME__  envp++  __MS__76 ),sizeof(*( __ME__  envp++  __MS__76 )))  __ME__ ;
		while ( __MS__76 ((__typeof__(*( __ME__  p++  __MS__76 )))__get_user(( __ME__  p++  __MS__76 ),sizeof(*( __ME__  p++  __MS__76 ))))  __ME__ )   ;
	}
	 __MS__76 __put_user((unsigned long)( __ME__   __MS__11 ((void *) 0)  __ME__   __MS__76 ),( __ME__  envp  __MS__76 ),sizeof(*( __ME__  envp  __MS__76 )))  __ME__ ;
	 __MS__68 (0+current_set[ __MS__78 0  __ME__ ])  __ME__ ->mm->env_end = (unsigned long) p;
	return sp;
}

 




static inline int
do_load_aout_binary(struct linux_binprm * bprm, struct pt_regs * regs)
{
	struct exec ex;
	struct file * file;
	int fd;
	unsigned long error;
	unsigned long p = bprm->p;
	unsigned long fd_offset;
	unsigned long rlim;

	ex = *((struct exec *) bprm->buf);		 
	if (( __MS__106 (( __ME__  ex  __MS__106 ).a_info & 0xffff)  __ME__  !=  __MS__106 0413  __ME__  &&  __MS__106 (( __ME__  ex  __MS__106 ).a_info & 0xffff)  __ME__  !=  __MS__106 0407  __ME__  && 
	      __MS__106 (( __ME__  ex  __MS__106 ).a_info & 0xffff)  __ME__  !=  __MS__106 0314  __ME__ ) ||
	     __MS__107 (( __ME__  ex  __MS__107 ).a_trsize)  __ME__  ||  __MS__107 (( __ME__  ex  __MS__107 ).a_drsize)  __ME__  ||
	    bprm->inode->i_size < ex.a_text+ex.a_data+ __MS__107 (( __ME__  ex  __MS__107 ).a_syms)  __ME__ + __MS__106 (((  __ME__  ex  __MS__106  ).a_info & 0xffff)  == 0413  ? (1024 - sizeof (struct exec))  + sizeof (struct exec) : (((  __ME__  ex  __MS__106  ).a_info & 0xffff)  == 0314  ? 0 : sizeof (struct exec)))  __ME__ ) {
		return -  __MS__50 8  __ME__ ;
	}

	 __MS__68 (0+current_set[ __MS__78 0  __ME__ ])  __ME__ ->personality =  __MS__73 (0x0000)  __ME__ ;
	fd_offset =  __MS__106 (((  __ME__  ex  __MS__106  ).a_info & 0xffff)  == 0413  ? (1024 - sizeof (struct exec))  + sizeof (struct exec) : (((  __ME__  ex  __MS__106  ).a_info & 0xffff)  == 0314  ? 0 : sizeof (struct exec)))  __ME__ ;

# 289 "binfmt_aout.c"


	 



	rlim =  __MS__68 (0+current_set[ __MS__78 0  __ME__ ])  __ME__ ->rlim[ __MS__97 2  __ME__ ].rlim_cur;
	if (rlim >=  __MS__96 ((long)(~0UL>>1))  __ME__ )
		rlim = ~0;
	if (ex.a_data + ex.a_bss > rlim)
		return -  __MS__50 12  __ME__ ;

	 
	flush_old_exec(bprm);

	 __MS__68 (0+current_set[ __MS__78 0  __ME__ ])  __ME__ ->mm->end_code = ex.a_text +
		( __MS__68 (0+current_set[ __MS__78 0  __ME__ ])  __ME__ ->mm->start_code =  __MS__106 (((  __ME__  ex  __MS__106  ).a_info & 0xffff)  == 0314  ?  __MS__77 (1UL << 12 )  __ME__  : 0)  __ME__ );
	 __MS__68 (0+current_set[ __MS__78 0  __ME__ ])  __ME__ ->mm->end_data = ex.a_data +
		( __MS__68 (0+current_set[ __MS__78 0  __ME__ ])  __ME__ ->mm->start_data =  __MS__106 (((  __ME__  ex  __MS__106  ).a_info & 0xffff) ==0407 ? (((((    __ME__  ex  __MS__106    ).a_info & 0xffff)  == 0314  ?  __MS__77 (1UL << 12 )  __ME__  : 0) +(  __ME__  ex  __MS__106  ).a_text) ) : (((( ((((    __ME__  ex  __MS__106    ).a_info & 0xffff)  == 0314  ?  __MS__77 (1UL << 12 )  __ME__  : 0) +(  __ME__  ex  __MS__106  ).a_text)  ) + SEGMENT_SIZE - 1) & ~(SEGMENT_SIZE - 1)) ))  __ME__ );
	 __MS__68 (0+current_set[ __MS__78 0  __ME__ ])  __ME__ ->mm->brk = ex.a_bss +
		( __MS__68 (0+current_set[ __MS__78 0  __ME__ ])  __ME__ ->mm->start_brk =  __MS__106 ((((   __ME__  ex  __MS__106   ).a_info & 0xffff) ==0407 ? (((((     __ME__  ex  __MS__106     ).a_info & 0xffff)  == 0314  ?  __MS__77 (1UL << 12 )  __ME__  : 0) +(   __ME__  ex  __MS__106   ).a_text) ) : (((( ((((     __ME__  ex  __MS__106     ).a_info & 0xffff)  == 0314  ?  __MS__77 (1UL << 12 )  __ME__  : 0) +(   __ME__  ex  __MS__106   ).a_text)  ) + SEGMENT_SIZE - 1) & ~(SEGMENT_SIZE - 1)) ))  + ( __ME__  ex  __MS__106 ).a_data)  __ME__ );

	 __MS__68 (0+current_set[ __MS__78 0  __ME__ ])  __ME__ ->mm->rss = 0;
	 __MS__68 (0+current_set[ __MS__78 0  __ME__ ])  __ME__ ->mm->mmap =  __MS__11 ((void *) 0)  __ME__ ;
	 __MS__68 (0+current_set[ __MS__78 0  __ME__ ])  __ME__ ->suid =  __MS__68 (0+current_set[ __MS__78 0  __ME__ ])  __ME__ ->euid =  __MS__68 (0+current_set[ __MS__78 0  __ME__ ])  __ME__ ->fsuid = bprm->e_uid;
	 __MS__68 (0+current_set[ __MS__78 0  __ME__ ])  __ME__ ->sgid =  __MS__68 (0+current_set[ __MS__78 0  __ME__ ])  __ME__ ->egid =  __MS__68 (0+current_set[ __MS__78 0  __ME__ ])  __ME__ ->fsgid = bprm->e_gid;
 	 __MS__68 (0+current_set[ __MS__78 0  __ME__ ])  __ME__ ->flags &= ~ __MS__68 0x00000040  __ME__ ;
	if ( __MS__106 (( __ME__  ex  __MS__106 ).a_info & 0xffff)  __ME__  ==  __MS__106 0407  __ME__ ) {








		do_mmap( __MS__11 ((void *) 0)  __ME__ , 0, ex.a_text+ex.a_data,
			 __MS__105 0x1  __ME__ |  __MS__105 0x2  __ME__ |  __MS__105 0x4  __ME__ ,
			 __MS__105 0x10  __ME__ |  __MS__105 0x02  __ME__ , 0);
		read_exec(bprm->inode, 32, (char *) 0, ex.a_text+ex.a_data, 0);

	} else {
		if (ex.a_text & 0xfff || ex.a_data & 0xfff)
			printk( __MS__42 "<5>"  __ME__  "executable not page aligned\n");
		
		fd = open_inode(bprm->inode,  __MS__53 00  __ME__ );
		
		if (fd < 0)
			return fd;
		file =  __MS__68 (0+current_set[ __MS__78 0  __ME__ ])  __ME__ ->files->fd[fd];
		if (!file->f_op || !file->f_op->mmap) {
			sys_close(fd);
			do_mmap( __MS__11 ((void *) 0)  __ME__ , 0, ex.a_text+ex.a_data,
				 __MS__105 0x1  __ME__ |  __MS__105 0x2  __ME__ |  __MS__105 0x4  __ME__ ,
				 __MS__105 0x10  __ME__ |  __MS__105 0x02  __ME__ , 0);
			read_exec(bprm->inode, fd_offset,
				  (char *)  __MS__106 (((  __ME__  ex  __MS__106  ).a_info & 0xffff)  == 0314  ?  __MS__77 (1UL << 12 )  __ME__  : 0)  __ME__ , ex.a_text+ex.a_data, 0);
			goto beyond_if;
		}

		error = do_mmap(file,  __MS__106 (((  __ME__  ex  __MS__106  ).a_info & 0xffff)  == 0314  ?  __MS__77 (1UL << 12 )  __ME__  : 0)  __ME__ , ex.a_text,
			 __MS__105 0x1  __ME__  |  __MS__105 0x4  __ME__ ,
			 __MS__105 0x10  __ME__  |  __MS__105 0x02  __ME__  |  __MS__105 0x0800  __ME__  |  __MS__105 0x1000  __ME__ ,
			fd_offset);

		if (error !=  __MS__106 (((  __ME__  ex  __MS__106  ).a_info & 0xffff)  == 0314  ?  __MS__77 (1UL << 12 )  __ME__  : 0)  __ME__ ) {
			sys_close(fd);
			send_sig( __MS__93 9  __ME__ ,  __MS__68 (0+current_set[ __MS__78 0  __ME__ ])  __ME__ , 0);
			return error;
		}
		
 		error = do_mmap(file,  __MS__106 (((  __ME__  ex  __MS__106  ).a_info & 0xffff) ==0407 ? (((((    __ME__  ex  __MS__106    ).a_info & 0xffff)  == 0314  ?  __MS__77 (1UL << 12 )  __ME__  : 0) +(  __ME__  ex  __MS__106  ).a_text) ) : (((( ((((    __ME__  ex  __MS__106    ).a_info & 0xffff)  == 0314  ?  __MS__77 (1UL << 12 )  __ME__  : 0) +(  __ME__  ex  __MS__106  ).a_text)  ) + SEGMENT_SIZE - 1) & ~(SEGMENT_SIZE - 1)) ))  __ME__ , ex.a_data,
				 __MS__105 0x1  __ME__  |  __MS__105 0x2  __ME__  |  __MS__105 0x4  __ME__ ,
				 __MS__105 0x10  __ME__  |  __MS__105 0x02  __ME__  |  __MS__105 0x0800  __ME__  |  __MS__105 0x1000  __ME__ ,
				fd_offset + ex.a_text);
		sys_close(fd);
		if (error !=  __MS__106 (((  __ME__  ex  __MS__106  ).a_info & 0xffff) ==0407 ? (((((    __ME__  ex  __MS__106    ).a_info & 0xffff)  == 0314  ?  __MS__77 (1UL << 12 )  __ME__  : 0) +(  __ME__  ex  __MS__106  ).a_text) ) : (((( ((((    __ME__  ex  __MS__106    ).a_info & 0xffff)  == 0314  ?  __MS__77 (1UL << 12 )  __ME__  : 0) +(  __ME__  ex  __MS__106  ).a_text)  ) + SEGMENT_SIZE - 1) & ~(SEGMENT_SIZE - 1)) ))  __ME__ ) {
			send_sig( __MS__93 9  __ME__ ,  __MS__68 (0+current_set[ __MS__78 0  __ME__ ])  __ME__ , 0);
			return error;
		}
	}
beyond_if:
	if ( __MS__68 (0+current_set[ __MS__78 0  __ME__ ])  __ME__ ->exec_domain &&  __MS__68 (0+current_set[ __MS__78 0  __ME__ ])  __ME__ ->exec_domain->use_count)
		(* __MS__68 (0+current_set[ __MS__78 0  __ME__ ])  __ME__ ->exec_domain->use_count)--;
	if ( __MS__68 (0+current_set[ __MS__78 0  __ME__ ])  __ME__ ->binfmt &&  __MS__68 (0+current_set[ __MS__78 0  __ME__ ])  __ME__ ->binfmt->use_count)
		(* __MS__68 (0+current_set[ __MS__78 0  __ME__ ])  __ME__ ->binfmt->use_count)--;
	 __MS__68 (0+current_set[ __MS__78 0  __ME__ ])  __ME__ ->exec_domain = lookup_exec_domain( __MS__68 (0+current_set[ __MS__78 0  __ME__ ])  __ME__ ->personality);
	 __MS__68 (0+current_set[ __MS__78 0  __ME__ ])  __ME__ ->binfmt = &aout_format;
	if ( __MS__68 (0+current_set[ __MS__78 0  __ME__ ])  __ME__ ->exec_domain &&  __MS__68 (0+current_set[ __MS__78 0  __ME__ ])  __ME__ ->exec_domain->use_count)
		(* __MS__68 (0+current_set[ __MS__78 0  __ME__ ])  __ME__ ->exec_domain->use_count)++;
	if ( __MS__68 (0+current_set[ __MS__78 0  __ME__ ])  __ME__ ->binfmt &&  __MS__68 (0+current_set[ __MS__78 0  __ME__ ])  __ME__ ->binfmt->use_count)
		(* __MS__68 (0+current_set[ __MS__78 0  __ME__ ])  __ME__ ->binfmt->use_count)++;

	set_brk( __MS__68 (0+current_set[ __MS__78 0  __ME__ ])  __ME__ ->mm->start_brk,  __MS__68 (0+current_set[ __MS__78 0  __ME__ ])  __ME__ ->mm->brk);

	p = setup_arg_pages(p, bprm);
	
	p = (unsigned long) create_aout_tables((char *)p, bprm);
	 __MS__68 (0+current_set[ __MS__78 0  __ME__ ])  __ME__ ->mm->start_stack = p;



	start_thread(regs, ex.a_entry, p);
	if ( __MS__68 (0+current_set[ __MS__78 0  __ME__ ])  __ME__ ->flags &  __MS__68 0x00000010  __ME__ )
		send_sig( __MS__93 5  __ME__ ,  __MS__68 (0+current_set[ __MS__78 0  __ME__ ])  __ME__ , 0);
	return 0;
}

static int
load_aout_binary(struct linux_binprm * bprm, struct pt_regs * regs)
{
	int retval;

	 __MS__3 do { } while (0)  __ME__ ;
	retval = do_load_aout_binary(bprm, regs);
	 __MS__3 do { } while (0)  __ME__ ;
	return retval;
}

static inline int
do_load_aout_library(int fd)
{
        struct file * file;
	struct exec ex;
	struct  inode * inode;
	unsigned int len;
	unsigned int bss;
	unsigned int start_addr;
	unsigned long error;
	
	file =  __MS__68 (0+current_set[ __MS__78 0  __ME__ ])  __ME__ ->files->fd[fd];
	inode = file->f_inode;
	
	if (!file || !file->f_op)
		return -  __MS__50 13  __ME__ ;

	 
	if (file->f_op->lseek) {
		if ((error = file->f_op->lseek(inode, file, 0, 0)) != 0)
			return -  __MS__50 8  __ME__ ;
	} else
		file->f_pos = 0;

	set_fs( __MS__76 0x18  __ME__ );
	error = file->f_op->read(inode, file, (char *) &ex, sizeof(ex));
	set_fs( __MS__76 0x2B  __ME__ );
	if (error != sizeof(ex))
		return -  __MS__50 8  __ME__ ;

	 
	if (( __MS__106 (( __ME__  ex  __MS__106 ).a_info & 0xffff)  __ME__  !=  __MS__106 0413  __ME__  &&  __MS__106 (( __ME__  ex  __MS__106 ).a_info & 0xffff)  __ME__  !=  __MS__106 0314  __ME__ ) ||  __MS__107 (( __ME__  ex  __MS__107 ).a_trsize)  __ME__  ||
	     __MS__107 (( __ME__  ex  __MS__107 ).a_drsize)  __ME__  || ((ex.a_entry & 0xfff) &&  __MS__106 (( __ME__  ex  __MS__106 ).a_info & 0xffff)  __ME__  ==  __MS__106 0413  __ME__ ) ||
	    inode->i_size < ex.a_text+ex.a_data+ __MS__107 (( __ME__  ex  __MS__107 ).a_syms)  __ME__ + __MS__106 (((  __ME__  ex  __MS__106  ).a_info & 0xffff)  == 0413  ? (1024 - sizeof (struct exec))  + sizeof (struct exec) : (((  __ME__  ex  __MS__106  ).a_info & 0xffff)  == 0314  ? 0 : sizeof (struct exec)))  __ME__ ) {
		return -  __MS__50 8  __ME__ ;
	}
	if ( __MS__106 (( __ME__  ex  __MS__106 ).a_info & 0xffff)  __ME__  ==  __MS__106 0413  __ME__  &&  __MS__106 (((  __ME__  ex  __MS__106  ).a_info & 0xffff)  == 0413  ? (1024 - sizeof (struct exec))  + sizeof (struct exec) : (((  __ME__  ex  __MS__106  ).a_info & 0xffff)  == 0314  ? 0 : sizeof (struct exec)))  __ME__  && 
	    ( __MS__106 (((  __ME__  ex  __MS__106  ).a_info & 0xffff)  == 0413  ? (1024 - sizeof (struct exec))  + sizeof (struct exec) : (((  __ME__  ex  __MS__106  ).a_info & 0xffff)  == 0314  ? 0 : sizeof (struct exec)))  __ME__  < inode->i_sb->s_blocksize)) {
		printk("N_TXTOFF < BLOCK_SIZE. Please convert library\n");
		return -  __MS__50 8  __ME__ ;
	}
	
	if ( __MS__106 ((( __ME__  ex  __MS__106 ).a_info >> 24) & 0xff)  __ME__ ) return -  __MS__50 8  __ME__ ;

	 


	start_addr =  ex.a_entry & 0xfffff000;

	 
	error = do_mmap(file, start_addr, ex.a_text + ex.a_data,
			 __MS__105 0x1  __ME__  |  __MS__105 0x2  __ME__  |  __MS__105 0x4  __ME__ ,
			 __MS__105 0x10  __ME__  |  __MS__105 0x02  __ME__  |  __MS__105 0x0800  __ME__ ,
			 __MS__106 (((  __ME__  ex  __MS__106  ).a_info & 0xffff)  == 0413  ? (1024 - sizeof (struct exec))  + sizeof (struct exec) : (((  __ME__  ex  __MS__106  ).a_info & 0xffff)  == 0314  ? 0 : sizeof (struct exec)))  __ME__ );
	if (error != start_addr)
		return error;
	len =  __MS__77 ((( __ME__  ex.a_text + ex.a_data  __MS__77 )+(1UL << 12 ) -1)&(~((1UL << 12 ) -1)) )  __ME__ ;
	bss = ex.a_text + ex.a_data + ex.a_bss;
	if (bss > len) {
		error = do_mmap( __MS__11 ((void *) 0)  __ME__ , start_addr + len, bss-len,
				 __MS__105 0x1  __ME__ |  __MS__105 0x2  __ME__ |  __MS__105 0x4  __ME__ ,
				 __MS__105 0x02  __ME__ |  __MS__105 0x10  __ME__ , 0);
		if (error != start_addr + len)
			return error;
	}
	return 0;
}

static int
load_aout_library(int fd)
{
	int retval;

	 __MS__3 do { } while (0)  __ME__ ;
	retval = do_load_aout_library(fd);
	 __MS__3 do { } while (0)  __ME__ ;
	return retval;
}


int init_aout_binfmt(void) {
	return register_binfmt(&aout_format);
}

# 500 "binfmt_aout.c"


