/* Generated automatically by the program `genoutput'
from the machine description file `md'.  */

#include "config.h"
#include "rtl.h"
#include "regs.h"
#include "hard-reg-set.h"
#include "real.h"
#include "insn-config.h"

#include "conditions.h"
#include "insn-flags.h"
#include "insn-attr.h"

#include "insn-codes.h"

#include "recog.h"

#include <stdio.h>
#include "output.h"

static char *
output_62 (operands, insn)
     rtx *operands;
     rtx insn;
{
 return output_scc_insn (operands, insn); 
}

static char *
output_63 (operands, insn)
     rtx *operands;
     rtx insn;
{
 return output_scc_insn (operands, insn); 
}

static char *
output_74 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
  return output_cbranch (operands[0], 0, 1, 0,
			 final_sequence && INSN_ANNULLED_BRANCH_P (insn),
			 ! final_sequence);
}
}

static char *
output_75 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
  return output_cbranch (operands[0], 0, 1, 1,
			 final_sequence && INSN_ANNULLED_BRANCH_P (insn),
			 ! final_sequence);
}
}

static char *
output_76 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
  return output_cbranch (operands[0], operands[1], 2, 0,
			 final_sequence && INSN_ANNULLED_BRANCH_P (insn),
			 ! final_sequence);
}
}

static char *
output_77 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
  return output_cbranch (operands[0], operands[1], 2, 1,
			 final_sequence && INSN_ANNULLED_BRANCH_P (insn),
			 ! final_sequence);
}
}

static char *
output_78 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
  return output_cbranch (operands[0], operands[1], 2, 0,
			 final_sequence && INSN_ANNULLED_BRANCH_P (insn),
			 ! final_sequence);
}
}

static char *
output_79 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
  return output_cbranch (operands[0], operands[1], 2, 1,
			 final_sequence && INSN_ANNULLED_BRANCH_P (insn),
			 ! final_sequence);
}
}

static char *
output_80 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
  return output_v9branch (operands[0], 1, 2, 0,
			  final_sequence && INSN_ANNULLED_BRANCH_P (insn),
			  ! final_sequence);
}
}

static char *
output_81 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
  return output_v9branch (operands[0], 1, 2, 1,
			  final_sequence && INSN_ANNULLED_BRANCH_P (insn),
			  ! final_sequence);
}
}

static char *
output_82 (operands, insn)
     rtx *operands;
     rtx insn;
{
 return TARGET_V9 ? "add %1,%%lo(%a2),%0" : "or %1,%%lo(%a2),%0";
}

static char *
output_83 (operands, insn)
     rtx *operands;
     rtx insn;
{
 return TARGET_V9 ? "add %1,%%lo(%a2),%0" : "or %1,%%lo(%a2),%0";
}

static char *
output_89 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
  /* Don't output a 64 bit constant, since we can't trust the assembler to
     handle it correctly.  */
  if (GET_CODE (operands[2]) == CONST_DOUBLE)
    operands[2] = gen_rtx (CONST_INT, VOIDmode, CONST_DOUBLE_LOW (operands[2]));
  return "or %R1,%%lo(%a2),%R0";
}
}

static char *
output_90 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
  /* Don't output a 64 bit constant, since we can't trust the assembler to
     handle it correctly.  */
  if (GET_CODE (operands[2]) == CONST_DOUBLE)
    operands[2] = gen_rtx (CONST_INT, VOIDmode, CONST_DOUBLE_LOW (operands[2]));
  /* Note that we use add here.  This is important because Medium/Anywhere
     code model support depends on it.  */
  return "add %1,%%lo(%a2),%0";
}
}

static char *
output_91 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
  rtx op0 = operands[0];
  rtx op1 = operands[1];

  if (GET_CODE (op1) == CONST_INT)
    {
      operands[0] = operand_subword (op0, 1, 0, DImode);
      output_asm_insn ("sethi %%hi(%a1),%0", operands);

      operands[0] = operand_subword (op0, 0, 0, DImode);
      if (INTVAL (op1) < 0)
	return "mov -1,%0";
      else
	return "mov 0,%0";
    }
  else if (GET_CODE (op1) == CONST_DOUBLE)
    {
      operands[0] = operand_subword (op0, 1, 0, DImode);
      operands[1] = gen_rtx (CONST_INT, VOIDmode, CONST_DOUBLE_LOW (op1));
      output_asm_insn ("sethi %%hi(%a1),%0", operands);

      operands[0] = operand_subword (op0, 0, 0, DImode);
      operands[1] = gen_rtx (CONST_INT, VOIDmode, CONST_DOUBLE_HIGH (op1));
      return singlemove_string (operands);
    }
  else
    abort ();
  return "";
}
}

static char *
output_92 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
  rtx high, low;
  
  split_double (operands[1], &high, &low);

  if (high == const0_rtx)
    {
      operands[1] = low;
      output_asm_insn ("sethi %%hi(%a1),%0", operands);
    }
  else
    {
      operands[1] = high;
      output_asm_insn (singlemove_string (operands), operands);

      operands[1] = low;
      output_asm_insn ("sllx %0,32,%0", operands);
      if (low != const0_rtx)
	output_asm_insn ("sethi %%hi(%a1),%%g1; or %0,%%g1,%0", operands);
    }
}
}

static char *
output_98 (operands, insn)
     rtx *operands;
     rtx insn;
{
  static /*const*/ char *const strings_98[] = {
    "mov %1,%0",
    "sethi %%hi(%a1),%0",
    "ldub %1,%0",
    "stb %r1,%0",
  };
  return strings_98[which_alternative];
}

static char *
output_102 (operands, insn)
     rtx *operands;
     rtx insn;
{
  static /*const*/ char *const strings_102[] = {
    "mov %1,%0",
    "sethi %%hi(%a1),%0",
    "lduh %1,%0",
    "sth %r1,%0",
  };
  return strings_102[which_alternative];
}

static char *
output_106 (operands, insn)
     rtx *operands;
     rtx insn;
{
  static /*const*/ char *const strings_106[] = {
    "mov %1,%0",
    "fmovs %1,%0",
    "sethi %%hi(%a1),%0",
    "ld %1,%0",
    "ld %1,%0",
    "st %r1,%0",
    "st %r1,%0",
  };
  return strings_106[which_alternative];
}

static char *
output_109 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
  if (FP_REG_P (operands[0]) || FP_REG_P (operands[1]))
    return output_fp_move_double (operands);
  return output_move_double (operands);
}
}

static char *
output_110 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
  switch (which_alternative)
    {
    case 0:
      return "mov %1,%0";
    case 1:
      /* Sethi does not sign extend, so we must use a little trickery
	 to use it for negative numbers.  Invert the constant before
	 loading it in, then use a xor immediate to invert the loaded bits
	 (along with the upper 32 bits) to the desired constant.  This
	 works because the sethi and immediate fields overlap.  */

      if ((INTVAL (operands[1]) & 0x80000000) == 0)
	return "sethi %%hi(%a1),%0";
      else
	{
	  operands[1] = gen_rtx (CONST_INT, VOIDmode,
				 ~ INTVAL (operands[1]));
	  output_asm_insn ("sethi %%hi(%a1),%0", operands);
	  /* The low 10 bits are already zero, but invert the rest.
	     Assemblers don't accept 0x1c00, so use -0x400 instead.  */
	  return "xor %0,-0x400,%0";
	}
    case 2:
      return "ldx %1,%0";
    case 3:
      return "stx %r1,%0";
    case 4:
      return "mov %1,%0";
    case 5:
      return "ldd %1,%0";
    case 6:
      return "std %1,%0";
    }
}
}

static char *
output_111 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
  switch (which_alternative)
    {
    case 0:
      return singlemove_string (operands);
    case 1:
      return "ld %1,%0";
    case 2:
      return "st %%g0,%0";
    }
}
}

static char *
output_113 (operands, insn)
     rtx *operands;
     rtx insn;
{
  static /*const*/ char *const strings_113[] = {
    "fmovs %1,%0",
    "mov %1,%0",
    "ld %1,%0",
    "ld %1,%0",
    "st %r1,%0",
    "st %r1,%0",
  };
  return strings_113[which_alternative];
}

static char *
output_114 (operands, insn)
     rtx *operands;
     rtx insn;
{
  static /*const*/ char *const strings_114[] = {
    "mov %1,%0",
    "ld %1,%0",
    "st %r1,%0",
  };
  return strings_114[which_alternative];
}

static char *
output_116 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
  switch (which_alternative)
    {
    case 0:
      return output_move_double (operands);
    case 1:
      return output_fp_move_double (operands);
    case 2:
      if (TARGET_V9)
	{
	  return "stx %%g0,%0";
	}
      else
	{
	  operands[1] = adj_offsettable_operand (operands[0], 4);
	  return "st %%g0,%0\n\tst %%g0,%1";
	}
    }
}
}

static char *
output_118 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
  if (FP_REG_P (operands[0]) || FP_REG_P (operands[1]))
    return output_fp_move_double (operands);
  return output_move_double (operands);
}
}

static char *
output_119 (operands, insn)
     rtx *operands;
     rtx insn;
{
 return output_move_double (operands);
}

static char *
output_121 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
  output_asm_insn ("sethi %%hi(%a0),%2", operands);
  if (which_alternative == 0)
    return "std %1,[%2+%%lo(%a0)]";
  else
    return "st %%g0,[%2+%%lo(%a0)]\n\tst %%g0,[%2+%%lo(%a0+4)]";
}
}

static char *
output_122 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
  switch (which_alternative)
    {
    case 0:
      return output_move_quad (operands);
    case 1:
      return output_fp_move_quad (operands);
    case 2:
      if (TARGET_V9)
	{
	  operands[1] = adj_offsettable_operand (operands[0], 8);
	  return "stx %%g0,%0\n\tstx %%g0,%1";
	}
      else
	{
	  /* ??? Do we run off the end of the array here? */
	  operands[1] = adj_offsettable_operand (operands[0], 4);
	  operands[2] = adj_offsettable_operand (operands[0], 8);
	  operands[3] = adj_offsettable_operand (operands[0], 12);
	  return "st %%g0,%0\n\tst %%g0,%1\n\tst %%g0,%2\n\tst %%g0,%3";
	}
    }
}
}

static char *
output_124 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
  if (FP_REG_P (operands[0]) || FP_REG_P (operands[1]))
    return output_fp_move_quad (operands);
  return output_move_quad (operands);
}
}

static char *
output_125 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
  if (FP_REG_P (operands[0]) || FP_REG_P (operands[1]))
    return output_fp_move_quad (operands);
  return output_move_quad (operands);
}
}

static char *
output_126 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
  output_asm_insn ("sethi %%hi(%a0),%2", operands);
  if (which_alternative == 0)
    return "std %1,[%2+%%lo(%a0)]\n\tstd %S1,[%2+%%lo(%a0+8)]";
  else
    return "st %%g0,[%2+%%lo(%a0)]\n\tst %%g0,[%2+%%lo(%a0+4)]\n\t st %%g0,[%2+%%lo(%a0+8)]\n\tst %%g0,[%2+%%lo(%a0+12)]";
}
}

static char *
output_155 (operands, insn)
     rtx *operands;
     rtx insn;
{
  static /*const*/ char *const strings_155[] = {
    "and %1,0xff,%0",
    "ldub %1,%0",
  };
  return strings_155[which_alternative];
}

static char *
output_157 (operands, insn)
     rtx *operands;
     rtx insn;
{
  static /*const*/ char *const strings_157[] = {
    "and %1,0xff,%0",
    "ldub %1,%0",
  };
  return strings_157[which_alternative];
}

static char *
output_159 (operands, insn)
     rtx *operands;
     rtx insn;
{
  static /*const*/ char *const strings_159[] = {
    "and %1,0xff,%0",
    "ldub %1,%0",
  };
  return strings_159[which_alternative];
}

static char *
output_163 (operands, insn)
     rtx *operands;
     rtx insn;
{
  static /*const*/ char *const strings_163[] = {
    "srl %1,0,%0",
    "lduw %1,%0",
  };
  return strings_163[which_alternative];
}

static char *
output_179 (operands, insn)
     rtx *operands;
     rtx insn;
{
  static /*const*/ char *const strings_179[] = {
    "sra %1,0,%0",
    "ldsw %1,%0",
  };
  return strings_179[which_alternative];
}

static char *
output_180 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
  int len = INTVAL (operands[1]);
  int pos = 32 - INTVAL (operands[2]) - len;
  unsigned mask = ((1 << len) - 1) << pos;

  operands[1] = gen_rtx (CONST_INT, VOIDmode, mask);
  return "andcc %0,%1,%%g0";
}
}

static char *
output_181 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
  int len = INTVAL (operands[1]);
  int pos = 64 - INTVAL (operands[2]) - len;
  unsigned mask = ((1 << len) - 1) << pos;

  operands[1] = gen_rtx (CONST_INT, VOIDmode, mask);
  return "andcc %0,%1,%%g0";
}
}

static char *
output_194 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
  if (GET_CODE (operands[1]) == MEM)
    output_asm_insn ("ldd %1,%2", operands);
  else
    output_asm_insn ("stx %1,%3\n\tldd %3,%2", operands);
  return "fxtos %2,%0";
}
}

static char *
output_195 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
  if (GET_CODE (operands[1]) == MEM)
    output_asm_insn ("ldd %1,%2", operands);
  else
    output_asm_insn ("stx %1,%3\n\tldd %3,%2", operands);
  return "fxtod %2,%0";
}
}

static char *
output_196 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
  if (GET_CODE (operands[1]) == MEM)
    output_asm_insn ("ldd %1,%2", operands);
  else
    output_asm_insn ("stx %1,%3\n\tldd %3,%2", operands);
  return "fxtoq %2,%0";
}
}

static char *
output_206 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
  output_asm_insn ("fstox %1,%2", operands);
  if (GET_CODE (operands[0]) == MEM)
    return "std %2,%0";
  else
    return "std %2,%3\n\tldx %3,%0";
}
}

static char *
output_207 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
  output_asm_insn ("fdtox %1,%2", operands);
  if (GET_CODE (operands[0]) == MEM)
    return "std %2,%0";
  else
    return "std %2,%3\n\tldx %3,%0";
}
}

static char *
output_208 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
  output_asm_insn ("fqtox %1,%2", operands);
  if (GET_CODE (operands[0]) == MEM)
    return "std %2,%0";
  else
    return "std %2,%3\n\tldx %3,%0";
}
}

static char *
output_213 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
  rtx op2 = operands[2];

  /* If constant is positive, upper bits zeroed, otherwise unchanged.
     Give the assembler a chance to pick the move instruction. */
  if (GET_CODE (op2) == CONST_INT)
    {
      int sign = INTVAL (op2);
      if (sign < 0)
	return "addcc %R1,%2,%R0\n\taddx %1,-1,%0";
      return "addcc %R1,%2,%R0\n\taddx %1,0,%0";
    }
  else if (GET_CODE (op2) == CONST_DOUBLE)
    {
      rtx xoperands[4];
      xoperands[0] = operands[0];
      xoperands[1] = operands[1];
      xoperands[2] = GEN_INT (CONST_DOUBLE_LOW (op2));
      xoperands[3] = GEN_INT (CONST_DOUBLE_HIGH (op2));
      if (xoperands[2] == const0_rtx && xoperands[0] == xoperands[1])
	output_asm_insn ("add %1,%3,%0", xoperands);
      else
	output_asm_insn ("addcc %R1,%2,%R0\n\taddx %1,%3,%0", xoperands);
      return "";
    }
  return "addcc %R1,%R2,%R0\n\taddx %1,%2,%0";
}
}

static char *
output_221 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
  rtx op2 = operands[2];

  /* If constant is positive, upper bits zeroed, otherwise unchanged.
     Give the assembler a chance to pick the move instruction. */
  if (GET_CODE (op2) == CONST_INT)
    {
      int sign = INTVAL (op2);
      if (sign < 0)
	return "subcc %R1,%2,%R0\n\tsubx %1,-1,%0";
      return "subcc %R1,%2,%R0\n\tsubx %1,0,%0";
    }
  else if (GET_CODE (op2) == CONST_DOUBLE)
    {
      rtx xoperands[4];
      xoperands[0] = operands[0];
      xoperands[1] = operands[1];
      xoperands[2] = GEN_INT (CONST_DOUBLE_LOW (op2));
      xoperands[3] = GEN_INT (CONST_DOUBLE_HIGH (op2));
      if (xoperands[2] == const0_rtx && xoperands[0] == xoperands[1])
	output_asm_insn ("sub %1,%3,%0", xoperands);
      else
	output_asm_insn ("subcc %R1,%2,%R0\n\tsubx %1,%3,%0", xoperands);
      return "";
    }
  return "subcc %R1,%R2,%R0\n\tsubx %1,%2,%0";
}
}

static char *
output_250 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
  rtx op2 = operands[2];

  /* If constant is positive, upper bits zeroed, otherwise unchanged.
     Give the assembler a chance to pick the move instruction. */
  if (GET_CODE (op2) == CONST_INT)
    {
      int sign = INTVAL (op2);
      if (sign < 0)
	return "mov %1,%0\n\tand %R1,%2,%R0";
      return "mov 0,%0\n\tand %R1,%2,%R0";
    }
  else if (GET_CODE (op2) == CONST_DOUBLE)
    {
      rtx xoperands[4];
      xoperands[0] = operands[0];
      xoperands[1] = operands[1];
      xoperands[2] = GEN_INT (CONST_DOUBLE_LOW (op2));
      xoperands[3] = GEN_INT (CONST_DOUBLE_HIGH (op2));
      /* We could optimize then operands[1] == operands[0]
	 and either half of the constant is -1.  */
      output_asm_insn ("and %R1,%2,%R0\n\tand %1,%3,%0", xoperands);
      return "";
    }
  return "and %1,%2,%0\n\tand %R1,%R2,%R0";
}
}

static char *
output_258 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
  rtx op2 = operands[2];

  /* If constant is positive, upper bits zeroed, otherwise unchanged.
     Give the assembler a chance to pick the move instruction. */
  if (GET_CODE (op2) == CONST_INT)
    {
      int sign = INTVAL (op2);
      if (sign < 0)
	return "mov -1,%0\n\tor %R1,%2,%R0";
      return "mov %1,%0\n\tor %R1,%2,%R0";
    }
  else if (GET_CODE (op2) == CONST_DOUBLE)
    {
      rtx xoperands[4];
      xoperands[0] = operands[0];
      xoperands[1] = operands[1];
      xoperands[2] = GEN_INT (CONST_DOUBLE_LOW (op2));
      xoperands[3] = GEN_INT (CONST_DOUBLE_HIGH (op2));
      /* We could optimize then operands[1] == operands[0]
	 and either half of the constant is 0.  */
      output_asm_insn ("or %R1,%2,%R0\n\tor %1,%3,%0", xoperands);
      return "";
    }
  return "or %1,%2,%0\n\tor %R1,%R2,%R0";
}
}

static char *
output_266 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
  rtx op2 = operands[2];

  /* If constant is positive, upper bits zeroed, otherwise unchanged.
     Give the assembler a chance to pick the move instruction. */
  if (GET_CODE (op2) == CONST_INT)
    {
      int sign = INTVAL (op2);
      if (sign < 0)
	return "xor %1,-1,%0\n\txor %R1,%2,%R0";
      return "mov %1,%0\n\txor %R1,%2,%R0";
    }
  else if (GET_CODE (op2) == CONST_DOUBLE)
    {
      rtx xoperands[4];
      xoperands[0] = operands[0];
      xoperands[1] = operands[1];
      xoperands[2] = GEN_INT (CONST_DOUBLE_LOW (op2));
      xoperands[3] = GEN_INT (CONST_DOUBLE_HIGH (op2));
      /* We could optimize then operands[1] == operands[0]
	 and either half of the constant is 0.  */
      output_asm_insn ("xor %R1,%2,%R0\n\txor %1,%3,%0", xoperands);
      return "";
    }
  return "xor %1,%2,%0\n\txor %R1,%R2,%R0";
}
}

static char *
output_316 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
  if (TARGET_V9)
    return "fnegd %1,%0"; /* Can't use fnegs, won't work with upper regs.  */
  else if (which_alternative == 0)
   return "fnegs %0,%0";
  else
   return "fnegs %1,%0\n\tfmovs %R1,%R0\n\tfmovs %S1,%S0\n\tfmovs %T1,%T0";
}
}

static char *
output_317 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
  if (TARGET_V9)
    return "fnegd %1,%0";
  else if (which_alternative == 0)
   return "fnegs %0,%0";
  else
   return "fnegs %1,%0\n\tfmovs %R1,%R0";
}
}

static char *
output_319 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
  if (TARGET_V9)
    return "fabsd %1,%0"; /* Can't use fabss, won't work with upper regs.  */
  else if (which_alternative == 0)
    return "fabss %0,%0";
  else
    return "fabss %1,%0\n\tfmovs %R1,%R0\n\tfmovs %S1,%S0\n\tfmovs %T1,%T0";
}
}

static char *
output_320 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
  if (TARGET_V9)
    return "fabsd %1,%0";
  else if (which_alternative == 0)
    return "fabss %0,%0";
  else
    return "fabss %1,%0\n\tfmovs %R1,%R0";
}
}

static char *
output_325 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
  if (GET_CODE (operands[2]) == CONST_INT
      && (unsigned) INTVAL (operands[2]) > 31)
    operands[2] = GEN_INT (INTVAL (operands[2]) & 0x1f);

  return "sll %1,%2,%0";
}
}

static char *
output_326 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
  if (GET_CODE (operands[2]) == CONST_INT
      && (unsigned) INTVAL (operands[2]) > 63)
    operands[2] = GEN_INT (INTVAL (operands[2]) & 0x3f);

  return "sllx %1,%2,%0";
}
}

static char *
output_329 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
  if (GET_CODE (operands[2]) == CONST_INT
      && (unsigned) INTVAL (operands[2]) > 31)
    operands[2] = GEN_INT (INTVAL (operands[2]) & 0x1f);

  return "sra %1,%2,%0";
}
}

static char *
output_330 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
  if (GET_CODE (operands[2]) == CONST_INT
      && (unsigned) INTVAL (operands[2]) > 63)
    operands[2] = GEN_INT (INTVAL (operands[2]) & 0x3f);

  return "srax %1,%2,%0";
}
}

static char *
output_331 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
  if (GET_CODE (operands[2]) == CONST_INT
      && (unsigned) INTVAL (operands[2]) > 31)
    operands[2] = GEN_INT (INTVAL (operands[2]) & 0x1f);

  return "srl %1,%2,%0";
}
}

static char *
output_332 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
  if (GET_CODE (operands[2]) == CONST_INT
      && (unsigned) INTVAL (operands[2]) > 63)
    operands[2] = GEN_INT (INTVAL (operands[2]) & 0x3f);

  return "srlx %1,%2,%0";
}
}

static char *
output_342 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
  return "call %a0,%1%#";
}
}

static char *
output_343 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
  return "call %a0,%1%#";
}
}

static char *
output_344 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
  return "call %a0,%1%#";
}
}

static char *
output_345 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
  return "call %a0,%1%#";
}
}

static char *
output_346 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
  return "call %a0,%1\n\tnop\n\tunimp %2";
}
}

static char *
output_347 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
  return "call %a0,%1\n\tnop\n\tunimp %2";
}
}

static char *
output_349 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
  return "call %a1,%2%#";
}
}

static char *
output_350 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
  return "call %a1,%2%#";
}
}

static char *
output_351 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
  return "call %a1,%2%#";
}
}

static char *
output_352 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
  return "call %a1,%2%#";
}
}

static char *
output_354 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
  operands[2] = adj_offsettable_operand (operands[1], 8);
  return "call %a0,0\n\tnop\n\tnop\n\tstd %%o0,%1\n\tstd %%f0,%2";
}
}

static char *
output_355 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
  operands[2] = adj_offsettable_operand (operands[1], 8);
  return "call %a0,0\n\tnop\n\tnop\n\tstd %%o0,%1\n\tstd %%f0,%2";
}
}

static char *
output_356 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
  operands[2] = adj_offsettable_operand (operands[1], 8);
  return "call %a0,0\n\tnop\n\tstx %%o0,%1\n\tstq %%f0,%2";
}
}

static char *
output_357 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
  operands[2] = adj_offsettable_operand (operands[1], 8);
  return "call %a0,0\n\tnop\n\tstx %%o0,%1\n\tstq %%f0,%2";
}
}

static char *
output_360 (operands, insn)
     rtx *operands;
     rtx insn;
{
 return output_return (operands);
}

static char *
output_366 (operands, insn)
     rtx *operands;
     rtx insn;
{
 return TARGET_V9 ? "flushw" : "ta 3";
}

static char *
output_368 (operands, insn)
     rtx *operands;
     rtx insn;
{
 return TARGET_V9 ? "flush %a0" : "iflush %a0";
}

static char *
output_399 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
  warning ("bad peephole");
  if (! MEM_VOLATILE_P (operands[1]))
    abort ();
  return "ldsh %1,%2";
}
}

static char *
output_400 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
  warning ("bad peephole");
  if (! MEM_VOLATILE_P (operands[1]))
    abort ();
  return "ldsb %1,%2";
}
}

static char *
output_401 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
  /* Go by way of output_move_double in case the register in operand 2
     is not properly aligned for ldd.  */
  operands[1] = gen_rtx (MEM, DFmode,
			 gen_rtx (LO_SUM, SImode, operands[0], operands[1]));
  operands[0] = operands[2];
  return output_move_double (operands);
}
}

static char *
output_403 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
  if (! TARGET_V9 && current_function_returns_struct)
    return "jmp %%i7+12\n\trestore %%g0,%1,%Y0";
  else
    return "ret\n\trestore %%g0,%1,%Y0";
}
}

static char *
output_404 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
  if (! TARGET_V9 && current_function_returns_struct)
    return "jmp %%i7+12\n\trestore %%g0,%1,%Y0";
  else
    return "ret\n\trestore %%g0,%1,%Y0";
}
}

static char *
output_405 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
  if (! TARGET_V9 && current_function_returns_struct)
    return "jmp %%i7+12\n\trestore %%g0,%1,%Y0";
  else
    return "ret\n\trestore %%g0,%1,%Y0";
}
}

static char *
output_406 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
  if (! TARGET_V9 && current_function_returns_struct)
    return "jmp %%i7+12\n\trestore %%g0,%1,%Y0";
  else
    return "ret\n\trestore %%g0,%1,%Y0";
}
}

static char *
output_407 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
  if (! TARGET_V9 && current_function_returns_struct)
    return "jmp %%i7+12\n\trestore %r1,%2,%Y0";
  else
    return "ret\n\trestore %r1,%2,%Y0";
}
}

static char *
output_411 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
  return "call %a1,%2\n\tadd %%o7,(%l3-.-4),%%o7";
}
}

static char *
output_412 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
  return "call %a0,%1\n\tadd %%o7,(%l2-.-4),%%o7";
}
}

static char *
output_413 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
  return "call %a1,%2\n\tadd %%o7,(%l3-.-4),%%o7";
}
}

static char *
output_414 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
  return "call %a0,%1\n\tadd %%o7,(%l2-.-4),%%o7";
}
}

char * const insn_template[] =
  {
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    "cmp %r0,%1",
    "fcmpes %0,%1",
    "fcmped %0,%1",
    "fcmpeq %0,%1",
    "fcmps %0,%1",
    "fcmpd %0,%1",
    "fcmpq %0,%1",
    "cmp %r0,%1",
    "fcmpes %0,%1,%2",
    "fcmped %0,%1,%2",
    "fcmpeq %0,%1,%2",
    "fcmps %0,%1,%2",
    "fcmpd %0,%1,%2",
    "fcmpq %0,%1,%2",
    "subcc %%g0,%1,%%g0\n\taddx %%g0,0,%0",
    "subcc %%g0,%1,%%g0\n\tsubx %%g0,0,%0",
    "mov 0,%0\n\tmovrnz %1,1,%0",
    "mov 0,%0\n\tmovrnz %1,-1,%0",
    "subcc %%g0,%1,%%g0\n\tsubx %%g0,-1,%0",
    "subcc %%g0,%1,%%g0\n\taddx %%g0,-1,%0",
    "mov 0,%0\n\tmovrz %1,1,%0",
    "mov 0,%0\n\tmovrz %1,-1,%0",
    "subcc %%g0,%1,%%g0\n\taddx %2,0,%0",
    "subcc %%g0,%1,%%g0\n\tsubx %2,0,%0",
    "subcc %%g0,%1,%%g0\n\tsubx %2,-1,%0",
    "subcc %%g0,%1,%%g0\n\taddx %2,-1,%0",
    "addx %%g0,0,%0",
    "subx %%g0,0,%0",
    "subx %%g0,%1,%0",
    "subx %%g0,%1,%0",
    "subx %%g0,-1,%0",
    "addx %%g0,-1,%0",
    "addx %%g0,%1,%0",
    "addx %1,%2,%0",
    "subx %1,0,%0",
    "subx %1,%2,%0",
    "subx %1,%2,%0",
    "subx %1,-1,%0",
    "addx %1,-1,%0",
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    "sethi %%hi(%a1),%0",
    "sethi %%hi(%a1),%0",
    "sethi %%hi(%a1),%0",
    "\n1:\n\tcall 2f\n\tsethi %%hi(%l1-1b),%0\n2:\tor %0,%%lo(%l1-1b),%0\n\tadd %0,%%o7,%0",
    "\n1:\n\tcall 2f\n\tsethi %%hi(%l1-1b),%0\n2:\tor %0,%%lo(%l1-1b),%0\n\tadd %0,%%o7,%0",
    0,
    0,
    0,
    0,
    "sethi %%hi(%a1),%0",
    "sethi %%hi(%a1),%0; add %0,%%g4,%0",
    "sethi %%hi(%a1),%0",
    "sethi %%uhi(%a1),%%g1; or %%g1,%%ulo(%a1),%%g1; sllx %%g1,32,%%g1; sethi %%hi(%a1),%0; or %0,%%g1,%0",
    0,
    0,
    "or %1,%%lo(%a2),%0",
    "sethi %%hi(%a0),%2\n\tstb %r1,[%2+%%lo(%a0)]",
    0,
    0,
    "or %1,%%lo(%a2),%0",
    "sethi %%hi(%a0),%2\n\tsth %r1,[%2+%%lo(%a0)]",
    0,
    0,
    "sethi %%hi(%a0),%2\n\tst %r1,[%2+%%lo(%a0)]",
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    "sethi %%hi(%a0),%2\n\tst %r1,[%2+%%lo(%a0)]",
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    "mov%C1 %%icc,%2,%0",
    "mov%C1 %%icc,%2,%0",
    "mov%C1 %%xcc,%2,%0",
    "mov%C1 %%xcc,%2,%0",
    "mov%C1 %2,%3,%0",
    "mov%C1 %2,%3,%0",
    "mov%C1 %2,%3,%0",
    "mov%C1 %2,%3,%0",
    "movr%D1 %2,%r3,%0",
    "movr%D1 %2,%r3,%0",
    "fmovrs%D1 %2,%r3,%0",
    "fmovrd%D1 %2,%r3,%0",
    "fmovrq%D1 %2,%r3,%0",
    "fmovs%C1 %2,%3,%0",
    "fmovs%C1 %2,%3,%0",
    "fmovd%C1 %2,%3,%0",
    "fmovd%C1 %2,%3,%0",
    "fmovq%C1 %2,%3,%0",
    "fmovq%C1 %2,%3,%0",
    "fmovs%C1 %%icc,%2,%0",
    "fmovd%C1 %%icc,%2,%0",
    "fmovq%C1 %%icc,%2,%0",
    "fmovs%C1 %%xcc,%2,%0",
    "fmovd%C1 %%xcc,%2,%0",
    "fmovq%C1 %%xcc,%2,%0",
    0,
    "lduh %1,%0",
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    "lduh %1,%0",
    0,
    0,
    "andcc %0,0xff,%%g0",
    "andcc %1,0xff,%0",
    "andcc %0,0xff,%%g0",
    "andcc %1,0xff,%0",
    0,
    "ldsh %1,%0",
    0,
    "ldsb %1,%0",
    0,
    "ldsb %1,%0",
    0,
    "ldsb %1,%0",
    0,
    "ldsh %1,%0",
    0,
    0,
    0,
    0,
    "fstod %1,%0",
    "fstoq %1,%0",
    "fdtoq %1,%0",
    "fdtos %1,%0",
    "fqtos %1,%0",
    "fqtod %1,%0",
    "fitos %1,%0",
    "fitod %1,%0",
    "fitoq %1,%0",
    0,
    0,
    0,
    0,
    0,
    0,
    "fxtos %1,%0",
    "fxtod %1,%0",
    "fxtoq %1,%0",
    "fstoi %1,%0",
    "fdtoi %1,%0",
    "fqtoi %1,%0",
    0,
    0,
    0,
    0,
    0,
    0,
    "fstox %1,%0",
    "fdtox %1,%0",
    "fqtox %1,%0",
    0,
    0,
    "add %1,%2,%0",
    "add %1,%2,%0",
    "addcc %0,%1,%%g0",
    "addcc %0,%1,%%g0",
    "addcc %1,%2,%0",
    "addcc %1,%2,%0",
    0,
    0,
    "sub %1,%2,%0",
    "sub %1,%2,%0",
    "subcc %0,%1,%%g0",
    "subcc %0,%1,%%g0",
    "subcc %1,%2,%0",
    "subcc %1,%2,%0",
    "smul %1,%2,%0",
    "mulx %1,%2,%0",
    "smulcc %1,%2,%0",
    0,
    "smul %1,%2,%R0\n\trd %%y,%0",
    "smul %1,%2,%R0\n\trd %%y,%0",
    0,
    "smul %1,%2,%%g0\n\trd %%y,%0",
    "smul %1,%2,%%g0\n\trd %%y,%0",
    0,
    "umul %1,%2,%R0\n\trd %%y,%0",
    "umul %1,%2,%R0\n\trd %%y,%0",
    0,
    "umul %1,%2,%%g0\n\trd %%y,%0",
    "umul %1,%2,%%g0\n\trd %%y,%0",
    "sra %1,31,%3\n\twr %%g0,%3,%%y\n\tnop\n\tnop\n\tnop\n\tsdiv %1,%2,%0",
    "sdivx %1,%2,%0",
    "sra %1,31,%3\n\twr %%g0,%3,%%y\n\tnop\n\tnop\n\tnop\n\tsdivcc %1,%2,%0",
    "wr %%g0,%%g0,%%y\n\tnop\n\tnop\n\tnop\n\tudiv %1,%2,%0",
    "udivx %1,%2,%0",
    "wr %%g0,%%g0,%%y\n\tnop\n\tnop\n\tnop\n\tudivcc %1,%2,%0",
    0,
    0,
    "and %1,%2,%0",
    "and %1,%2,%0",
    0,
    "andn %2,%1,%0\n\tandn %R2,%R1,%R0",
    "andn %2,%1,%0",
    "andn %2,%1,%0",
    0,
    0,
    "or %1,%2,%0",
    "or %1,%2,%0",
    0,
    "orn %2,%1,%0\n\torn %R2,%R1,%R0",
    "orn %2,%1,%0",
    "orn %2,%1,%0",
    0,
    0,
    "xor %r1,%2,%0",
    "xor %r1,%2,%0",
    0,
    0,
    "xnor %1,%2,%0\n\txnor %R1,%R2,%R0",
    "xnor %r1,%2,%0",
    "xnor %r1,%2,%0",
    "%A2cc %0,%1,%%g0",
    "%A2cc %0,%1,%%g0",
    "%A3cc %1,%2,%0",
    "%A3cc %1,%2,%0",
    "xnorcc %r0,%1,%%g0",
    "xnorcc %r0,%1,%%g0",
    "xnorcc %r1,%2,%0",
    "xnorcc %r1,%2,%0",
    "%B2cc %r1,%0,%%g0",
    "%B2cc %r1,%0,%%g0",
    "%B3cc %r2,%1,%0",
    "%B3cc %r2,%1,%0",
    0,
    "subcc %%g0,%R1,%R0\n\tsubx %%g0,%1,%0",
    "sub %%g0,%1,%0",
    "sub %%g0,%1,%0",
    "subcc %%g0,%0,%%g0",
    "subcc %%g0,%0,%%g0",
    "subcc %%g0,%1,%0",
    "subcc %%g0,%1,%0",
    0,
    "xnor %%g0,%1,%0\n\txnor %%g0,%R1,%R0",
    "xnor %%g0,%1,%0",
    "xnor %%g0,%1,%0",
    "xnorcc %%g0,%0,%%g0",
    "xnorcc %%g0,%0,%%g0",
    "xnorcc %%g0,%1,%0",
    "xnorcc %%g0,%1,%0",
    "faddq %1,%2,%0",
    "faddd %1,%2,%0",
    "fadds %1,%2,%0",
    "fsubq %1,%2,%0",
    "fsubd %1,%2,%0",
    "fsubs %1,%2,%0",
    "fmulq %1,%2,%0",
    "fmuld %1,%2,%0",
    "fmuls %1,%2,%0",
    "fsmuld %1,%2,%0",
    "fdmulq %1,%2,%0",
    "fdivq %1,%2,%0",
    "fdivd %1,%2,%0",
    "fdivs %1,%2,%0",
    0,
    0,
    "fnegs %1,%0",
    0,
    0,
    "fabss %1,%0",
    "fsqrtq %1,%0",
    "fsqrtd %1,%0",
    "fsqrts %1,%0",
    0,
    0,
    "addcc %0,%0,%%g0",
    "addcc %1,%1,%0",
    0,
    0,
    0,
    0,
    "b%* %l0%(",
    0,
    "jmp %%o7+%0%#",
    "jmp %%o7+%0%#",
    "jmp %a0%#",
    "jmp %a0%#",
    "call %l0%#",
    "call %l0%#",
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    "cmp %1,0\n\tbe,a .+8\n\tadd %0,4,%0",
    0,
    "nop",
    0,
    "jmp %a0%#",
    "jmp %a0%#",
    0,
    0,
    "jmp %%o0+0\n\trestore",
    0,
    "sub %%g0,%1,%0\n\tand %0,%1,%0\n\tscan %0,0,%0\n\tmov 32,%2\n\tsub %2,%0,%0\n\tsra %0,31,%2\n\tand %2,31,%2\n\tadd %2,%0,%0",
    "neg %1,%2\n\tnot %2,%2\n\txor %1,%2,%2\n\tpopc %2,%0\n\tmovrz %1,%%g0,%0",
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    "ldd %1,%0",
    "std %1,%0",
    "ldd %1,%0",
    "std %1,%0",
    "ldd %3,%2",
    "std %3,%2",
    "ldd %3,%2",
    "std %3,%2",
    "orcc %1,%%g0,%0",
    "orcc %1,%%g0,%0",
    "ldsh %1,%0\n\torcc %0,%%g0,%2",
    "ldsh %1,%0\n\torcc %0,%%g0,%2",
    "ldsb %1,%0\n\torcc %0,%%g0,%2",
    "ldsb %1,%0\n\torcc %0,%%g0,%2",
    0,
    0,
    0,
    "ld [%0+%%lo(%a1)],%2",
    0,
    0,
    0,
    0,
    0,
    "ret\n\trestore %%g0,%1,%Y0",
    "ret\n\trestore %r1,%2,%Y0",
    "ret\n\tfmovs %0,%%f0",
    0,
    0,
    0,
    0,
    "subxcc %r1,0,%0",
  };

char *(*const insn_outfun[])() =
  {
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    output_62,
    output_63,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    output_74,
    output_75,
    output_76,
    output_77,
    output_78,
    output_79,
    output_80,
    output_81,
    output_82,
    output_83,
    0,
    0,
    0,
    0,
    0,
    output_89,
    output_90,
    output_91,
    output_92,
    0,
    0,
    0,
    0,
    0,
    output_98,
    0,
    0,
    0,
    output_102,
    0,
    0,
    0,
    output_106,
    0,
    0,
    output_109,
    output_110,
    output_111,
    0,
    output_113,
    output_114,
    0,
    output_116,
    0,
    output_118,
    output_119,
    0,
    output_121,
    output_122,
    0,
    output_124,
    output_125,
    output_126,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    output_155,
    0,
    output_157,
    0,
    output_159,
    0,
    0,
    0,
    output_163,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    output_179,
    output_180,
    output_181,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    output_194,
    output_195,
    output_196,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    output_206,
    output_207,
    output_208,
    0,
    0,
    0,
    0,
    output_213,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    output_221,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    output_250,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    output_258,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    output_266,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    output_316,
    output_317,
    0,
    output_319,
    output_320,
    0,
    0,
    0,
    0,
    output_325,
    output_326,
    0,
    0,
    output_329,
    output_330,
    output_331,
    output_332,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    output_342,
    output_343,
    output_344,
    output_345,
    output_346,
    output_347,
    0,
    output_349,
    output_350,
    output_351,
    output_352,
    0,
    output_354,
    output_355,
    output_356,
    output_357,
    0,
    0,
    output_360,
    0,
    0,
    0,
    0,
    0,
    output_366,
    0,
    output_368,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    output_399,
    output_400,
    output_401,
    0,
    output_403,
    output_404,
    output_405,
    output_406,
    output_407,
    0,
    0,
    0,
    output_411,
    output_412,
    output_413,
    output_414,
    0,
  };

rtx (*const insn_gen_function[]) () =
  {
    gen_cmpsi,
    gen_cmpdi,
    gen_cmpsf,
    gen_cmpdf,
    gen_cmptf,
    gen_seqsi_special,
    gen_seqdi_special,
    gen_snesi_special,
    gen_snedi_special,
    gen_seqdi_special_trunc,
    gen_snedi_special_trunc,
    gen_seqsi_special_extend,
    gen_snesi_special_extend,
    gen_seq,
    gen_sne,
    gen_sgt,
    gen_slt,
    gen_sge,
    gen_sle,
    gen_sgtu,
    gen_sltu,
    gen_sgeu,
    gen_sleu,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    gen_beq,
    gen_bne,
    gen_bgt,
    gen_bgtu,
    gen_blt,
    gen_bltu,
    gen_bge,
    gen_bgeu,
    gen_ble,
    gen_bleu,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    gen_movqi,
    0,
    0,
    0,
    gen_movhi,
    0,
    0,
    0,
    gen_movsi,
    0,
    0,
    gen_movdi,
    0,
    0,
    0,
    gen_movsf,
    0,
    0,
    0,
    0,
    gen_movdf,
    0,
    0,
    0,
    0,
    0,
    gen_movtf,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    gen_zero_extendhisi2,
    0,
    gen_zero_extendqihi2,
    0,
    gen_zero_extendqisi2,
    0,
    gen_zero_extendqidi2,
    0,
    gen_zero_extendhidi2,
    0,
    gen_zero_extendsidi2,
    0,
    0,
    0,
    0,
    0,
    gen_extendhisi2,
    0,
    gen_extendqihi2,
    0,
    gen_extendqisi2,
    0,
    gen_extendqidi2,
    0,
    gen_extendhidi2,
    0,
    gen_extendsidi2,
    0,
    0,
    0,
    gen_extendsfdf2,
    gen_extendsftf2,
    gen_extenddftf2,
    gen_truncdfsf2,
    gen_trunctfsf2,
    gen_trunctfdf2,
    gen_floatsisf2,
    gen_floatsidf2,
    gen_floatsitf2,
    gen_floatdisf2,
    gen_floatdidf2,
    gen_floatditf2,
    0,
    0,
    0,
    gen_floatdisf2_v9,
    gen_floatdidf2_v9,
    gen_floatditf2_v9,
    gen_fix_truncsfsi2,
    gen_fix_truncdfsi2,
    gen_fix_trunctfsi2,
    gen_fix_truncsfdi2,
    gen_fix_truncdfdi2,
    gen_fix_trunctfdi2,
    0,
    0,
    0,
    gen_fix_truncsfdi2_v9,
    gen_fix_truncdfdi2_v9,
    gen_fix_trunctfdi2_v9,
    gen_adddi3,
    0,
    0,
    gen_addsi3,
    0,
    0,
    0,
    0,
    gen_subdi3,
    0,
    0,
    gen_subsi3,
    0,
    0,
    0,
    0,
    gen_mulsi3,
    gen_muldi3,
    0,
    gen_mulsidi3,
    0,
    gen_const_mulsidi3,
    gen_smulsi3_highpart,
    0,
    gen_const_smulsi3_highpart,
    gen_umulsidi3,
    0,
    gen_const_umulsidi3,
    gen_umulsi3_highpart,
    0,
    gen_const_umulsi3_highpart,
    gen_divsi3,
    gen_divdi3,
    0,
    gen_udivsi3,
    gen_udivdi3,
    0,
    gen_anddi3,
    0,
    0,
    gen_andsi3,
    0,
    0,
    0,
    0,
    gen_iordi3,
    0,
    0,
    gen_iorsi3,
    0,
    0,
    0,
    0,
    gen_xordi3,
    0,
    0,
    gen_xorsi3,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    gen_negdi2,
    0,
    0,
    gen_negsi2,
    0,
    0,
    0,
    0,
    gen_one_cmpldi2,
    0,
    0,
    gen_one_cmplsi2,
    0,
    0,
    0,
    0,
    gen_addtf3,
    gen_adddf3,
    gen_addsf3,
    gen_subtf3,
    gen_subdf3,
    gen_subsf3,
    gen_multf3,
    gen_muldf3,
    gen_mulsf3,
    0,
    0,
    gen_divtf3,
    gen_divdf3,
    gen_divsf3,
    gen_negtf2,
    gen_negdf2,
    gen_negsf2,
    gen_abstf2,
    gen_absdf2,
    gen_abssf2,
    gen_sqrttf2,
    gen_sqrtdf2,
    gen_sqrtsf2,
    gen_ashlsi3,
    gen_ashldi3,
    0,
    0,
    gen_ashrsi3,
    gen_ashrdi3,
    gen_lshrsi3,
    gen_lshrdi3,
    gen_jump,
    gen_tablejump,
    gen_pic_tablejump_32,
    gen_pic_tablejump_64,
    0,
    0,
    0,
    0,
    gen_call,
    0,
    0,
    0,
    0,
    0,
    0,
    gen_call_value,
    0,
    0,
    0,
    0,
    gen_untyped_call,
    0,
    0,
    0,
    0,
    gen_untyped_return,
    gen_update_return,
    gen_return,
    gen_nop,
    gen_indirect_jump,
    0,
    0,
    gen_nonlocal_goto,
    gen_flush_register_windows,
    gen_goto_handler_and_restore,
    gen_flush,
    gen_ffssi2,
    gen_ffsdi2,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
  };

char *insn_name[] =
  {
    "cmpsi",
    "cmpdi",
    "cmpsf",
    "cmpdf",
    "cmptf",
    "seqsi_special",
    "seqdi_special",
    "snesi_special",
    "snedi_special",
    "seqdi_special_trunc",
    "snedi_special_trunc",
    "seqsi_special_extend",
    "snesi_special_extend",
    "seq",
    "sne",
    "sgt",
    "slt",
    "sge",
    "sle",
    "sgtu",
    "sltu",
    "sgeu",
    "sleu",
    "sleu+1",
    "sleu+2",
    "sleu+3",
    "sleu+4",
    "sleu+5",
    "sleu+6",
    "sleu+7",
    "sleu+8",
    "sleu+9",
    "sleu+10",
    "sleu+11",
    "sleu+12",
    "sleu+13",
    "sleu+14",
    "sleu+15",
    "sleu+16",
    "sleu+17",
    "sleu+18",
    "sleu+19",
    "sleu+20",
    "sleu+21",
    "beq-20",
    "beq-19",
    "beq-18",
    "beq-17",
    "beq-16",
    "beq-15",
    "beq-14",
    "beq-13",
    "beq-12",
    "beq-11",
    "beq-10",
    "beq-9",
    "beq-8",
    "beq-7",
    "beq-6",
    "beq-5",
    "beq-4",
    "beq-3",
    "beq-2",
    "beq-1",
    "beq",
    "bne",
    "bgt",
    "bgtu",
    "blt",
    "bltu",
    "bge",
    "bgeu",
    "ble",
    "bleu",
    "bleu+1",
    "bleu+2",
    "bleu+3",
    "bleu+4",
    "bleu+5",
    "bleu+6",
    "bleu+7",
    "bleu+8",
    "bleu+9",
    "bleu+10",
    "bleu+11",
    "bleu+12",
    "movqi-11",
    "movqi-10",
    "movqi-9",
    "movqi-8",
    "movqi-7",
    "movqi-6",
    "movqi-5",
    "movqi-4",
    "movqi-3",
    "movqi-2",
    "movqi-1",
    "movqi",
    "movqi+1",
    "movqi+2",
    "movhi-1",
    "movhi",
    "movhi+1",
    "movhi+2",
    "movsi-1",
    "movsi",
    "movsi+1",
    "movdi-1",
    "movdi",
    "movdi+1",
    "movdi+2",
    "movsf-1",
    "movsf",
    "movsf+1",
    "movsf+2",
    "movdf-2",
    "movdf-1",
    "movdf",
    "movdf+1",
    "movdf+2",
    "movdf+3",
    "movtf-2",
    "movtf-1",
    "movtf",
    "movtf+1",
    "movtf+2",
    "movtf+3",
    "movtf+4",
    "movtf+5",
    "movtf+6",
    "movtf+7",
    "movtf+8",
    "movtf+9",
    "movtf+10",
    "movtf+11",
    "movtf+12",
    "movtf+13",
    "movtf+14",
    "zero_extendhisi2-14",
    "zero_extendhisi2-13",
    "zero_extendhisi2-12",
    "zero_extendhisi2-11",
    "zero_extendhisi2-10",
    "zero_extendhisi2-9",
    "zero_extendhisi2-8",
    "zero_extendhisi2-7",
    "zero_extendhisi2-6",
    "zero_extendhisi2-5",
    "zero_extendhisi2-4",
    "zero_extendhisi2-3",
    "zero_extendhisi2-2",
    "zero_extendhisi2-1",
    "zero_extendhisi2",
    "zero_extendhisi2+1",
    "zero_extendqihi2",
    "zero_extendqihi2+1",
    "zero_extendqisi2",
    "zero_extendqisi2+1",
    "zero_extendqidi2",
    "zero_extendqidi2+1",
    "zero_extendhidi2",
    "zero_extendhidi2+1",
    "zero_extendsidi2",
    "zero_extendsidi2+1",
    "zero_extendsidi2+2",
    "zero_extendsidi2+3",
    "extendhisi2-2",
    "extendhisi2-1",
    "extendhisi2",
    "extendhisi2+1",
    "extendqihi2",
    "extendqihi2+1",
    "extendqisi2",
    "extendqisi2+1",
    "extendqidi2",
    "extendqidi2+1",
    "extendhidi2",
    "extendhidi2+1",
    "extendsidi2",
    "extendsidi2+1",
    "extendsidi2+2",
    "extendsfdf2-1",
    "extendsfdf2",
    "extendsftf2",
    "extenddftf2",
    "truncdfsf2",
    "trunctfsf2",
    "trunctfdf2",
    "floatsisf2",
    "floatsidf2",
    "floatsitf2",
    "floatdisf2",
    "floatdidf2",
    "floatditf2",
    "floatditf2+1",
    "floatditf2+2",
    "floatdisf2_v9-1",
    "floatdisf2_v9",
    "floatdidf2_v9",
    "floatditf2_v9",
    "fix_truncsfsi2",
    "fix_truncdfsi2",
    "fix_trunctfsi2",
    "fix_truncsfdi2",
    "fix_truncdfdi2",
    "fix_trunctfdi2",
    "fix_trunctfdi2+1",
    "fix_trunctfdi2+2",
    "fix_truncsfdi2_v9-1",
    "fix_truncsfdi2_v9",
    "fix_truncdfdi2_v9",
    "fix_trunctfdi2_v9",
    "adddi3",
    "adddi3+1",
    "addsi3-1",
    "addsi3",
    "addsi3+1",
    "addsi3+2",
    "subdi3-2",
    "subdi3-1",
    "subdi3",
    "subdi3+1",
    "subsi3-1",
    "subsi3",
    "subsi3+1",
    "subsi3+2",
    "mulsi3-2",
    "mulsi3-1",
    "mulsi3",
    "muldi3",
    "muldi3+1",
    "mulsidi3",
    "mulsidi3+1",
    "const_mulsidi3",
    "smulsi3_highpart",
    "smulsi3_highpart+1",
    "const_smulsi3_highpart",
    "umulsidi3",
    "umulsidi3+1",
    "const_umulsidi3",
    "umulsi3_highpart",
    "umulsi3_highpart+1",
    "const_umulsi3_highpart",
    "divsi3",
    "divdi3",
    "divdi3+1",
    "udivsi3",
    "udivdi3",
    "udivdi3+1",
    "anddi3",
    "anddi3+1",
    "andsi3-1",
    "andsi3",
    "andsi3+1",
    "andsi3+2",
    "iordi3-2",
    "iordi3-1",
    "iordi3",
    "iordi3+1",
    "iorsi3-1",
    "iorsi3",
    "iorsi3+1",
    "iorsi3+2",
    "xordi3-2",
    "xordi3-1",
    "xordi3",
    "xordi3+1",
    "xorsi3-1",
    "xorsi3",
    "xorsi3+1",
    "xorsi3+2",
    "xorsi3+3",
    "xorsi3+4",
    "xorsi3+5",
    "xorsi3+6",
    "xorsi3+7",
    "xorsi3+8",
    "xorsi3+9",
    "negdi2-8",
    "negdi2-7",
    "negdi2-6",
    "negdi2-5",
    "negdi2-4",
    "negdi2-3",
    "negdi2-2",
    "negdi2-1",
    "negdi2",
    "negdi2+1",
    "negsi2-1",
    "negsi2",
    "negsi2+1",
    "negsi2+2",
    "one_cmpldi2-2",
    "one_cmpldi2-1",
    "one_cmpldi2",
    "one_cmpldi2+1",
    "one_cmplsi2-1",
    "one_cmplsi2",
    "one_cmplsi2+1",
    "one_cmplsi2+2",
    "addtf3-2",
    "addtf3-1",
    "addtf3",
    "adddf3",
    "addsf3",
    "subtf3",
    "subdf3",
    "subsf3",
    "multf3",
    "muldf3",
    "mulsf3",
    "mulsf3+1",
    "divtf3-1",
    "divtf3",
    "divdf3",
    "divsf3",
    "negtf2",
    "negdf2",
    "negsf2",
    "abstf2",
    "absdf2",
    "abssf2",
    "sqrttf2",
    "sqrtdf2",
    "sqrtsf2",
    "ashlsi3",
    "ashldi3",
    "ashldi3+1",
    "ashrsi3-1",
    "ashrsi3",
    "ashrdi3",
    "lshrsi3",
    "lshrdi3",
    "jump",
    "tablejump",
    "pic_tablejump_32",
    "pic_tablejump_64",
    "pic_tablejump_64+1",
    "pic_tablejump_64+2",
    "call-2",
    "call-1",
    "call",
    "call+1",
    "call+2",
    "call+3",
    "call_value-3",
    "call_value-2",
    "call_value-1",
    "call_value",
    "call_value+1",
    "call_value+2",
    "untyped_call-2",
    "untyped_call-1",
    "untyped_call",
    "untyped_call+1",
    "untyped_call+2",
    "untyped_return-2",
    "untyped_return-1",
    "untyped_return",
    "update_return",
    "return",
    "nop",
    "indirect_jump",
    "indirect_jump+1",
    "nonlocal_goto-1",
    "nonlocal_goto",
    "flush_register_windows",
    "goto_handler_and_restore",
    "flush",
    "ffssi2",
    "ffsdi2",
    "ffsdi2+1",
    "ffsdi2+2",
    "ffsdi2+3",
    "ffsdi2+4",
    "ffsdi2+5",
    "ffsdi2+6",
    "ffsdi2+7",
    "ffsdi2+8",
    "ffsdi2+9",
    "ffsdi2+10",
    "ffsdi2+11",
    "ffsdi2+12",
    "ffsdi2+13",
    "ffsdi2+14",
    "ffsdi2+15",
    "ffsdi2+16",
    "ffsdi2+17",
    "ffsdi2+18",
    "ffsdi2+19",
    "ffsdi2+20",
    "ffsdi2+21",
    "ffsdi2+22",
    "ffsdi2+23",
    "ffsdi2+24",
    "ffsdi2+25",
    "ffsdi2+26",
    "ffsdi2+27",
    "ffsdi2+28",
    "ffsdi2+29",
    "ffsdi2+30",
    "ffsdi2+31",
    "ffsdi2+32",
    "ffsdi2+33",
    "ffsdi2+34",
    "ffsdi2+35",
    "ffsdi2+36",
    "ffsdi2+37",
    "ffsdi2+38",
    "ffsdi2+39",
    "ffsdi2+40",
    "ffsdi2+41",
    "ffsdi2+42",
    "ffsdi2+43",
    "ffsdi2+44",
    "ffsdi2+45",
  };
char **insn_name_ptr = insn_name;

const int insn_n_operands[] =
  {
    2,
    2,
    2,
    2,
    2,
    3,
    3,
    3,
    3,
    3,
    3,
    3,
    3,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    2,
    2,
    2,
    2,
    2,
    2,
    2,
    2,
    3,
    3,
    3,
    3,
    3,
    3,
    2,
    2,
    2,
    2,
    2,
    2,
    2,
    2,
    3,
    3,
    3,
    3,
    1,
    1,
    2,
    2,
    1,
    1,
    2,
    3,
    2,
    3,
    3,
    2,
    2,
    2,
    2,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    1,
    1,
    2,
    2,
    2,
    2,
    2,
    2,
    3,
    3,
    2,
    2,
    2,
    2,
    2,
    3,
    3,
    2,
    2,
    2,
    2,
    2,
    2,
    2,
    2,
    3,
    3,
    2,
    2,
    3,
    3,
    2,
    2,
    3,
    2,
    2,
    2,
    2,
    2,
    2,
    2,
    3,
    2,
    2,
    2,
    2,
    2,
    3,
    2,
    2,
    2,
    2,
    3,
    4,
    4,
    4,
    4,
    5,
    5,
    5,
    5,
    5,
    5,
    5,
    5,
    5,
    5,
    5,
    5,
    5,
    5,
    5,
    4,
    4,
    4,
    4,
    4,
    4,
    2,
    2,
    2,
    2,
    2,
    2,
    2,
    2,
    2,
    2,
    2,
    2,
    1,
    2,
    1,
    2,
    2,
    2,
    2,
    2,
    2,
    2,
    2,
    2,
    2,
    2,
    2,
    2,
    3,
    3,
    2,
    2,
    2,
    2,
    2,
    2,
    2,
    2,
    2,
    2,
    2,
    2,
    4,
    4,
    4,
    2,
    2,
    2,
    2,
    2,
    2,
    2,
    2,
    2,
    4,
    4,
    4,
    2,
    2,
    2,
    3,
    3,
    3,
    3,
    2,
    2,
    3,
    3,
    3,
    3,
    3,
    3,
    2,
    2,
    3,
    3,
    3,
    3,
    3,
    3,
    3,
    3,
    3,
    3,
    3,
    3,
    3,
    3,
    3,
    3,
    3,
    4,
    3,
    4,
    3,
    3,
    3,
    3,
    3,
    3,
    3,
    4,
    3,
    3,
    3,
    3,
    3,
    3,
    3,
    4,
    3,
    3,
    3,
    3,
    3,
    3,
    3,
    4,
    4,
    3,
    3,
    3,
    3,
    3,
    4,
    4,
    2,
    2,
    3,
    3,
    3,
    3,
    4,
    4,
    2,
    2,
    2,
    2,
    1,
    1,
    2,
    2,
    2,
    2,
    2,
    2,
    1,
    1,
    2,
    2,
    3,
    3,
    3,
    3,
    3,
    3,
    3,
    3,
    3,
    3,
    3,
    3,
    3,
    3,
    2,
    2,
    2,
    2,
    2,
    2,
    2,
    2,
    2,
    3,
    3,
    1,
    2,
    3,
    3,
    3,
    3,
    0,
    1,
    1,
    1,
    1,
    1,
    0,
    0,
    4,
    2,
    2,
    2,
    2,
    3,
    3,
    5,
    3,
    3,
    3,
    3,
    3,
    3,
    3,
    3,
    3,
    2,
    2,
    0,
    0,
    1,
    1,
    1,
    4,
    0,
    0,
    1,
    3,
    3,
    4,
    4,
    3,
    4,
    2,
    2,
    2,
    2,
    2,
    2,
    3,
    3,
    3,
    3,
    4,
    4,
    4,
    4,
    4,
    4,
    4,
    4,
    3,
    3,
    3,
    3,
    3,
    3,
    3,
    3,
    3,
    3,
    2,
    2,
    2,
    2,
    3,
    2,
    3,
    1,
    3,
    2,
    3,
    2,
    2,
  };

const int insn_n_dups[] =
  {
    0,
    0,
    0,
    0,
    0,
    2,
    2,
    2,
    2,
    2,
    2,
    2,
    2,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    1,
    0,
    1,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    2,
    2,
    2,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    2,
    2,
    2,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    2,
    2,
    0,
    0,
    0,
    0,
    0,
    0,
    2,
    2,
    0,
    0,
    2,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    2,
    0,
    0,
    2,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    1,
    1,
    0,
    0,
    2,
    2,
    0,
    0,
    1,
    1,
    0,
    0,
    0,
    0,
    0,
    0,
    1,
    1,
    0,
    0,
    0,
    0,
    0,
    0,
    1,
    1,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    1,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
  };

char *const insn_operand_constraint[][MAX_RECOG_OPERANDS] =
  {
    { "", "", },
    { "", "", },
    { "", "", },
    { "", "", },
    { "", "", },
    { "", "", "", },
    { "", "", "", },
    { "", "", "", },
    { "", "", "", },
    { "", "", "", },
    { "", "", "", },
    { "", "", "", },
    { "", "", "", },
    { "", },
    { "", },
    { "", },
    { "", },
    { "", },
    { "", },
    { "", },
    { "", },
    { "", },
    { "", },
    { "r", "rI", },
    { "f", "f", },
    { "f", "f", },
    { "f", "f", },
    { "f", "f", },
    { "f", "f", },
    { "f", "f", },
    { "r", "rHI", },
    { "=c", "f", "f", },
    { "=c", "f", "f", },
    { "=c", "f", "f", },
    { "=c", "f", "f", },
    { "=c", "f", "f", },
    { "=c", "f", "f", },
    { "=r", "r", },
    { "=r", "r", },
    { "=r", "r", },
    { "=r", "r", },
    { "=r", "r", },
    { "=r", "r", },
    { "=r", "r", },
    { "=r", "r", },
    { "=r", "r", "r", },
    { "=r", "r", "r", },
    { "=r", "r", "r", },
    { "=r", "r", "r", },
    { "=r", },
    { "=r", },
    { "=r", "rI", },
    { "=r", "rI", },
    { "=r", },
    { "=r", },
    { "=r", "rI", },
    { "=r", "%r", "rI", },
    { "=r", "r", },
    { "=r", "r", "rI", },
    { "=r", "r", "rI", },
    { "=r", "r", },
    { "=r", "r", },
    { "=r", "", },
    { "=r", "", },
    { 0 },
    { 0 },
    { 0 },
    { 0 },
    { 0 },
    { 0 },
    { 0 },
    { 0 },
    { 0 },
    { 0 },
    { "", },
    { "", },
    { "", "c", },
    { "", "c", },
    { "", "c", },
    { "", "c", },
    { "", "r", },
    { "", "r", },
    { "=r", "r", "in", },
    { "=r", "r", "in", },
    { "=r", "", },
    { "=r", "", },
    { "=r", "", },
    { "=r", "i", },
    { "=r", "i", },
    { "=r", "0", "in", },
    { "=r", "0", "in", },
    { "=r", "", },
    { "=r", "", },
    { "=r", "", },
    { "=r", "", },
    { "=r", "", },
    { "=r", "", },
    { "", "", },
    { "=r,r,r,Q", "rI,K,Q,rJ", },
    { "=r", "r", "in", },
    { "", "rJ", "=&r", },
    { "", "", },
    { "=r,r,r,Q", "rI,K,Q,rJ", },
    { "=r", "r", "in", },
    { "", "rJ", "=&r", },
    { "", "", },
    { "=r,f,r,r,f,Q,Q", "rI,!f,K,Q,!Q,rJ,!f", },
    { "", "rJ", "=&r", },
    { "", "", },
    { "=r,T,U,Q,r,r,?f,?f,?Q", "r,U,T,r,Q,i,f,Q,f", },
    { "=r,r,r,Q,?f,?f,?Q", "rI,K,Q,rJ,f,Q,f", },
    { "=?r,f,m", "?E,m,G", },
    { "", "", },
    { "=f,r,f,r,Q,Q", "f,r,Q,Q,f,r", },
    { "=r,r,Q", "r,Q,r", },
    { "i", "rfG", "=&r", },
    { "=?r,f,o", "?E,m,G", },
    { "", "", },
    { "=T,U,f,r,Q,Q,f,r", "U,T,f,r,f,r,Q,Q", },
    { "=T,U,r,Q,&r", "U,T,r,r,Q", },
    { "", "", },
    { "i,i", "rf,G", "=&r,&r", },
    { "=?r,f,o", "?E,m,G", },
    { "", "", },
    { "=f,r,Q,Q,f,&r", "f,r,f,r,Q,Q", },
    { "=r,Q,&r", "r,r,Q", },
    { "i,i", "rf,G", "=&r,&r", },
    { "=r", "", "ri", "0", },
    { "=r", "", "rHI", "0", },
    { "=r", "", "ri", "0", },
    { "=r", "", "rHI", "0", },
    { "=r", "", "c", "ri", "0", },
    { "=r", "", "c", "ri", "0", },
    { "=r", "", "c", "rHI", "0", },
    { "=r", "", "c", "rHI", "0", },
    { "=r", "", "r", "ri", "0", },
    { "=r", "", "r", "ri", "0", },
    { "=f", "", "r", "f", "0", },
    { "=f", "", "r", "f", "0", },
    { "=f", "", "r", "f", "0", },
    { "=f", "", "c", "f", "0", },
    { "=f", "", "c", "f", "0", },
    { "=f", "", "c", "f", "0", },
    { "=f", "", "c", "f", "0", },
    { "=f", "", "c", "f", "0", },
    { "=f", "", "c", "f", "0", },
    { "=f", "", "f", "0", },
    { "=f", "", "f", "0", },
    { "=f", "", "f", "0", },
    { "=f", "", "f", "0", },
    { "=f", "", "f", "0", },
    { "=f", "", "f", "0", },
    { "", "", },
    { "=r", "m", },
    { "", "", },
    { "=r,r", "r,Q", },
    { "", "", },
    { "=r,r", "r,Q", },
    { "", "", },
    { "=r,r", "r,Q", },
    { "", "", },
    { "=r", "m", },
    { "", "", },
    { "=r,r", "r,Q", },
    { "r", },
    { "=r", "r", },
    { "r", },
    { "=r", "r", },
    { "", "", },
    { "=r", "m", },
    { "", "", },
    { "=r", "m", },
    { "", "", },
    { "=r", "m", },
    { "", "", },
    { "=r", "m", },
    { "", "", },
    { "=r", "m", },
    { "", "", },
    { "=r,r", "r,Q", },
    { "r", "n", "n", },
    { "r", "n", "n", },
    { "=f", "f", },
    { "=f", "f", },
    { "=f", "f", },
    { "=f", "f", },
    { "=f", "f", },
    { "=f", "f", },
    { "=f", "f", },
    { "=f", "f", },
    { "=f", "f", },
    { "", "", },
    { "", "", },
    { "", "", },
    { "=f", "rm", "=&f", "m", },
    { "=f", "rm", "=&f", "m", },
    { "=f", "rm", "=&f", "m", },
    { "=f", "f", },
    { "=f", "f", },
    { "=f", "f", },
    { "=f", "f", },
    { "=f", "f", },
    { "=f", "f", },
    { "", "", },
    { "", "", },
    { "", "", },
    { "=rm", "f", "=&f", "m", },
    { "=rm", "f", "=&f", "m", },
    { "=rm", "f", "=&f", "m", },
    { "=f", "f", },
    { "=f", "f", },
    { "=f", "f", },
    { "=r", "%r", "rHI", },
    { "=r", "%r", "rHI", },
    { "=r", "%r", "rHI", },
    { "=r", "%r", "rI", },
    { "%r", "rI", },
    { "%r", "rHI", },
    { "=r", "%r", "rI", },
    { "=r", "%r", "rHI", },
    { "=r", "r", "rHI", },
    { "=r", "r", "rHI", },
    { "=r", "r", "rHI", },
    { "=r", "r", "rI", },
    { "r", "rI", },
    { "r", "rHI", },
    { "=r", "r", "rI", },
    { "=r", "r", "rHI", },
    { "=r", "%r", "rI", },
    { "=r", "%r", "rHI", },
    { "=r", "%r", "rI", },
    { "", "", "", },
    { "=r", "r", "r", },
    { "=r", "r", "I", },
    { "", "", "", },
    { "=r", "r", "r", },
    { "=r", "r", "r", },
    { "", "", "", },
    { "=r", "r", "r", },
    { "=r", "r", "", },
    { "", "", "", },
    { "=r", "r", "r", },
    { "=r", "r", "", },
    { "=r", "r", "rI", "=&r", },
    { "=r", "r", "rHI", },
    { "=r", "r", "rI", "=&r", },
    { "=r", "r", "rI", },
    { "=r", "r", "rHI", },
    { "=r", "r", "rI", },
    { "", "", "", },
    { "=r", "%r", "rHI", },
    { "=r", "%r", "rHI", },
    { "=r", "%r", "rI", },
    { "", "", "", "", },
    { "=r", "r", "r", },
    { "=r", "r", "r", },
    { "=r", "r", "r", },
    { "", "", "", },
    { "=r", "%r", "rHI", },
    { "=r", "%r", "rHI", },
    { "=r", "%r", "rI", },
    { "", "", "", "", },
    { "=r", "r", "r", },
    { "=r", "r", "r", },
    { "=r", "r", "r", },
    { "", "", "", },
    { "=r", "%r", "rHI", },
    { "=r", "%rJ", "rHI", },
    { "=r", "%rJ", "rI", },
    { "", "", "", "", },
    { "", "", "", "", },
    { "=r", "r", "r", },
    { "=r", "rJ", "rHI", },
    { "=r", "rJ", "rI", },
    { "%r", "rI", "", },
    { "%r", "rHI", "", },
    { "=r", "%r", "rI", "", },
    { "=r", "%r", "rHI", "", },
    { "%rJ", "rI", },
    { "%rJ", "rHI", },
    { "=r", "%rJ", "rI", },
    { "=r", "%rJ", "rHI", },
    { "rI", "rJ", "", },
    { "rHI", "rJ", "", },
    { "=r", "rI", "rJ", "", },
    { "=r", "rHI", "rJ", "", },
    { "=r", "r", },
    { "=r", "r", },
    { "=r", "r", },
    { "=r", "rI", },
    { "rI", },
    { "rHI", },
    { "=r", "rI", },
    { "=r", "rHI", },
    { "", "", },
    { "=r", "r", },
    { "=r", "rHI", },
    { "=r", "rI", },
    { "rI", },
    { "rHI", },
    { "=r", "rI", },
    { "=r", "rHI", },
    { "=f", "f", "f", },
    { "=f", "f", "f", },
    { "=f", "f", "f", },
    { "=f", "f", "f", },
    { "=f", "f", "f", },
    { "=f", "f", "f", },
    { "=f", "f", "f", },
    { "=f", "f", "f", },
    { "=f", "f", "f", },
    { "=f", "f", "f", },
    { "=f", "f", "f", },
    { "=f", "f", "f", },
    { "=f", "f", "f", },
    { "=f", "f", "f", },
    { "=f,f", "0,f", },
    { "=f,f", "0,f", },
    { "=f", "f", },
    { "=f,f", "0,f", },
    { "=f,f", "0,f", },
    { "=f", "f", },
    { "=f", "f", },
    { "=f", "f", },
    { "=f", "f", },
    { "=r", "r", "rI", },
    { "=r", "r", "rI", },
    { "r", },
    { "=r", "r", },
    { "=r", "r", "rI", },
    { "=r", "r", "rI", },
    { "=r", "r", "rI", },
    { "=r", "r", "rI", },
    { 0 },
    { "r", },
    { "r", },
    { "r", },
    { "p", },
    { "p", },
    { 0 },
    { 0 },
    { "", "", "", "i", },
    { "p", "", },
    { "i", "", },
    { "p", "", },
    { "i", "", },
    { "p", "", "", },
    { "i", "", "", },
    { "=rf", "", "", "", "", },
    { "=rf", "p", "", },
    { "=rf", "i", "", },
    { "=rf", "p", "", },
    { "=rf", "i", "", },
    { "", "", "", },
    { "p", "o", "", },
    { "i", "o", "", },
    { "p", "o", "", },
    { "i", "o", "", },
    { "", "", },
    { "r", "r", },
    { 0 },
    { 0 },
    { "p", },
    { "p", },
    { "p", },
    { "", "", "", "", },
    { 0 },
    { 0 },
    { "", },
    { "=&r", "r", "=&r", },
    { "=&r", "r", "=&r", },
    { "", "", "", "", },
    { "", "", "", "", },
    { "", "", "", },
    { "", "", "", "", },
    { "", "", },
    { "", "", },
    { "", "", },
    { "", "", },
    { "", "", },
    { "", "", },
    { "", "", "", },
    { "", "", "", },
    { "", "", "", },
    { "", "", "", },
    { "=rf", "", "=rf", "", },
    { "", "rf", "", "rf", },
    { "=fr", "", "=fr", "", },
    { "", "fr", "", "fr", },
    { "=rf", "", "=rf", "", },
    { "", "rf", "", "rf", },
    { "=fr", "", "=fr", "", },
    { "", "fr", "", "fr", },
    { "=r", "r", "r", },
    { "=r", "r", "r", },
    { "", "", "", },
    { "", "", "", },
    { "", "", "", },
    { "", "", "", },
    { "", "", "", },
    { "", "", "", },
    { "=r", "i", "=fr", },
    { "=r", "i", "=fr", },
    { "", "rI", },
    { "", "rI", },
    { "", "rI", },
    { "r", "r", },
    { "", "%r", "rI", },
    { "", "rHI", },
    { "", "%r", "rHI", },
    { "f", },
    { "", "pi", "", },
    { "pi", "", },
    { "", "pi", "", },
    { "pi", "", },
    { "=r", "rJ", },
  };

const enum machine_mode insn_operand_mode[][MAX_RECOG_OPERANDS] =
  {
    { SImode, SImode, },
    { DImode, DImode, },
    { SFmode, SFmode, },
    { DFmode, DFmode, },
    { TFmode, TFmode, },
    { SImode, SImode, SImode, },
    { DImode, DImode, DImode, },
    { SImode, SImode, SImode, },
    { DImode, DImode, DImode, },
    { SImode, DImode, DImode, },
    { SImode, DImode, DImode, },
    { DImode, SImode, SImode, },
    { DImode, SImode, SImode, },
    { SImode, },
    { SImode, },
    { SImode, },
    { SImode, },
    { SImode, },
    { SImode, },
    { SImode, },
    { SImode, },
    { SImode, },
    { SImode, },
    { SImode, SImode, },
    { SFmode, SFmode, },
    { DFmode, DFmode, },
    { TFmode, TFmode, },
    { SFmode, SFmode, },
    { DFmode, DFmode, },
    { TFmode, TFmode, },
    { DImode, DImode, },
    { CCFPEmode, SFmode, SFmode, },
    { CCFPEmode, DFmode, DFmode, },
    { CCFPEmode, TFmode, TFmode, },
    { CCFPmode, SFmode, SFmode, },
    { CCFPmode, DFmode, DFmode, },
    { CCFPmode, TFmode, TFmode, },
    { SImode, SImode, },
    { SImode, SImode, },
    { DImode, DImode, },
    { DImode, DImode, },
    { SImode, SImode, },
    { SImode, SImode, },
    { DImode, DImode, },
    { DImode, DImode, },
    { SImode, SImode, SImode, },
    { SImode, SImode, SImode, },
    { SImode, SImode, SImode, },
    { SImode, SImode, SImode, },
    { SImode, },
    { SImode, },
    { SImode, SImode, },
    { SImode, SImode, },
    { SImode, },
    { SImode, },
    { SImode, SImode, },
    { SImode, SImode, SImode, },
    { SImode, SImode, },
    { SImode, SImode, SImode, },
    { SImode, SImode, SImode, },
    { SImode, SImode, },
    { SImode, SImode, },
    { SImode, SImode, },
    { DImode, DImode, },
    { VOIDmode },
    { VOIDmode },
    { VOIDmode },
    { VOIDmode },
    { VOIDmode },
    { VOIDmode },
    { VOIDmode },
    { VOIDmode },
    { VOIDmode },
    { VOIDmode },
    { VOIDmode, },
    { VOIDmode, },
    { VOIDmode, CCFPmode, },
    { VOIDmode, CCFPmode, },
    { VOIDmode, CCFPEmode, },
    { VOIDmode, CCFPEmode, },
    { VOIDmode, DImode, },
    { VOIDmode, DImode, },
    { SImode, SImode, SImode, },
    { SImode, SImode, SImode, },
    { SImode, VOIDmode, },
    { SImode, VOIDmode, },
    { HImode, VOIDmode, },
    { SImode, SImode, },
    { DImode, DImode, },
    { DImode, DImode, DImode, },
    { DImode, DImode, DImode, },
    { DImode, VOIDmode, },
    { DImode, VOIDmode, },
    { DImode, VOIDmode, },
    { DImode, VOIDmode, },
    { DImode, VOIDmode, },
    { DImode, VOIDmode, },
    { QImode, QImode, },
    { QImode, QImode, },
    { QImode, QImode, VOIDmode, },
    { SImode, QImode, SImode, },
    { HImode, HImode, },
    { HImode, HImode, },
    { HImode, HImode, VOIDmode, },
    { SImode, HImode, SImode, },
    { SImode, SImode, },
    { SImode, SImode, },
    { SImode, SImode, SImode, },
    { DImode, DImode, },
    { DImode, DImode, },
    { DImode, DImode, },
    { SFmode, SFmode, },
    { SFmode, SFmode, },
    { SFmode, SFmode, },
    { SFmode, SFmode, },
    { SImode, SFmode, SImode, },
    { DFmode, DFmode, },
    { DFmode, DFmode, },
    { DFmode, DFmode, },
    { DFmode, DFmode, },
    { VOIDmode, VOIDmode, },
    { SImode, DFmode, SImode, },
    { TFmode, TFmode, },
    { TFmode, TFmode, },
    { TFmode, TFmode, },
    { TFmode, TFmode, },
    { SImode, TFmode, SImode, },
    { SImode, VOIDmode, SImode, SImode, },
    { DImode, VOIDmode, DImode, DImode, },
    { SImode, VOIDmode, SImode, SImode, },
    { DImode, VOIDmode, DImode, DImode, },
    { SImode, VOIDmode, CCFPmode, SImode, SImode, },
    { SImode, VOIDmode, CCFPEmode, SImode, SImode, },
    { DImode, VOIDmode, CCFPmode, DImode, DImode, },
    { DImode, VOIDmode, CCFPEmode, DImode, DImode, },
    { SImode, VOIDmode, DImode, SImode, SImode, },
    { DImode, VOIDmode, DImode, DImode, DImode, },
    { SFmode, VOIDmode, DImode, SFmode, SFmode, },
    { DFmode, VOIDmode, DImode, DFmode, DFmode, },
    { TFmode, VOIDmode, DImode, TFmode, TFmode, },
    { SFmode, VOIDmode, CCFPmode, SFmode, SFmode, },
    { SFmode, VOIDmode, CCFPEmode, SFmode, SFmode, },
    { DFmode, VOIDmode, CCFPmode, DFmode, DFmode, },
    { DFmode, VOIDmode, CCFPEmode, DFmode, DFmode, },
    { TFmode, VOIDmode, CCFPmode, TFmode, TFmode, },
    { TFmode, VOIDmode, CCFPEmode, TFmode, TFmode, },
    { SFmode, VOIDmode, SFmode, SFmode, },
    { DFmode, VOIDmode, DFmode, DFmode, },
    { TFmode, VOIDmode, TFmode, TFmode, },
    { SFmode, VOIDmode, SFmode, SFmode, },
    { DFmode, VOIDmode, DFmode, DFmode, },
    { TFmode, VOIDmode, TFmode, TFmode, },
    { SImode, HImode, },
    { SImode, HImode, },
    { HImode, QImode, },
    { HImode, QImode, },
    { SImode, QImode, },
    { SImode, QImode, },
    { DImode, QImode, },
    { DImode, QImode, },
    { DImode, HImode, },
    { DImode, HImode, },
    { DImode, SImode, },
    { DImode, SImode, },
    { QImode, },
    { SImode, QImode, },
    { SImode, },
    { QImode, SImode, },
    { SImode, HImode, },
    { SImode, HImode, },
    { HImode, QImode, },
    { HImode, QImode, },
    { SImode, QImode, },
    { SImode, QImode, },
    { DImode, QImode, },
    { DImode, QImode, },
    { DImode, HImode, },
    { DImode, HImode, },
    { DImode, SImode, },
    { DImode, SImode, },
    { SImode, SImode, SImode, },
    { DImode, SImode, SImode, },
    { DFmode, SFmode, },
    { TFmode, SFmode, },
    { TFmode, DFmode, },
    { SFmode, DFmode, },
    { SFmode, TFmode, },
    { DFmode, TFmode, },
    { SFmode, SImode, },
    { DFmode, SImode, },
    { TFmode, SImode, },
    { SFmode, DImode, },
    { DFmode, DImode, },
    { TFmode, DImode, },
    { SFmode, DImode, DFmode, DImode, },
    { DFmode, DImode, DFmode, DImode, },
    { TFmode, DImode, DFmode, DImode, },
    { SFmode, DImode, },
    { DFmode, DImode, },
    { TFmode, DImode, },
    { SImode, SFmode, },
    { SImode, DFmode, },
    { SImode, TFmode, },
    { DImode, SFmode, },
    { DImode, DFmode, },
    { DImode, TFmode, },
    { DImode, SFmode, DFmode, DImode, },
    { DImode, DFmode, DFmode, DImode, },
    { DImode, TFmode, DFmode, DImode, },
    { DImode, SFmode, },
    { DImode, DFmode, },
    { DImode, TFmode, },
    { DImode, DImode, DImode, },
    { DImode, DImode, DImode, },
    { DImode, DImode, DImode, },
    { SImode, SImode, SImode, },
    { SImode, SImode, },
    { DImode, DImode, },
    { SImode, SImode, SImode, },
    { DImode, DImode, DImode, },
    { DImode, DImode, DImode, },
    { DImode, DImode, DImode, },
    { DImode, DImode, DImode, },
    { SImode, SImode, SImode, },
    { SImode, SImode, },
    { DImode, DImode, },
    { SImode, SImode, SImode, },
    { DImode, DImode, DImode, },
    { SImode, SImode, SImode, },
    { DImode, DImode, DImode, },
    { SImode, SImode, SImode, },
    { DImode, SImode, SImode, },
    { DImode, SImode, SImode, },
    { DImode, SImode, SImode, },
    { SImode, SImode, SImode, },
    { SImode, SImode, SImode, },
    { SImode, SImode, SImode, },
    { DImode, SImode, SImode, },
    { DImode, SImode, SImode, },
    { DImode, SImode, SImode, },
    { SImode, SImode, SImode, },
    { SImode, SImode, SImode, },
    { SImode, SImode, SImode, },
    { SImode, SImode, SImode, SImode, },
    { DImode, DImode, DImode, },
    { SImode, SImode, SImode, SImode, },
    { SImode, SImode, SImode, },
    { DImode, DImode, DImode, },
    { SImode, SImode, SImode, },
    { DImode, DImode, DImode, },
    { DImode, DImode, DImode, },
    { DImode, DImode, DImode, },
    { SImode, SImode, SImode, },
    { VOIDmode, VOIDmode, VOIDmode, VOIDmode, },
    { DImode, DImode, DImode, },
    { DImode, DImode, DImode, },
    { SImode, SImode, SImode, },
    { DImode, DImode, DImode, },
    { DImode, DImode, DImode, },
    { DImode, DImode, DImode, },
    { SImode, SImode, SImode, },
    { VOIDmode, VOIDmode, VOIDmode, VOIDmode, },
    { DImode, DImode, DImode, },
    { DImode, DImode, DImode, },
    { SImode, SImode, SImode, },
    { DImode, DImode, DImode, },
    { DImode, DImode, DImode, },
    { DImode, DImode, DImode, },
    { SImode, SImode, SImode, },
    { VOIDmode, VOIDmode, VOIDmode, VOIDmode, },
    { VOIDmode, VOIDmode, VOIDmode, VOIDmode, },
    { DImode, DImode, DImode, },
    { DImode, DImode, DImode, },
    { SImode, SImode, SImode, },
    { SImode, SImode, SImode, },
    { DImode, DImode, DImode, },
    { SImode, SImode, SImode, SImode, },
    { DImode, DImode, DImode, DImode, },
    { SImode, SImode, },
    { DImode, DImode, },
    { SImode, SImode, SImode, },
    { DImode, DImode, DImode, },
    { SImode, SImode, SImode, },
    { DImode, DImode, DImode, },
    { SImode, SImode, SImode, SImode, },
    { DImode, DImode, DImode, DImode, },
    { DImode, DImode, },
    { DImode, DImode, },
    { DImode, DImode, },
    { SImode, SImode, },
    { SImode, },
    { DImode, },
    { SImode, SImode, },
    { DImode, DImode, },
    { DImode, DImode, },
    { DImode, DImode, },
    { DImode, DImode, },
    { SImode, SImode, },
    { SImode, },
    { DImode, },
    { SImode, SImode, },
    { DImode, DImode, },
    { TFmode, TFmode, TFmode, },
    { DFmode, DFmode, DFmode, },
    { SFmode, SFmode, SFmode, },
    { TFmode, TFmode, TFmode, },
    { DFmode, DFmode, DFmode, },
    { SFmode, SFmode, SFmode, },
    { TFmode, TFmode, TFmode, },
    { DFmode, DFmode, DFmode, },
    { SFmode, SFmode, SFmode, },
    { DFmode, SFmode, SFmode, },
    { TFmode, DFmode, DFmode, },
    { TFmode, TFmode, TFmode, },
    { DFmode, DFmode, DFmode, },
    { SFmode, SFmode, SFmode, },
    { TFmode, TFmode, },
    { DFmode, DFmode, },
    { SFmode, SFmode, },
    { TFmode, TFmode, },
    { DFmode, DFmode, },
    { SFmode, SFmode, },
    { TFmode, TFmode, },
    { DFmode, DFmode, },
    { SFmode, SFmode, },
    { SImode, SImode, SImode, },
    { DImode, DImode, SImode, },
    { SImode, },
    { SImode, SImode, },
    { SImode, SImode, SImode, },
    { DImode, DImode, SImode, },
    { SImode, SImode, SImode, },
    { DImode, DImode, SImode, },
    { VOIDmode },
    { VOIDmode, },
    { SImode, },
    { DImode, },
    { SImode, },
    { DImode, },
    { VOIDmode },
    { VOIDmode },
    { VOIDmode, VOIDmode, VOIDmode, VOIDmode, },
    { SImode, VOIDmode, },
    { SImode, VOIDmode, },
    { DImode, VOIDmode, },
    { DImode, VOIDmode, },
    { SImode, VOIDmode, VOIDmode, },
    { SImode, VOIDmode, VOIDmode, },
    { VOIDmode, SImode, VOIDmode, VOIDmode, VOIDmode, },
    { VOIDmode, SImode, VOIDmode, },
    { VOIDmode, SImode, VOIDmode, },
    { VOIDmode, DImode, VOIDmode, },
    { VOIDmode, DImode, VOIDmode, },
    { SImode, BLKmode, VOIDmode, },
    { SImode, DImode, VOIDmode, },
    { SImode, DImode, VOIDmode, },
    { DImode, DImode, VOIDmode, },
    { DImode, DImode, VOIDmode, },
    { BLKmode, VOIDmode, },
    { SImode, SImode, },
    { VOIDmode },
    { VOIDmode },
    { VOIDmode, },
    { SImode, },
    { DImode, },
    { SImode, SImode, SImode, SImode, },
    { VOIDmode },
    { VOIDmode },
    { VOIDmode, },
    { SImode, SImode, SImode, },
    { DImode, DImode, DImode, },
    { VOIDmode, VOIDmode, VOIDmode, VOIDmode, },
    { VOIDmode, VOIDmode, VOIDmode, VOIDmode, },
    { VOIDmode, VOIDmode, VOIDmode, },
    { VOIDmode, VOIDmode, VOIDmode, VOIDmode, },
    { VOIDmode, VOIDmode, },
    { VOIDmode, VOIDmode, },
    { VOIDmode, VOIDmode, },
    { VOIDmode, VOIDmode, },
    { VOIDmode, VOIDmode, },
    { VOIDmode, VOIDmode, },
    { VOIDmode, VOIDmode, VOIDmode, },
    { VOIDmode, VOIDmode, VOIDmode, },
    { VOIDmode, VOIDmode, VOIDmode, },
    { VOIDmode, VOIDmode, VOIDmode, },
    { VOIDmode, VOIDmode, VOIDmode, VOIDmode, },
    { VOIDmode, VOIDmode, VOIDmode, VOIDmode, },
    { VOIDmode, VOIDmode, VOIDmode, VOIDmode, },
    { VOIDmode, VOIDmode, VOIDmode, VOIDmode, },
    { VOIDmode, VOIDmode, VOIDmode, VOIDmode, },
    { VOIDmode, VOIDmode, VOIDmode, VOIDmode, },
    { VOIDmode, VOIDmode, VOIDmode, VOIDmode, },
    { VOIDmode, VOIDmode, VOIDmode, VOIDmode, },
    { VOIDmode, VOIDmode, VOIDmode, },
    { VOIDmode, VOIDmode, VOIDmode, },
    { VOIDmode, VOIDmode, VOIDmode, },
    { VOIDmode, VOIDmode, VOIDmode, },
    { VOIDmode, VOIDmode, VOIDmode, },
    { VOIDmode, VOIDmode, VOIDmode, },
    { VOIDmode, VOIDmode, VOIDmode, },
    { VOIDmode, VOIDmode, VOIDmode, },
    { VOIDmode, VOIDmode, VOIDmode, },
    { VOIDmode, VOIDmode, VOIDmode, },
    { QImode, QImode, },
    { HImode, HImode, },
    { SImode, SImode, },
    { SFmode, SFmode, },
    { SImode, SImode, SImode, },
    { DImode, DImode, },
    { DImode, DImode, DImode, },
    { SFmode, },
    { VOIDmode, VOIDmode, VOIDmode, },
    { VOIDmode, VOIDmode, },
    { VOIDmode, VOIDmode, VOIDmode, },
    { VOIDmode, VOIDmode, },
    { VOIDmode, VOIDmode, },
  };

const char insn_operand_strict_low[][MAX_RECOG_OPERANDS] =
  {
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, },
    { 0, },
    { 0, },
    { 0, },
    { 0, },
    { 0, },
    { 0, },
    { 0, },
    { 0, },
    { 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, },
    { 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, },
    { 0, },
    { 0, 0, },
    { 0, 0, 0, },
    { 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0 },
    { 0 },
    { 0 },
    { 0 },
    { 0 },
    { 0 },
    { 0 },
    { 0 },
    { 0 },
    { 0 },
    { 0, },
    { 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, 0, },
    { 0, 0, 0, 0, },
    { 0, 0, 0, 0, },
    { 0, 0, 0, 0, },
    { 0, 0, 0, 0, 0, },
    { 0, 0, 0, 0, 0, },
    { 0, 0, 0, 0, 0, },
    { 0, 0, 0, 0, 0, },
    { 0, 0, 0, 0, 0, },
    { 0, 0, 0, 0, 0, },
    { 0, 0, 0, 0, 0, },
    { 0, 0, 0, 0, 0, },
    { 0, 0, 0, 0, 0, },
    { 0, 0, 0, 0, 0, },
    { 0, 0, 0, 0, 0, },
    { 0, 0, 0, 0, 0, },
    { 0, 0, 0, 0, 0, },
    { 0, 0, 0, 0, 0, },
    { 0, 0, 0, 0, 0, },
    { 0, 0, 0, 0, },
    { 0, 0, 0, 0, },
    { 0, 0, 0, 0, },
    { 0, 0, 0, 0, },
    { 0, 0, 0, 0, },
    { 0, 0, 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, },
    { 0, 0, },
    { 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, 0, 0, },
    { 0, 0, 0, 0, },
    { 0, 0, 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, 0, 0, },
    { 0, 0, 0, 0, },
    { 0, 0, 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, 0, },
    { 0, 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, 0, },
    { 0, 0, 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, 0, },
    { 0, 0, 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, },
    { 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, },
    { 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, },
    { 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0 },
    { 0, },
    { 0, },
    { 0, },
    { 0, },
    { 0, },
    { 0 },
    { 0 },
    { 0, 0, 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0 },
    { 0 },
    { 0, },
    { 0, },
    { 0, },
    { 0, 0, 0, 0, },
    { 0 },
    { 0 },
    { 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, 0, },
    { 0, 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, 0, },
    { 0, 0, 0, 0, },
    { 0, 0, 0, 0, },
    { 0, 0, 0, 0, },
    { 0, 0, 0, 0, },
    { 0, 0, 0, 0, },
    { 0, 0, 0, 0, },
    { 0, 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, 0, },
    { 0, 0, },
    { 0, 0, 0, },
    { 0, },
    { 0, 0, 0, },
    { 0, 0, },
    { 0, 0, 0, },
    { 0, 0, },
    { 0, 0, },
  };

extern int register_operand ();
extern int arith_operand ();
extern int arith_double_operand ();
extern int intreg_operand ();
extern int ccfp_reg_operand ();
extern int noov_compare_op ();
extern int comparison_operator ();
extern int v9_regcmp_op ();
extern int immediate_operand ();
extern int move_pic_label ();
extern int const_double_operand ();
extern int data_segment_operand ();
extern int text_segment_operand ();
extern int general_operand ();
extern int reg_or_nonsymb_mem_operand ();
extern int move_operand ();
extern int symbolic_operand ();
extern int reg_or_0_operand ();
extern int scratch_operand ();
extern int arith11_operand ();
extern int arith11_double_operand ();
extern int arith10_operand ();
extern int arith10_double_operand ();
extern int memory_operand ();
extern int sparc_operand ();
extern int small_int ();
extern int uns_arith_operand ();
extern int uns_small_int ();
extern int cc_arithop ();
extern int cc_arithopn ();
extern int address_operand ();
extern int call_operand ();
extern int restore_operand ();

int (*const insn_operand_predicate[][MAX_RECOG_OPERANDS])() =
  {
    { register_operand, arith_operand, },
    { register_operand, arith_double_operand, },
    { register_operand, register_operand, },
    { register_operand, register_operand, },
    { register_operand, register_operand, },
    { register_operand, register_operand, register_operand, },
    { register_operand, register_operand, register_operand, },
    { register_operand, register_operand, register_operand, },
    { register_operand, register_operand, register_operand, },
    { register_operand, register_operand, register_operand, },
    { register_operand, register_operand, register_operand, },
    { register_operand, register_operand, register_operand, },
    { register_operand, register_operand, register_operand, },
    { intreg_operand, },
    { intreg_operand, },
    { intreg_operand, },
    { intreg_operand, },
    { intreg_operand, },
    { intreg_operand, },
    { intreg_operand, },
    { intreg_operand, },
    { intreg_operand, },
    { intreg_operand, },
    { register_operand, arith_operand, },
    { register_operand, register_operand, },
    { register_operand, register_operand, },
    { register_operand, register_operand, },
    { register_operand, register_operand, },
    { register_operand, register_operand, },
    { register_operand, register_operand, },
    { register_operand, arith_double_operand, },
    { ccfp_reg_operand, register_operand, register_operand, },
    { ccfp_reg_operand, register_operand, register_operand, },
    { ccfp_reg_operand, register_operand, register_operand, },
    { ccfp_reg_operand, register_operand, register_operand, },
    { ccfp_reg_operand, register_operand, register_operand, },
    { ccfp_reg_operand, register_operand, register_operand, },
    { register_operand, register_operand, },
    { register_operand, register_operand, },
    { register_operand, register_operand, },
    { register_operand, register_operand, },
    { register_operand, register_operand, },
    { register_operand, register_operand, },
    { register_operand, register_operand, },
    { register_operand, register_operand, },
    { register_operand, register_operand, register_operand, },
    { register_operand, register_operand, register_operand, },
    { register_operand, register_operand, register_operand, },
    { register_operand, register_operand, register_operand, },
    { register_operand, },
    { register_operand, },
    { register_operand, arith_operand, },
    { register_operand, arith_operand, },
    { register_operand, },
    { register_operand, },
    { register_operand, arith_operand, },
    { register_operand, arith_operand, arith_operand, },
    { register_operand, register_operand, },
    { register_operand, register_operand, arith_operand, },
    { register_operand, register_operand, arith_operand, },
    { register_operand, register_operand, },
    { register_operand, register_operand, },
    { register_operand, noov_compare_op, },
    { register_operand, noov_compare_op, },
    { 0 },
    { 0 },
    { 0 },
    { 0 },
    { 0 },
    { 0 },
    { 0 },
    { 0 },
    { 0 },
    { 0 },
    { noov_compare_op, },
    { noov_compare_op, },
    { comparison_operator, ccfp_reg_operand, },
    { comparison_operator, ccfp_reg_operand, },
    { comparison_operator, ccfp_reg_operand, },
    { comparison_operator, ccfp_reg_operand, },
    { v9_regcmp_op, register_operand, },
    { v9_regcmp_op, register_operand, },
    { register_operand, register_operand, immediate_operand, },
    { register_operand, register_operand, immediate_operand, },
    { register_operand, 0, },
    { register_operand, 0, },
    { register_operand, 0, },
    { register_operand, move_pic_label, },
    { register_operand, move_pic_label, },
    { register_operand, register_operand, immediate_operand, },
    { register_operand, register_operand, immediate_operand, },
    { register_operand, 0, },
    { register_operand, const_double_operand, },
    { register_operand, 0, },
    { register_operand, data_segment_operand, },
    { register_operand, text_segment_operand, },
    { register_operand, 0, },
    { general_operand, general_operand, },
    { reg_or_nonsymb_mem_operand, move_operand, },
    { register_operand, register_operand, immediate_operand, },
    { symbolic_operand, reg_or_0_operand, scratch_operand, },
    { general_operand, general_operand, },
    { reg_or_nonsymb_mem_operand, move_operand, },
    { register_operand, register_operand, immediate_operand, },
    { symbolic_operand, reg_or_0_operand, scratch_operand, },
    { general_operand, general_operand, },
    { reg_or_nonsymb_mem_operand, move_operand, },
    { symbolic_operand, reg_or_0_operand, scratch_operand, },
    { reg_or_nonsymb_mem_operand, general_operand, },
    { reg_or_nonsymb_mem_operand, general_operand, },
    { reg_or_nonsymb_mem_operand, move_operand, },
    { general_operand, 0, },
    { general_operand, general_operand, },
    { reg_or_nonsymb_mem_operand, reg_or_nonsymb_mem_operand, },
    { reg_or_nonsymb_mem_operand, reg_or_nonsymb_mem_operand, },
    { symbolic_operand, reg_or_0_operand, scratch_operand, },
    { general_operand, 0, },
    { general_operand, general_operand, },
    { reg_or_nonsymb_mem_operand, reg_or_nonsymb_mem_operand, },
    { reg_or_nonsymb_mem_operand, reg_or_nonsymb_mem_operand, },
    { 0, 0, },
    { symbolic_operand, reg_or_0_operand, scratch_operand, },
    { general_operand, 0, },
    { general_operand, general_operand, },
    { reg_or_nonsymb_mem_operand, reg_or_nonsymb_mem_operand, },
    { reg_or_nonsymb_mem_operand, reg_or_nonsymb_mem_operand, },
    { symbolic_operand, reg_or_0_operand, scratch_operand, },
    { register_operand, comparison_operator, arith11_operand, register_operand, },
    { register_operand, comparison_operator, arith11_double_operand, register_operand, },
    { register_operand, comparison_operator, arith11_operand, register_operand, },
    { register_operand, comparison_operator, arith11_double_operand, register_operand, },
    { register_operand, comparison_operator, ccfp_reg_operand, arith11_operand, register_operand, },
    { register_operand, comparison_operator, ccfp_reg_operand, arith11_operand, register_operand, },
    { register_operand, comparison_operator, ccfp_reg_operand, arith11_double_operand, register_operand, },
    { register_operand, comparison_operator, ccfp_reg_operand, arith11_double_operand, register_operand, },
    { register_operand, v9_regcmp_op, register_operand, arith10_operand, register_operand, },
    { register_operand, v9_regcmp_op, register_operand, arith10_double_operand, register_operand, },
    { register_operand, v9_regcmp_op, register_operand, register_operand, register_operand, },
    { register_operand, v9_regcmp_op, register_operand, register_operand, register_operand, },
    { register_operand, v9_regcmp_op, register_operand, register_operand, register_operand, },
    { register_operand, comparison_operator, ccfp_reg_operand, register_operand, register_operand, },
    { register_operand, comparison_operator, ccfp_reg_operand, register_operand, register_operand, },
    { register_operand, comparison_operator, ccfp_reg_operand, register_operand, register_operand, },
    { register_operand, comparison_operator, ccfp_reg_operand, register_operand, register_operand, },
    { register_operand, comparison_operator, ccfp_reg_operand, register_operand, register_operand, },
    { register_operand, comparison_operator, ccfp_reg_operand, register_operand, register_operand, },
    { register_operand, comparison_operator, register_operand, register_operand, },
    { register_operand, comparison_operator, register_operand, register_operand, },
    { register_operand, comparison_operator, register_operand, register_operand, },
    { register_operand, comparison_operator, register_operand, register_operand, },
    { register_operand, comparison_operator, register_operand, register_operand, },
    { register_operand, comparison_operator, register_operand, register_operand, },
    { register_operand, register_operand, },
    { register_operand, memory_operand, },
    { register_operand, register_operand, },
    { register_operand, sparc_operand, },
    { register_operand, register_operand, },
    { register_operand, sparc_operand, },
    { register_operand, register_operand, },
    { register_operand, sparc_operand, },
    { register_operand, register_operand, },
    { register_operand, memory_operand, },
    { register_operand, register_operand, },
    { register_operand, sparc_operand, },
    { register_operand, },
    { register_operand, register_operand, },
    { register_operand, },
    { register_operand, register_operand, },
    { register_operand, register_operand, },
    { register_operand, memory_operand, },
    { register_operand, register_operand, },
    { register_operand, memory_operand, },
    { register_operand, register_operand, },
    { register_operand, memory_operand, },
    { register_operand, register_operand, },
    { register_operand, memory_operand, },
    { register_operand, register_operand, },
    { register_operand, memory_operand, },
    { register_operand, register_operand, },
    { register_operand, sparc_operand, },
    { register_operand, small_int, small_int, },
    { register_operand, small_int, small_int, },
    { register_operand, register_operand, },
    { register_operand, register_operand, },
    { register_operand, register_operand, },
    { register_operand, register_operand, },
    { register_operand, register_operand, },
    { register_operand, register_operand, },
    { register_operand, register_operand, },
    { register_operand, register_operand, },
    { register_operand, register_operand, },
    { register_operand, general_operand, },
    { register_operand, general_operand, },
    { register_operand, general_operand, },
    { register_operand, general_operand, register_operand, memory_operand, },
    { register_operand, general_operand, register_operand, memory_operand, },
    { register_operand, general_operand, register_operand, memory_operand, },
    { register_operand, register_operand, },
    { register_operand, register_operand, },
    { register_operand, register_operand, },
    { register_operand, register_operand, },
    { register_operand, register_operand, },
    { register_operand, register_operand, },
    { general_operand, register_operand, },
    { general_operand, register_operand, },
    { general_operand, register_operand, },
    { general_operand, register_operand, register_operand, memory_operand, },
    { general_operand, register_operand, register_operand, memory_operand, },
    { general_operand, register_operand, register_operand, memory_operand, },
    { register_operand, register_operand, },
    { register_operand, register_operand, },
    { register_operand, register_operand, },
    { register_operand, arith_double_operand, arith_double_operand, },
    { register_operand, arith_double_operand, arith_double_operand, },
    { register_operand, arith_double_operand, arith_double_operand, },
    { register_operand, arith_operand, arith_operand, },
    { arith_operand, arith_operand, },
    { arith_double_operand, arith_double_operand, },
    { register_operand, arith_operand, arith_operand, },
    { register_operand, arith_double_operand, arith_double_operand, },
    { register_operand, register_operand, arith_double_operand, },
    { register_operand, register_operand, arith_double_operand, },
    { register_operand, register_operand, arith_double_operand, },
    { register_operand, register_operand, arith_operand, },
    { register_operand, arith_operand, },
    { register_operand, arith_double_operand, },
    { register_operand, register_operand, arith_operand, },
    { register_operand, register_operand, arith_double_operand, },
    { register_operand, arith_operand, arith_operand, },
    { register_operand, arith_double_operand, arith_double_operand, },
    { register_operand, arith_operand, arith_operand, },
    { register_operand, register_operand, arith_operand, },
    { register_operand, register_operand, register_operand, },
    { register_operand, register_operand, small_int, },
    { register_operand, register_operand, arith_operand, },
    { register_operand, register_operand, register_operand, },
    { register_operand, register_operand, register_operand, },
    { register_operand, register_operand, uns_arith_operand, },
    { register_operand, register_operand, register_operand, },
    { register_operand, register_operand, uns_small_int, },
    { register_operand, register_operand, uns_arith_operand, },
    { register_operand, register_operand, register_operand, },
    { register_operand, register_operand, uns_small_int, },
    { register_operand, register_operand, arith_operand, scratch_operand, },
    { register_operand, register_operand, arith_double_operand, },
    { register_operand, register_operand, arith_operand, scratch_operand, },
    { register_operand, register_operand, arith_operand, },
    { register_operand, register_operand, arith_double_operand, },
    { register_operand, register_operand, arith_operand, },
    { register_operand, arith_double_operand, arith_double_operand, },
    { register_operand, arith_double_operand, arith_double_operand, },
    { register_operand, arith_double_operand, arith_double_operand, },
    { register_operand, arith_operand, arith_operand, },
    { 0, 0, 0, 0, },
    { register_operand, register_operand, register_operand, },
    { register_operand, register_operand, register_operand, },
    { register_operand, register_operand, register_operand, },
    { register_operand, arith_double_operand, arith_double_operand, },
    { register_operand, arith_double_operand, arith_double_operand, },
    { register_operand, arith_double_operand, arith_double_operand, },
    { register_operand, arith_operand, arith_operand, },
    { 0, 0, 0, 0, },
    { register_operand, register_operand, register_operand, },
    { register_operand, register_operand, register_operand, },
    { register_operand, register_operand, register_operand, },
    { register_operand, arith_double_operand, arith_double_operand, },
    { register_operand, arith_double_operand, arith_double_operand, },
    { register_operand, arith_double_operand, arith_double_operand, },
    { register_operand, arith_operand, arith_operand, },
    { 0, 0, 0, 0, },
    { 0, 0, 0, 0, },
    { register_operand, register_operand, register_operand, },
    { register_operand, reg_or_0_operand, arith_double_operand, },
    { register_operand, reg_or_0_operand, arith_operand, },
    { arith_operand, arith_operand, cc_arithop, },
    { arith_double_operand, arith_double_operand, cc_arithop, },
    { register_operand, arith_operand, arith_operand, cc_arithop, },
    { register_operand, arith_double_operand, arith_double_operand, cc_arithop, },
    { reg_or_0_operand, arith_operand, },
    { reg_or_0_operand, arith_double_operand, },
    { register_operand, reg_or_0_operand, arith_operand, },
    { register_operand, reg_or_0_operand, arith_double_operand, },
    { arith_operand, reg_or_0_operand, cc_arithopn, },
    { arith_double_operand, reg_or_0_operand, cc_arithopn, },
    { register_operand, arith_operand, reg_or_0_operand, cc_arithopn, },
    { register_operand, arith_double_operand, reg_or_0_operand, cc_arithopn, },
    { register_operand, register_operand, },
    { register_operand, register_operand, },
    { register_operand, register_operand, },
    { general_operand, arith_operand, },
    { arith_operand, },
    { arith_double_operand, },
    { register_operand, arith_operand, },
    { register_operand, arith_double_operand, },
    { register_operand, register_operand, },
    { register_operand, register_operand, },
    { register_operand, arith_double_operand, },
    { register_operand, arith_operand, },
    { arith_operand, },
    { arith_double_operand, },
    { register_operand, arith_operand, },
    { register_operand, arith_double_operand, },
    { register_operand, register_operand, register_operand, },
    { register_operand, register_operand, register_operand, },
    { register_operand, register_operand, register_operand, },
    { register_operand, register_operand, register_operand, },
    { register_operand, register_operand, register_operand, },
    { register_operand, register_operand, register_operand, },
    { register_operand, register_operand, register_operand, },
    { register_operand, register_operand, register_operand, },
    { register_operand, register_operand, register_operand, },
    { register_operand, register_operand, register_operand, },
    { register_operand, register_operand, register_operand, },
    { register_operand, register_operand, register_operand, },
    { register_operand, register_operand, register_operand, },
    { register_operand, register_operand, register_operand, },
    { register_operand, register_operand, },
    { register_operand, register_operand, },
    { register_operand, register_operand, },
    { register_operand, register_operand, },
    { register_operand, register_operand, },
    { register_operand, register_operand, },
    { register_operand, register_operand, },
    { register_operand, register_operand, },
    { register_operand, register_operand, },
    { register_operand, register_operand, arith_operand, },
    { register_operand, register_operand, arith_operand, },
    { register_operand, },
    { register_operand, register_operand, },
    { register_operand, register_operand, arith_operand, },
    { register_operand, register_operand, arith_operand, },
    { register_operand, register_operand, arith_operand, },
    { register_operand, register_operand, arith_operand, },
    { 0 },
    { register_operand, },
    { register_operand, },
    { register_operand, },
    { address_operand, },
    { address_operand, },
    { 0 },
    { 0 },
    { call_operand, 0, 0, 0, },
    { address_operand, 0, },
    { immediate_operand, 0, },
    { address_operand, 0, },
    { immediate_operand, 0, },
    { address_operand, 0, immediate_operand, },
    { immediate_operand, 0, immediate_operand, },
    { register_operand, 0, 0, 0, 0, },
    { 0, address_operand, 0, },
    { 0, immediate_operand, 0, },
    { 0, address_operand, 0, },
    { 0, immediate_operand, 0, },
    { call_operand, memory_operand, 0, },
    { address_operand, memory_operand, 0, },
    { immediate_operand, memory_operand, 0, },
    { address_operand, memory_operand, 0, },
    { immediate_operand, memory_operand, 0, },
    { memory_operand, 0, },
    { register_operand, register_operand, },
    { 0 },
    { 0 },
    { address_operand, },
    { address_operand, },
    { address_operand, },
    { general_operand, general_operand, general_operand, 0, },
    { 0 },
    { 0 },
    { 0, },
    { register_operand, register_operand, scratch_operand, },
    { register_operand, register_operand, scratch_operand, },
    { 0, 0, 0, 0, },
    { 0, 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, 0, },
    { 0, 0, 0, 0, },
    { 0, 0, 0, 0, },
    { 0, 0, 0, 0, },
    { 0, 0, 0, 0, },
    { 0, 0, 0, 0, },
    { 0, 0, 0, 0, },
    { 0, 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { restore_operand, arith_operand, },
    { restore_operand, arith_operand, },
    { restore_operand, arith_operand, },
    { restore_operand, register_operand, },
    { restore_operand, arith_operand, arith_operand, },
    { restore_operand, arith_double_operand, },
    { restore_operand, arith_operand, arith_double_operand, },
    { register_operand, },
    { 0, 0, 0, },
    { 0, 0, },
    { 0, 0, 0, },
    { 0, 0, },
    { 0, 0, },
  };

const int insn_n_alternatives[] =
  {
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    0,
    4,
    1,
    1,
    0,
    4,
    1,
    1,
    0,
    7,
    1,
    0,
    9,
    7,
    3,
    0,
    6,
    3,
    1,
    3,
    0,
    8,
    5,
    0,
    2,
    3,
    0,
    6,
    3,
    2,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    0,
    1,
    0,
    2,
    0,
    2,
    0,
    2,
    0,
    1,
    0,
    2,
    1,
    1,
    1,
    1,
    0,
    1,
    0,
    1,
    0,
    1,
    0,
    1,
    0,
    1,
    0,
    2,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    0,
    0,
    0,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    0,
    0,
    0,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    0,
    1,
    1,
    0,
    1,
    1,
    0,
    1,
    1,
    0,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    0,
    1,
    1,
    1,
    0,
    1,
    1,
    1,
    0,
    1,
    1,
    1,
    0,
    1,
    1,
    1,
    0,
    1,
    1,
    1,
    0,
    0,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    0,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    2,
    2,
    1,
    2,
    2,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    0,
    1,
    1,
    1,
    1,
    1,
    0,
    0,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    0,
    1,
    1,
    1,
    1,
    0,
    1,
    0,
    0,
    1,
    1,
    1,
    0,
    0,
    0,
    0,
    1,
    1,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    0,
    0,
    0,
    0,
    0,
    0,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
  };
